2003-07-01  David Ayers  <d.ayers@inode.at>

	* Headers/gnustep/base/GSObjCRuntime.h/m (GSPrintf),
	* Headers/gnustep/base/NSObjCRuntime.h (GSPrintf),
	* Source/NSLog.m (GSPrintf): Moved implementation from NSLog.m to
	GSObjCRuntime.m and declaration from NSObjCRuntime.h to
	GSObjCRuntime.h.

2003-07-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Flush iconv buffer at end of conversion
	to handle obscure cases where it says it has converted all the input
	sequence, but hasn't written all the output.

2003-06-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Add 'UTF-7' so iconv can be used to
	handle utf7 if available.
	* Tools/AGSParser.m: Don't always strip asterisks from comments,
	Check first line of comment to see if it has one first.

2003-06-28 15:48  Alexander Malmberg <alexander@malmberg.org>

	* Tools/make_strings/StringsFile.h, Tools/make_strings/StringsFile.m,
	Tools/make_strings/make_strings.h, Tools/make_strings/make_strings.m:
	Clean up handling of key matching and ignoring. Add
	--aggressive-remove option.

2003-06-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: Don't NSLog when we can't find a localizable
	file ... log only when bundle debugging is turned on.

2003-06-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPipe.m: Fix descriptor leak ... close on dealloc

2003-06-25  Adam Fedor  <fedor@gnu.org>

	* Tools/gdnc.1.gz: New file (from Martin Brecher).
	* Tools/GNUmakefile (MAN1_PAGES): Install it

2003-06-24  David Ayers  <d.ayers@inode.at>

	* Source/GSFFCallInvocation.m
	(gs_method_for_receiver_and_selector): Replace usage of
	class_get_instance/class_method with GSGetInstance/ClassMethod and
	Method_t with GSMethod.
	(gs_find_by_receiver_best_typed_sel): Ditto.
	(GSInvocationCallback): Ditto.
	([GSFFCallInvocation -invokeWithTarget:]): Ditto.
	* Source/GSFFIInvocation.m
	(gs_method_for_receiver_and_selector): Ditto.
	(gs_find_by_receiver_best_typed_sel): Ditto.
	(GSFFIInvocationCallback): Ditto.
	([GSFFIInvocation -invokeWithTarget:]): Ditto.
	* Source/NSConnection.m
	([NSConnection -_service_typeForSelector:]): Ditto.
	* Source/NSInvocation.m
	([NSInvocation -invokeWithTarget:]): Ditto.
	* Source/NSObject.m
	([NSObject +instanceMethodSignatureForSelector:]): Ditto.
	([NDObject -methodSignatureForSelector:]): Ditto.
	([NSObject +descriptionForInstanceMethod:]): Ditto.
	([NSOnject -descriptionForMethod:]: Ditto.
	* Source/NSProxy.m 
	([NSProxy +methodSignatureForSelector:]): Ditto.
	([NSProxy -methodSignatureForSelector:]): Ditto.
	* Source/NSDistantObject.m
	([NSObject -selectorTypeForProxy:]): Ditto.
	([NSDistantObject +respondsToSelector:]): Ditto. Corrected
	implementation to check class methods instead of instance methods.
	
2003-06-23  Adam Fedor  <fedor@gnu.org>

	* Testing/diningPhilosophers.m: Locking and output fixes (from
	Chris Beaham).
	* Testing/create-abbrevs, Testing/create-regions: Remove.

2003-06-23  Adam Fedor  <fedor@gnu.org>

	* Source/NSProcessInfo.m (+load): use the KVM library where
	available when procfs doesn't work (FreeBSD, others?) (patch from
	Pete French <pete@twisted.org.uk>).

2003-06-21  David Ayers  <d.ayers@inode.at>

	* Headers/gnustep/base/objc-gnu2next.h: Remove simple mappings for
	class_get_class_method they cannot work due to different
	parameter expectations.  Added mapping from NeXT->GNU runtime. 
	The other way does not work.  Added simple mapping for internal
	flush function __objc_update_dispatch_table_for_class and
	_objc_flush_caches.

	* Headers/gnustep/base/GSObjCRuntime.h/m:
	Added typedef for GSMethod.
	(GSGetInstanceMethod): New function.
	(GSGetClassMethod): Ditto.
	(GSGetInstanceMethodNotInherited): Ditto.
	(GSGetClassMethodNotInherited): Ditto.
	(GSFlushMethodCacheForClass): Ditto.
	(flush_method_cache_for_class): Removed function which is replaced
	by GSFlushMethodCacheForClass.
	(GSObjCGetMethod): Removed function which is replaced by
	GSGetInstanceMethod and GSGetClassMethod.
	(GSObjCReplaceMethod): Removed function.

2003-06-21  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Check for libkvm.
	* configure, Headers/gnustep/base/config.h.in: Regen.

2003-06-20  Adam Fedor  <fedor@gnu.org>

	* Documentation/Makefile.postamble (after-clean): Remove Base
	and BaseAdditions

2003-06-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Allow more length when converting unicode
	string to integer.
	* Source/NSObject.m: ([methodSignatureForSelector:]) return nil if
	the receiver does not implement it.

2003-06-20  Adam Fedor  <fedor@gnu.org>

	* Documentation/Makefile.postamble (after-clean): 
	* Version 1.7.1

	* Source/DocMakefile (after-all): Check if Base exists before
	removing it.

2003-06-19  Adam Fedor  <fedor@gnu.org>

	* GNUmakefile (SUBPROJECTS): Revert last change.

2003-06-19  Andrew Ruder <aeruder@yahoo.com>

	* Source/Additions/Unicode.m: Increase size of table by one to
	avoid error if all possible character encodings were supported.
	Never happens ... but might conceivably do so one day.

2003-06-18  Kazunobu Kuriyama  <kazunobu.kuriyama@nifty.com>

	* configure.ac: Add --with--ffcall-include=PATH and
	--with-ffcall-library=PATH options

2003-06-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Implement -description for nodes.

2003-06-17  Adam Fedor  <fedor@gnu.org>

	* GNUmakefile (SUBPROJECTS): Add Documentation

2003-06-17  Chris Vetter <chrisv@web4inc.com>

	* Tools/AGSHtml.m: Tidy up formatting of author output.

2003-06-16 13:36  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSFormat.m (GSFormat()): Free malloc memory in all cases
	after handling %s, %S, %@ with strings longer than 8192 characters.

2003-06-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAutoreleasePool.m: Documented.
	* Headers/gnustep/base/NSObject.h: Documented memory management macros
	for autogsdoc.

2003-06-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Better attempt to infer charset from
	string only when needed.
	Don't insert transer encoding header if not needed.

2003-06-11  Adam Fedor  <fedor@gnu.org>

	* Source/NSNumberFormatter.m
	(-getObjectValue:forString:errorDescription:): Simple
	implementation.

2003-06-08  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSString.m
	In [initWithContentsOfURL:] changed variable test to unichar* to
	keep the compiler quiet.
	* Source/Additions/Unicode.m
	In GSFromUnicode() removed type cast of *_conv_base as the
	gcc 3.3 compiler complained about it.

2003-06-07  David Ayers  <d.ayers@inode.at>

	* Headers/gnustep/base/GSObjCRuntime.h
	* Source/Additions/GSObjCRuntime.m : White space patch to better
	conform with GNU coding standards and improve readability.
	Wrap deprecated API in NO_DEPRICATED macro.

2003-06-06  David Ayers  <d.ayers@inode.at>

	* Source/GSArray.m: Change syntax of include <> to "" for
	local headers. Change base/ to gnustep/base/ in includes.
	Source/GSAttributedString.m, Source/GSCompatibility.m,
	Source/GSCountedSet.m, Source/GSDictionary.m,
	Source/GSFFCallInvocation.m, Source/GSFFIInvocation.m,
	Source/GSFTPURLHandle.m, Source/GSFileHandle.m,
	Source/GSFormat.m, Source/GSHTTPURLHandle.m,
	Source/GSLocale.m, Source/GSSet.m,
	Source/GSString.m, Source/GSTcpPort.m,
	Source/GSTemplateValue.m, Source/GSValue.m,
	Source/NSArchiver.m, Source/NSArray.m,
	Source/NSAssertionHandler.m, Source/NSAttributedString.m,
	Source/NSAutoreleasePool.m, Source/NSBitmapCharSet.m,
	Source/NSBundle.m, Source/NSCalendarDate.m,
	Source/NSCallBacks.h, Source/NSCallBacks.m,
	Source/NSCharacterSet.m, Source/NSClassDescription.m,
	Source/NSCoder.m, Source/NSConcreteNumber.m,
	Source/NSConnection.m, Source/NSCopyObject.m,
	Source/NSCountedSet.m, Source/NSData.m,
	Source/NSDate.m, Source/NSDateFormatter.m,
	Source/NSDebug.m, Source/NSDecimal.m,
	Source/NSDecimalNumber.m, Source/NSDictionary.m,
	Source/NSDistantObject.m, Source/NSDistributedLock.m,
	Source/NSDistributedNotificationCenter.m, Source/NSEnumerator.m,
	Source/NSException.m, Source/NSFileHandle.m,
	Source/NSFileManager.m, Source/NSFormatter.m,
	Source/NSGeometry.m, Source/NSHashTable.m,
	Source/NSHost.m, Source/NSInvocation.m,
	Source/NSKeyValueCoding.m, Source/NSLock.m,
	Source/NSLog.m, Source/NSMapTable.m,
	Source/NSMethodSignature.m, Source/NSNotification.m,
	Source/NSNotificationCenter.m, Source/NSNotificationQueue.m,
	Source/NSNull.m, Source/NSNumber.m,
	Source/NSNumberFormatter.m, Source/NSObjCRuntime.m,
	Source/NSObject.m, Source/NSPage.m,
	Source/NSPipe.m, Source/NSPort.m,
	Source/NSPortCoder.m, Source/NSPortMessage.m,
	Source/NSPortNameServer.m, Source/NSProcessInfo.m,
	Source/NSProtocolChecker.m, Source/NSProxy.m,
	Source/NSRange.m, Source/NSRunLoop.m,
	Source/NSScanner.m, Source/NSSerializer.m,
	Source/NSSet.m, Source/NSSocketPort.m,
	Source/NSString.m, Source/NSTask.m,
	Source/NSThread.m, Source/NSTimeZone.m,
	Source/NSTimer.m, Source/NSURL.m,
	Source/NSURLHandle.m, Source/NSUnarchiver.m,
	Source/NSUndoManager.m, Source/NSUser.m,
	Source/NSUserDefaults.m, Source/NSValue.m,
	Source/NSZone.m, Source/UnixFileHandle.m,
	Source/callframe.h, Source/callframe.m,
	Source/cifframe.h, Source/cifframe.m,
	Source/externs.m, Source/libgnustep-base-entry.m,
	Source/mframe.m, Source/objc-gnu2next.m,
	Source/objc-load.m, Source/preface.m,
	Source/thr-mach.m, Source/thr-pthread.m,
	Source/Additions/GCArray.m, Source/Additions/GCDictionary.m,
	Source/Additions/GCObject.m, Source/Additions/GSCategories.m,
	Source/Additions/GSCompatibility.h, Source/Additions/GSMime.m,
	Source/Additions/GSNextRuntime.m, Source/Additions/GSObjCRuntime.m,
	Source/Additions/GSXML.m, Source/Additions/Unicode.m,
	Source/Additions/behavior.m: Idem.

2003-06-03  Adam Fedor  <fedor@gnu.org>

	* Source/mframe/powerpc/darwin: New file.

2003-06-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/mframe.m: Allow for structure names in type specifications.

2003-05-29  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Pass on original CPPFLAGS to config.mak.
	* config/objc-con-autoload.m4: Test for constructors directly.
	* config/objc-sys-dynamic.m4: Check for dl lib if we are using dladdr.

	* Source/objc-load.m (objc_get_uninstalled_dtable): Remove unused.

	* Source/Additions/GSXML.m (unparsedEntityDeclFunction): Add block
	around START so it will compile on GCC 2.

	* Testing/nsbundle.m: Errors to stdout.

2003-05-26  Adam Fedor  <fedor@gnu.org>

	* Testing/Makefile.postamble (check): Define to run all
	checkable tools (ones that exit in a finite amount of time).
	* Testing/README: New.

2003-05-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Some work towards making it possible to
	subclass GSTreeSAXHandler cleanly, so you can build a tree
	representation of a document but still handle data incrementally.

2003-05-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: ([GSXPathContext-evaluateExpression:])
	Test for NULL return from libxml and return nil rather than trying
	to dereference the null pointer.
	New features to record error and warning messages added.
	* Headers/Foundation/GSXML.h: ([GSXMLParser-messages]) returns saved
	messages. ([GSXMLParser-saveMessages:]) Says whether to save messages
	or write to stderr.
	* Source/Additions/GSObjCRuntime.m: Hack to fix type clash in
	declaration of __objc_exec_class()

2003-05-19  Adam Fedor  <fedor@gnu.org>

	* Version 1.7.0.
	* Documentation/news.texi: Updated.

	* NSObject: Revert last change

2003-05-20  David Ayers <d.ayers@inode.at>

	* Headers/gnustep/base/GSObjCRuntime.h (GSObjCGetMethod(),
	GSObjCReplaceMethod()):  Removed declarations for release as these
	functions will be replaced by a more consistent approach.
	
2003-05-19  Adam Fedor  <fedor@gnu.org>

	* Source/NSObject (GSAtExit): New function.
	(+initialize): Use it with atexit.

	* Source/objc-load.m (objc_invalidate_dtable): Remove.
	(objc_load_callback): Don't call it.

2003-05-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDate.m: Documented.

2003-05-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Fix occasional error unfolding
	headers.

2003-05-14 16:50  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSUser.m, Headers/gnustep/base/NSPathUtilities.h: Add
	GSApplicationSupportDirectory constant for
	NSSearchPathForDirectoriesInDomains.

2003-05-14  David Ayers  <d.ayers@inode.at>

	* Tools/Makefile.postamble: Added safe handling of empty
	MAN1_PAGES variable.
	* Tools/pl2link.m (main): Initialize variable to supress
	compiler warning.
	
2003-05-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Tools/gdnc.m: Tidy termination code.
	* Source/Additions/GSMime.m: ([GSMimeDocument-copyWithZone:])
	corrected implementation to do a real copy rather than just a
	retain.

2003-05-13 15:57  Alexander Malmberg <alexander@malmberg.org>

	* Tools/gdnc.m (ihandler): Declare variables.

2003-05-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: New -escapedContent method to provide
	text with the five entities libxml automatically substitutes even
	when told not to.
	* Tools/AGSHtml.m: Use -escapedContent to get text suitable for
	output in html documents.

2003-05-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.8.gz: Added man page adapted from internal docs by
	martin@mb-itconsulting.com
	* Tools/GNUmakefile: Declare man pages to be installed
	* Tools/Makefile.postamble: Install man pages

2003-05-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/xmlparse.m: new utility to parse/validate xml, for testing
	gsdoc and new style property lists etc.
	* Source/NSBundle.m: ([+allBundles]) Make sure the main bundle is
	present.  Add some documentation.

2003-05-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: ([-initWithCStringNocopy:length:freeWhenDone:])
	check encodings and convert to unicode if necessary. Thanks to
	Alaxander for pointing out bug.

2003-05-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Fix call to GSFormat() to append to a mutable
	string whose contents should not be freed.
	Removed bogus TODO comments saying code broken when defEnc!=intEnc
	in routines which should never be called when defEnc!=intEnc anyway.
	* Source/NSData.m: Remove windows specific code for simplification
	as the standard code actually works as well or better according to
	<Roland.Schwingel@onevision.de>
	* Tools/AGSParser.m: Ignore forward declarations of protocols.

2003-05-05 15:28  Alexander Malmberg <alexander@malmberg.org>

	* Source/Unicode.m (GSFromUnicode, GSToUnicode): Make sure the
	internal work buffer isn't returned to the caller.

	* Source/NSString.m: Clarify some comments, and mark code that is
	broken when defEnc!=intEnc.

	(fillHole, makeHole): Remove STABLE_MEMCPY. Use memmove.

	(transmute): Set the zone to the default zone when transmuting.
	Check the return value from GSToUnicode.

	(getCharacters_c): Check the return value from GSToUnicode.

2003-05-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpPort.m: ([dispatch]) catch exceptions handling the port
	message, so as to ensure that locking won't get out of sync.

Mon Apr 28 12:09:44 BST 2003  Nicola Pero  <nicola@brainstorm.co.uk>

	* NSCharacterSets/GNUmakefile (base-resources_RESOURCE_FILES_INSTALL_DIR): 
	Define using the full relative path.
	* Resources/GNUmakefile (base-resources_RESOURCE_FILES_INSTALL_DIR): Idem.
	
2003-04-27  Adam Fedor  <fedor@gnu.org>

	* Updates for filesystem change.
	* GNUmakefile (GNUSTEP_MAKEFILES): Remove
	* Documentation/GNUmakefile, Examples/GNUmakefile,
	NSTimeZones/GNUmakefile, SSL/GNUmakefile, SSL/configure.ac,
	Source/DocMakefile, Source/GNUmakefile,
	Source/Additions/GNUmakefile, Testing/GNUmakefile,
	Tools/GNUmakefile: Idem.
	* configure.ac: Replace $GNUSTEP_SYSTEM_ROOT/Makefiles with
	$GNUSTEP_MAKEFILES.  Replace Libraries with Library/Libraries.
	Replace Headers with Library/Headers.
	* Source/mframe/configure.ac: Idem.
	* NSCharacterSets/GNUmakefile: Use resource-set.make.
	* Resources/GNUmakefile: Idem.
	* Resources/GNUmakefile.postamble: Remove before/after install cmds.

	* Source/NSBundle (+pathForLibraryResource:ofType:inDirectory:): 
	New method.
	(+pathForGNUstepResource:...): Depreciate.
	* Source/Additions/GSXML.m: Use it to find DTDs.

	* Source/GSLocale.m (GSLanguageFromLocale): Use +bundleForLibrary
	to locate resources.
	* Source/NSCharacterSet.m (+_bitmapForSet:number:): Idem.
	* Source/NSUserDefaults.m (+standardUserDefaults): Idem.
	* Source/Additions/Unicode.m (GSEncodingFromLocale): Idem.
	* Source/NSTimeZone.m (_time_zone_path): New function.
	(+systemTimeZone, +getAbbreviationFile, +getRegionsFile,
	+getTimeZoneFile): Use it.

	* Source/NSUser.m (NSSearchPathForDirectoriesInDomains): Change
	libsDir to "Library/Libraries", docDir to "Library/Documentation".

	* Source/Additions/GSCompatibility.[hm]: Change 
	+pathForGNUstepResource:...  to +pathForLibraryResource:...

2003-04-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: ([synchronize]) fix locking to permit
	recursive call to this method, ensuring the distributed lock is
	only obtained once.
	* Headers/gnustep/base/GSCategories.h: removed varargs helper macros
	* Headers/gnustep/base/GSObjCRuntime.h: and put them here.

2003-04-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSCategories.h:
	* Headers/gnustep/base/NSCalendarDate.h:
	* Headers/gnustep/base/NSData.h:
	* Headers/gnustep/base/NSObject.h:
	* Headers/gnustep/base/NSString.h:
	* Headers/gnustep/base/NSValue.h:
	* Headers/gnustep/base/Foundation.h:
	Tidied use of GSCategories.
	* Source/NSFileManager.m: ([linkPath:toPath:handler:]) implemented.

2003-04-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSUserDefaults.h: remove timer ivar, now unused.
	* Source/NSRunLoop.m: Support a housekeeping timer which is ignored
	for purposes of deciding whether the loop shoiuld terminate.
	* Source/NSThread.m: Set up housekeeping timer to trigger housekeeping
	notifications in the default mode of the runloop of the main thread.
	* Source/NSUserDefaults.m: Use housekeeping notifications to trigger
	synchronise rather than using timers ... avoid circular dependencies.
	Thanks to Derek Zhou for bug report.

2003-04-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: Experimantal disable ReadFile and WriteFile on MINGW

2003-04-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObjCRuntime.m: NSClassFromString(), NSSelectorFromString()
	avoid doing an unnecessary autorelease.

2003-04-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/callframe.m:
	* Source/cifframe.m:
	Fix error in returning pointer to struct values.

2003-04-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: ([_service_forwardForProxy:]) don't free the
	decoded selector name ... the NSPortCoder now does it.
	([typeForSelector:]) return autoreleased copy of the type string.

2003-04-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/callframe.m:
	* Source/cifframe.m:
	Fix error in returning data via pointer arguments ... was writing to
	wrong memory location.
	* Source/GSFFCallInvocation.m: minor tidy up.
	* Source/NSArchiver.m: Structure encoding/decoding fixes.
	* Source/NSData.m: Structure encoding/decoding fixes.
	* Source/NSPortCoder.m: Structure encoding/decoding fixes.
	Manage memory used by decoded pointers (including c-strings).
	* Source/NSUnarchiver.m: Structure encoding/decoding fixes.
	* Source/NSConnectiom.m: Don't try to autorelease decoded pointers.
	* Testing/server.h: Make large structure have tricky layout.
	* Testing/nsconnection_client.m: Add harder structure test.
	* Testing/nsconnection_server.m: Add harder structure test.

2003-04-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpPort.m:
	* Source/NSData.m:
	* Source/NSSerializer.m:
	* Source/NSURL.m:
	Replace __alignof__() with calls to objc_alignof_type() so that if
	__alignof__() is broken we can hope that the objc runtime library
	has a workaround.

2003-04-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/Foundation.h: Include GNUstep extensions
	from GSCategories.h

2003-04-08 15:37  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSCalendarDate.m (-initWithString:calendarFormat:locale:):
	Fix assignment of 'found' in %z handling.

2003-04-07 13:21  Alexander Malmberg <alexander@malmberg.org>

	* configure.ac:	Link directly to the foreign function interfaces
	section in the build guide in the error message for missing ffi
	library.

	* configure: Regenerate.

2003-04-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSCategories.h (GS_USEIDLIST and
	GS_USEIDPAIRLIST): Complete implementation and testing.
	* Source/NSDictionary.m: Use macro.

2003-04-06 23:30  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/base/GSCategories.h (GS_USEIDLIST): Make the
	implementation match the actual use in NSArray and NSSet. Clarify
	documentation.

2003-04-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: (GSPerformHolder) execute perform operations
	in the same order in which they were submitted.
	* Headers/GNUstep/base/GSCategories.h: Added two new macros to
	agressively optimise the use of varargs when initialising arrays
	etc by avoiding multiple allocation/reallocation of memory to hold
	arrays of objects taken from the varargs list.
	* Source/NSArray.m: Use the new macros.

2003-04-04  Stephane Corthesy <stephane@sente.ch>

	* macosx/config.h, macosx/preface.h: Update.
	* macosx/gnustep.pbproj/project/pbxproj: Use relative paths.

2003-04-04  Adam Fedor  <fedor@gnu.org>

	* Source/Additions/GSCompatibility.m ([NSString(GSCompatibility)
	-substringFromRange:]): Add.

2003-04-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSInvocation: Added NS_INVOCATION asnd NS_MESSAGE
	* Source/NSInvocation.m: Support the two new macros. Documented.
	* Testing/nsinvocation.m: Trivial tests added.
        * Documentation/OpenStepCompliance.gsdoc: Updated.
	* Source/NSConnection.m: ([-forwardInvocation:forProxy:]) set
	invocation target explicitly, in case this was called as a result
	of a manual setup of the invocation rather than real forwarding.

2003-04-03  Adam Fedor  <fedor@gnu.org>

	* Documentation/OpenStepCompliance.gsdoc: New file.
	* Documentation/Base.gsdoc: Reference it.
	* Source/DocMakefile: Update.

2003-04-02  Stephane Corthesy <stephane@sente.ch>

	* Source/Additions/GSCompatibility.m: Fix up incorrectly applied 
	patch.
	* Source/Additions/Unicode.m (GSEncodingName): Don't define if
	NeXT_Foundation_Library.

2003-04-02  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/Foundation.h: Revert previous change

2003-04-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: ([-content]) fix to produce string
	content of elements rather than just text nodes.
	* Source/GSMime.m: ([-rawMimeData]) ensure that the transfer encoding
	of a multipart document is 8bit if any of its constituent parts are
	8bit or binary

22003-04-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m: ([initWithString:calendarFormat:locale:])
	add support for %F millisecond initialisation.
	make trivial simplification of timezone handling.
	on failure to parse zone using %z, use local time zone.

2003-03-31  Stephane Corthesy <stephane@sente.ch>

	* Source/Additions/GCArray.m: Replace retain/release by 
	RETAIN/RELEASE macros.
	* Source/Additions/GCDictionary.m: Idem.

	* Source/Additions/GSCompatibility.h: Add NSBundle category.
	* Source/Additions/GSCompatibility.m (GSEncodingName): New.
	Add -[NSBundle pathForGNUstepResource:ofType:inDirectory:].

	* Source/Additions/GSObjCRuntime.m: Include GNUstep.h.
	(GSObjCMethodNames): Cast method_name to const char *.

2003-03-31  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/Foundation.h: Add GSCategories.h

2003-03-30  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSString.h: (stringByTrimmingLeadSpaces,
	stringByTrimmingTailSpaces, stringByTrimmingSpaces, 
	stringByReplacingString:withString:, replaceString:withString:,
	trimLeadSpaces, trimTailSpaces, trimSpaces): Move to GSCategories.h
	* Headers/gnustep/base/NSValue.h (valueFromString): Idem.
	* Source/NSNumber.m (valueFromString:): Move to GSCategories.m
	* Source/NSString.m: Idem as above.
	* Source/Additions/GSCategories.m: Methods moved here.
	* Source/Additions/GSCompatibility.h: Rearrange, add
	NSDistantObject, NSFileHandle category, GSCurrentThreadDictionary().
	* Source/Additions/GSCompatibility.m: Add GSCurrentThreadDictionary
	NSDistantObject, and NSFileHandle methods.

2003-03-28 20:48  Alexander Malmberg <alexander@malmberg.org>

	* configure.ac: Fail the configure if neither ffcall nor ffi is
	available unless --disable-do is passed to configure. Add a message
	about why a user most likely does not want to build with ffcall and
	ffi, and with a link to the build guide.

	* configure: Regenerate.

2003-03-27  Adam Fedor  <fedor@gnu.org>

	* Source/NSBundle.m ([NSBundle -bundleIdentifier]): New.

2003-03-27  Stephane Corthesy <stephane@sente.ch>

	* Tools/autogsdoc.m, AGSHtml.m, AGSIndex.m, AGSOutput.m: Add
	MacOSX compatibility headers.
	* Tools/AGSParser.m: Idem.
	(-log:arguments:): Replace strinWithFormat:arguments: with
	initWithFormat:arguments:

2003-03-26  David Ayers  <d.ayers@inode.at>

	* Source/NSKeyValueCoding.m: Added documentation. 
	* Source/NSKeyValueCoding.m ([NSObject -takeValue:forKey:]),
	([NSObject -valueForKey:]): Corrected search order of instance
	variables.

2003-03-25  Stephane Corthesy <stephane@sente.ch>

	* macosx: New directory holding MacOSX project for building 
	Additions framework.

2003-03-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m: When loading a resource and attempting to notify
	a client, check that the client responds to the selectors before
	sending messages to it.
	Make ([-loadResourceDataNotifyingClient:usingCache:]) work in
	background (non-blocking).
	
2003-03-25  David Ayers  <d.ayers@inode.at>

	* Headers/gnustep/base/GSObjCRuntime.h
	* Source/Additions/GSObjCRuntime.m (GSObjCGetMethod),
	(GSObjCReplaceMethod): Added new functions. 
	* Source/Additions/GSObjCRuntime.m (search_for_method_in_class):
	Renamed static function for NeXT runtime to better reflect
	reality.
	(GSObjCAddMethods): Updated usage.
	(search_for_method_in_class): New static function for GNU runtime.
	(flush_method_cache_for_class): New static function.
	* Headers/gnustep/base/GSCategories.h: Included necessary headers.

2003-03-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Completed merge of changes from 1.6.0 branch.

2003-03-17  Adam Fedor  <fedor@gnu.org>

	* Version 1.6.0

2003-03-17  Adam Fedor  <fedor@gnu.org>

	* Testing/LoadMe.m (afterLoad): Use description, not name.
	* Testing/nsfilemanager.m: Print some output. Clean up.
	* Testing/scanner.m, nstimezone.m, release.m: Idem.

	* config/config.vsprintf, config/config.vasprintf: Rewrite to
	properly call a variable argument function.

2003-03-14  Adam Fedor  <fedor@Eldorado.local.>

	* Testing/nsarray.m (compare): Un-nest function.

	* Source/NSProcessInfo.m (-operatingSystem): Add darwin. 

2003-03-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: ([-isDeletableFileAtPath:]) Fix for the
	case where the path is a file in the current directory.

2003-03-11  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Fix some typos (Reported by
	Alexander Malmberg <alexander@malmberg.org>).

2003-03-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSSet.h: Added a few non-openstep declarations
	* Source/GSCompatibility.m: OAppend() sort dictionary keys even if
	locale is nil.

2003-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: Fix reference to zone of deallocated object.
	Bug reported by Roland Schwingel
	* Source/NSFileManager.m: Fix typo (using logical or rather than
	bitwise or) in call to access()
	Bug reported by Roland Schwingel

2003-02-17    <woudshoo@agilisys.com>

	* GNUmakefile (GNUSTEP_TARGET_INSTALL_PREFIX)
	(GNUSTEP_TARGET_LOCAL_ROOT, GNUSTEP_TARGET_NETWORK_ROOT): On
	mingw32 replace / with \\057 to avoid the msys shell translating /
	with \.

2003-03-04  Richard Frith-Macdonald <rfm@gnu.org>

	* config/config.vasprintf.c:
	* config/config.vsprintf.c: Correct the number of arguments passed
	so that modern compilers don't fail on these files.  A compiler
	failure is seen by configure as the same as a runtime failure, and
	configure would infer incorrect runtime behavior!

2003-03-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSerializer.m: Fix crash when deserializing a corrupt or
	truncated archive ... raise exception rather than segfaulting.
	Added code to recognize newer versions of the serialiser format and
	give up if they are encountered and cannot be handled.
	* Source/GSTcpPort.m: Added code to recognise newer versions of the
	port format and give up if they are encountered and cannot be handled.
	This allows for the addition of decent versioning in later formats.

2003-02-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Fix to understand __attribute__() in declaration.

2003-02-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSIndex.m: Convert nil content to empty strings before use.
	* Tools/AGSHtml.m: ditto ... prevent some crashes.

2003-02-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProcessInfo.m (_gnu_process_args): Tidied patch and add
	code to print error and abort if argv is null under unixy systems.

2003-02-24  Tom Koelman <tkoelman@xs4all.nl>

	* Source/NSProcessInfo.m (_gnu_process_args): If argv is 0 (e.g.
	on MingW) set executable name using module name info.

2003-02-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: Don't prepend HOMEDRIVE to HOMEPATH if HOMEPATH
	already contains a drive letter.

2003-02-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSObjCRuntime.m: GSObjCSetValue() correct to call
	([unableToSetNilForKey:]) when it should.
	* Source/NSDecimalNumber.m: Override initialisers from NSNumber to
	create NSDecimalNumber objects ... bug report by David Ayers.

2003-02-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedNotificationCenter.m: ([_connect]) make the
	connection to the server usable from any thread.

2003-02-19  Adam Fedor  <fedor@gnu.org>

	* Source/NSKeyValueCoding.m ([NSObject -handleQueryWithUnboundKey:]): 
	Raise NSUnknownKeyException.
	([NSObject -handleTakeValue:forUnboundKey:]): Idem.

2003-02-18  Adam Fedor  <fedor@gnu.org>

	* Source/GSFFIInvocation.m (GSFFIInvocationCallback): Cast
	invocation to access ivars correctly. Check validReturn.

2003-02-18  Tom Koelman <tkoelman@xs4all.nl>

	* Source/NSProcessInfo.m (_gnu_process_args): If argv is 0 (e.g.
	on MingW) set executable name to empty string.

2003-02-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: (fillHole) fix memory overrun (read only) and
	argument order errors (in code not normally compiled) spotted by
	Manuel Guesdon.


2003-03-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Start merged of changes from 1.6.0 branch.


2003-03-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSMime.m: (_unfoldHeader) Check that input pointer doesn't
	run past end of data.

2003-03-05 15:50  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSBundle.m (+initialize) [PROCFS_EXE_LINK]: Make sure that
	the link is a path before using it.

2003-03-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h: Added some trivial reverse
	mappings to use gnu runtime from old next code.

2003-03-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSObjCRuntime.h:
	* Source/GSFFIInvocation.m:
	* Source/GSString.m:
	* Source/NSInvocation.m:
	* Source/NSObject.m:
	* Source/NSPortCoder.m:
	* Source/NSUnarchiver.m:
	* Source/Additions/GSObjCRuntime.m:
	* Source/Additions/Unicode.m:
	Rename _fastMallocBuffer() to GSAutoreleasedBuffer() for clarity
	and consistency.  Moved implementation from NSObject.m to
	GSObjCRuntime.m so this is available for use withing the Additions
	library when built standalone.
	Add a couple of trivial functions to list ivars and methods.

2003-02-19  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Headers/gnustep/base/NSArray.h: fixed declarations.

2003-02-19  David Ayers  <d.ayers@inode.at>

	* Source/NSArray.m (compare()),
	([-sortedArrayUsingFunction:context:]),
	([-sortedArrayUsingFunction:context:hint:]),
	([-sortUsingFunction:context:]):  Changed declarations
	and implementation to account for 64 bit architectures.
	* Headers/gnustep/base/NSArray.h: Ditto.
	* Source/NSKeyValueCoding.m ([-takeStoredValuesFromDictionary:]):
	Implemented.
	* Headers/gnustep/base/NSKeyValueCoding.h: Ditto.
	
2003-02-18  Richard Frith-Macdonald <rfm@gnu.org>

	* NSObject.m: ([+instancesRespondToSelector:]),([-respondsToSelector])
	Return NO when given a null selector unless in MacOS-X compatibility
	mode.  rewritten from patch by Willem Rein Oudshoorn.

2003-02-16  Adam Fedor  <fedor@gnu.org>

	* Version 1.5.2
	* Documentation: Update.

	* Source/GSFFIInvocation.m (GSFFIInvocationCallback): Autorelease
	and invalidate the return value object before returning.

2003-02-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSDictionary.m: ([-isEqualToDictionary:]) implement optimised
	version which does not need to create a key enumerator.
	* Source/GSArray.m: ditto
	* Source/GSSet.m: similar minor optimisations.

2003-02-15 15:53  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSRunLoop.m (-performSelector:target:argument:order:modes:):
	Order the performers correctly (lower order values first). Correct
	the documentation.

2003-02-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimeZone.m: Fix memory leak when making absolute
	timezone for offset 0.

2003-02-11  Tom Koelman <tkoelman@xs4all.nl>

	* Source/NSTask.m: Make arguments into windows quoted strings for
	mingw.  Adjustments to conform to GNUstep style and use static
	functions to avoid adding methods by RFM.

2003-02-11  Adam Fedor  <fedor@gnu.org>

	* configure (LDFLAGS): Remove extra spaces that cause problems
	on Darwin/gcc

i2003-02-11  Willem Rein Oudshoorn  <woudshoo@xs4all.nl>

	* Headers/Foundation/NSFileManager.h: Added a little bit to the
	* documentation of the NSFileManagerHandler protocol.
	(some documentation markup fixes by RFM also)
	* Source/NSFileManager.m ([NSFileManager -copyPath:toPath:handler:]): 
	use new private methods to cope with handlers that do not implement
	the informal protocol.  Pass more information to the handler in case
	of an error.
	([NSFileManager -removeFileAtPath:handler:]):  see above
	([NSFileManager -movePath:toPath:handler:]): see above
	([NSFileManager -_copyPath:toPath:handler:]): see above
	([NSFileManager -_copyFile:toFile:handler:]): see above, also fixed
	leaking of file descriptors in case of error without a handler.
	([NSFileManager -_sendToHandler:handlerwillProcessPath:path]):
	new method
	([NSFileManager -_proceedAccordingToHandler:handlerforError:
	errorinPath:path]): new method
	([NSFileManager -_proceedAccordingToHandler:handlerforError:
	errorinPath:pathfromPath:fromPathtoPath:toPath]): new method

2003-02-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: ([+attributesAt:traverseLink:]) check for
	null pointer and return nil.  Crash reported by Tom Koelman.

2003-02-10 13:56  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSRunLoop.m [HAVE_POLL] (-pollUntil:within:): Set fdEnd
	to pollfds_count instead of setting it separately (which was being
	done incorrectly).

2003-02-07 19:21  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSAttributedString (-setAttributes:range:): Fix memory
	leak.

2003-02-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Sourcewin32-def.top: Remove recently added external functions.
	* Source/libgnustep-base.def.in: Regenerated to just contain
	public classes.  The manual hacks are no longer needed as the
	make system now handles inclusion of symbols from subprojects
	in dlls.

2003-02-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Sourcewin32-def.top: Manually added external functions.
	* Source/libgnustep-base.def.in: Regenerated to combine external
	functions and all public classes.
	* Source/NSConnection.m: ([-init]) creates a connection usable as
	a server.

2003-02-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: Implement new MacOS-X isLoaded method.
	* Headers/gnustep/base/NSBundle.h: ditto

2003-02-04  Willem Rein Oudshoorn  <woudshoo@xs4all.nl>

	* Headers/gnustep/base/GSInvocation.h (CLEAR_RETURN_VALUE_IF_OBJECT):
	* New macro, if invocation returns object release it.
	(RETAIN_RETURN_VALUE): New macro, if invocation returns object
	release it.
	* Source/NSInvocation.m ([NSInvocation -dealloc]): Implement RELEASE
	* return object
	([NSInvocation -setReturnValue:]) Implement RETAIN/RELEASE on return
	object ([NSInvocation -invokeWithTarget:]): Implement RETAIN/RELEASE
	on return object,
	fixed  _validReturn flag setting
	* Source/GSFFIInvocation.m ([GSFFIInvocation -invokeWithTarget:]): 
	Fix _validReturn flag setting, Implement RETAIN/RELEASE on return
	object.
	* Source/GSFFCallInvocation.m ([GSFFCallInvocation
	* -invokeWithTarget:]): 
	Fix _validReturn flag setting.  Implement RETAIN/RELEASE on return
	object.

2003-02-04  Adam Fedor  <fedor@Eldorado.local.>

	* Headers/gnustep/base/.cvsignore: Don't include config.h.in
	* Documentation/.cvsignore: Don't include *texi
	* Source/Additions/GSXML.h: Fix up GSXLM.h include on MacOSX

2003-02-02  Stephane Corthesy <stephane@sente.ch>
	    Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/GSObjCRuntime.h (GS_STATIC_INLINE): Rename
	from FOUNDATION_STATIC_INLINE
	* Headers/gnustep/base/GCObject.h, GSXML.h: include 
	Foundation/Foundation.h	on MacOSX.
	* Source/Additions/GCArray.m, GCDictionary.m, GCObject.m: Idem.
	* Source/Additions/GSCompatibility.[hm]: Change category names to
	GSCompatibility.
	* Source/Additions/GSNextRuntime.m (ROUND): Expand inline due to
	gcc 3.1 compile problems.
	* Source/Additions/Unicode.m: Don't define GetEncodingName on MacOSX
	Added #ifdef HAVE_ICONV around definition of iconv_stringforencoding().

2003-02-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Fix error in check for legality of
	three-byte utf-8 sequences.

2003-01-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: Fix memory leak with timed performs.

2003-01-31  Stephane Corthesy <stephane@sente.ch>
	    Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/GSCategories.h: Moved
	NSString(GSCategories), NSMutableString(GSCategories), and copied
	NSObject(GSCategories) to here
	* Headers/gnustep/base/NSString.h, Headers/gnustep/base/NSObject:
	From here.
	* Headers/gnustep/base/GSMime.h: Include Foundation on MacOSX.

	* Source/Additions/GSCategories.m: Fix includes.
	* Source/Additions/GSCompatibility.h: Defined DebugLog, WarnLog 
	macros. Add Additional NSObject, NSInvocation, NSString and
	NSProcessInfo methods. Add NSStandardLibraryPaths.
	* Source/Additions/GSCompatibility.m: Idem.

2003-01-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/libgnustep-base.def.in: Regenerated

2003-01-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Fixed bug in utf-8 output for three
	byte sequences.
	* Tools/AGSOutput.m: Fix loss of trailing info after a closing
	square bracket round a class name.
	* Source/Additions/GCArray.m: make mutable copy shallow for
	consistency with other arrays.

2003-01-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Added new MacOS-X method ...
	([MSMutableString-replaceOccurrencesOfString:withString:options:range:])
	* Source/Headers/gnustep/base/NSString.h: ditto
	* Source/Additions/GSCategories.m: Added
	([NSData-initWithHexadecimalRepresentation:])
	* Source/Headers/gnustep/base/GSCategories.h: ditto

2003-01-26  Adam Fedor  <fedor@gnu.org>

	* Compiling gdl2 on MacOSX.
	* Headers/gnustep/base/NSObject.h (-notImplemented:,
	-subclassResponsibility:, -shouldNotImplement:, -compare:): Move
	to GSCategories category.
	* Headers/gnustep/base/NSString.h (-stringByDeletingPrefix:,
	-stringByDeletingSuffix:, -deleteSuffix:, -deletePrefix:): Idem.
	* Source/NSObject: Move methods to Additions/GSCategories.m
	* Source/NSString: Idem.

	* Source/Additions/GSCompatibility.h (GetEncodingName): Add.
	* Source/Additions/GSCompatibility.m (GetEncodingName): Cocoa
	implementation.

2003-01-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSCategories.m: Changed name of md5 digest method
	and added -hexadecimalRepresentation.
	* Source/Additions/GSMime.m: Update for md5 change.
	* Documentation/GNUmakefile: Fixed error in installation location.
	* Documentation/Makefile.postamble: Fixed to install BaseAdditions
	documentation.
	* Source/md5.c: Tidy up ... removed ... no longer used
	* Source/md5.h: ditto
	* Source/numbers.c: ditto
	* Headers/gnustep/base/numbers.h: ditto

2003-01-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/Base.gsdoc: Refer to additions.
	* Documentation/BaseAdditions.gsdoc: New intorduction for additions
	* Headers/gnustep/base/GSCategories.h: Added MD5Digest NSData method
	* Source/DocMakefile: Build additions documentation separately
	* Source/Additions/GSCategories.m: Added MD5Digest NSData method
	* Source/Additions/GSMime.m: Use MD5Digest NSData method.

2003-01-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: ifdefed out my last change ...not sure
	it was good.
	* Source/GSFileHandle.m: Removed bogus semicolon which was causing
	code to be executed repeatedly rather than just once ... trivial
	optimisation.

2003-01-21  Adam Fedor  <fedor@gnu.org>

	* Source/Additions/(GCArray.m, GCDictionary.m, GCObject.m, 
	GSCategories.m): Include config.h
	* Source/Additions/GSMime.m: Add extra arg to some NSDebugMLog to
	get it to compile right on OSX.

2003-01-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/unicode/latin9.h: Latin9 string encoding tables
	* Source/Additions/Unicode.m: Added built-in support for the Latin9
	character encoding ... contains the Euro symbol ... nice for
	european users.
	* Source/NSArray.m: Make abstract copying implementation like that
	of latest MacOS-X rather than OPENSTEP ... no relationship between
	mutability and depth.
	* Source/NSDictionary.m: ditto
	* Source/NSSet.m: ditto
	* Source/GSArray.m: Implement optimised copies ... copying an immutable
	object just retains it, and copying a mutable object is shallow.
	* Source/GSDictionary.m: ditto
	* Source/GSSet.m: ditto

2003-01-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m: Support MacOS-X style initialisation using a path
	with a leading slash.

2003-01-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSCategories.m: Additional ([weekOfYear]) method
	for NSCalendarDate.
	* Headers/gnustep/base/GSCategories.h: ditto

2003-01-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLock.m:
	* Source/NSPage.m:
	Mingw fixes ... problems reported by Fred.

2003-01-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConcreteNumber.m: ([compare:]) explicitly cast to promote
	values to a type where comparisons can be done without loss of
	precision.

2003-01-03  Richard Frith-Macdonald <rfm@gnu.org>

	* base.make.in:
	* configure:
	* configure.ac:
	* Headers/gnustep/base/GSIArray.h:
	* Headers/gnustep/base/GSIMap.h:
	* Headers/gnustep/base/NSGeometry.h:
	* Headers/gnustep/base/NSInvocation.h:
	* Source/GSArray.m:
	* Source/GSAttributedString.m:
	* Source/GSCompatibility.m:
	* Source/GSCountedSet.m:
	* Source/GSDictionary.m:
	* Source/GSFFCallInvocation.m:
	* Source/GSFTPURLHandle.m:
	* Source/GSFileHandle.m:
	* Source/GSFormat.m:
	* Source/GSString.m:
	* Source/GSTcpPort.m:
	* Source/GSTemplateValue.m:
	* Source/NSArray.m:
	* Source/NSAutoreleasePool.m:
	* Source/NSBundle.m:
	* Source/NSCalendarDate.m:
	* Source/NSConcreteNumber.m:
	* Source/NSCountedSet.m:
	* Source/NSData.m:
	* Source/NSDebug.m:
	* Source/NSInvocation.m:
	* Source/NSLog.m:
	* Source/NSMethodSignature.m:
	* Source/NSNotificationCenter.m:
	* Source/NSObject.m:
	* Source/NSPortCoder.m:
	* Source/NSRunLoop.m:
	* Source/NSScanner.m:
	* Source/NSSerializer.m:
	* Source/NSString.m:
	* Source/NSTimeZone.m:
	* Source/NSUnarchiver.m:
	* Source/mframe.m:
	* Source/Additions/GSMime.m:
	* Source/Additions/GSXML.m:
	* Tools/AGSOutput.m:
	* Tools/AGSParser.m:
	* Tools/defaults.m:
	* Tools/gdomap.c:
	* Tools/pl2link.m:
	* Tools/sfparse.m:
	* Tools/make_strings/StringsFile.m:
	Tweaks for warning free compilation with gcc-3.4 ... many comparisons
	os signed and un signed values avoided etc.

2003-01-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.m: Don't try to make a type reference to the
	superclass of NSObject.

2002-12-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPage.m: Document all functions.

2002-12-31  Kelvin  <kelvin@xbar.org>

	* Source/NSPage.m (NSRealMemoryAvailable): Add support for MINGW
	and BeOS.

2002-12-31  Richard Frith-Macdonald <rfm@gnu.org>

	*  Source/GSEQ.h: Optimisations for normalising sequences, especially
	where they contain latin1 characters.
	* Source/Additions/GCDictionary.m: Update map tables for macosx
	* Source/NSMapTable.m: Update for macosx compatibility, add some
	documentation and move stuff from externs.m
	* Source/NSHashTable.m: Update for macosx compatibility, add some
	documentation and move stuff from externs.m
	* Source/externs.m: Remove map and hash table stuff
	* Source/NSException.m: Fix documentation cross ref error.
	* Source/NSAssertion.m: Improve documentation.
	* Headers/gnustep/base/NSException.h: Include assertion documentation.
	* Headers/gnustep/base/NSMapTable.h: Update for macosx compatibility.
	* Headers/gnustep/base/NSHashTable.h: Ditto
	* Tools/AGSHtml.m: Fix typo ... excess semicolon in constant output.
	* Tools/AGSParser.m: Fix error failing to find comment for constants.
	* Source/NSObjCRuntime.m: Document functions.

2002-12-30  Adam Fedor  <fedor@gnu.org>

	* SSL/GNUmakefile: Don't compile if base=no

	* Tools/AGSIndex.h: Include gnustep/base/GSXML.h.
	* Tools/AGSHtml.m: Include GNUstep.h
	* Tools/AGSInde.m, Tools/AGSOutput.m, Tools/AGSParser.m,
	Tools/HTMLLinker.m: Idem.
	* Tools/GNUmakegile: Only compile autogsdoc when add=yes
	* Tools/Makefile.preamble: Include -lgnustep-baseadd when add=yes

Mon Dec 30 18:19:55 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* configure.ac: Recognize apple OBJC_RUNTIME_LIB.
	* configure: Regenerated.
	* Makefile.postamble: Updated check for gnu FOUNDATION_LIB.
	* Source/Makefile.preamble (libgnustep-baseadd_LIBRARIES_DEPEND_UPON): 
	Do not add -framework Foundation on Apple, it's added automatically
	by gnustep-make.
	* Source/GNUmakefile: Updated check for OBJC_RUNTIME_LIB.
	* Source/Additions/GNUmakefile: Updated checks for
	OBJC_RUNTIME_LIB and FOUNDATION_LIB.
	
2002-12-28  Kelvin  <kelvin@xbar.org>

	* Source/NSPage.m: Add BeOS support.
	* Source/NSProcessInfo.m ([NSProcessInfo -operatingSystem]): Idem
	(Also added solaris (fedor@gnu.org)).

2002-12-24  Richard Frith-Macdonald <rfm@gnu.org>

	*  Source/Additions/Unicode.m: Tidied and optimised binary searches.

2002-12-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Fix bug handling repeated opeing braces.

2002-12-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSIndex.m: Fix error indexing vararg methods.
	* Source/Additions/Unicode.m: Added home-brewed support for UTF8 to
	avoid use of iconv where not necessary.q  Hope the code is OK :-)

2002-12-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSDistributedNotificationCenter.h: add type
	for LAN-wide notifications.  Add ivar to support this.
	* Source/NSDistributedNotificationCenter.m: Implement support for
	a LAN-wide notification center.  Fully document class.
	* Tools/gdnc.m: Add new GSNetwork flag to operate as LAN-wide
	notification center.
	* Tools/AGSHtml.m: Don't output contents section if there is
	nothing to show (ie must have at least two sections to index).
	* Source/NSConnection.m: Add locks to protect proxy cache in timeout.

2002-12-10  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Enable libffi on darwin by default.

2002-12-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: ([removeObjectsFromIndices:numIndices:])
	bugfix for sorting by Kelvin Sherlock.
	* Source/NSConnection.m: Experimental code to keep local objects
	retained long enough to deal with most cases where the remote
	process may want them again.
	* Source/NSHost.m: Don't cache local host name ... it may change
	due to use of DHCP etc.

2002-12-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Fix race condition firing perform holder.
	Fix supplied by Philip Derrin.

2002-12-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Fix uninitialised local variable 'locale'
	which was causing a crash ... not 100% sure my fix is making the code
	work as intended.  Could Adam please check it?

2002-12-04  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/GSLocale.h: Add category arg to
	SetLocale functions.
	* Source/GSLocale.m (GSSetLocaleC, GSSetLocale): Update for change.
	* Source/NSObject.m (+initialize): Idem.
	* Source/NSUserDefaults.m ([NSUserDefaults +standardUserDefaults]):
	Idem.

2002-12-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSerializer.m: bugfix deserialisation ... was trying to	
	read size of date/number when these values were not being serialized.

2002-12-03  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSBundle.m ([NSBundle +initialize]): check for linked
	framework in two passes, first collect all the framework classes, then
	add it. The previous routine failed to add all the frameworks.

2002-12-02  Adam Fedor  <fedor@gnu.org>

	* Port baseadd to MacOSX.
	* Makefile.postamble (header-links): Don't link gnustep/gui to 
	Foundation for FOUNDATION_LIB=nx
	* Headers/gnustep/base/NSObjCRuntime.h (FOUNDATION_EXPORT): Define
	only if not defined already.
	* Headers/gnustep/base/objc-gnu2next.h: Define _CLS_META, _CLS_CLASS
	* Source/Makefile.preamble (libgnustep-baseadd_LIBRARIES_DEPEND_UPON):
	Depend on framework Foudation if FOUNDATION_LIB=nx
	* Source/objc-gnu2next.m: Move most functions...
	* Source/Additions/GSNextRuntime.m: ...to here.
	* Source/Additions/GSCompatibility.[hm]: New files.
	* Source/Additions/GCDictionary.m: Include it.
	* Source/Additions/GSMime.m: Idem.
	* Source/Additions/GSXML.m: Idem.
	* Source/Additions/GCObject.m: Idem. Null out mutex code
	on NeXT_RUNTIME (Need a better fix).
	* Source/Additions/GNUmakefile: Don't compile Unicode.m
	on FOUNDATION_LIB=nx (not ported yet).
	* Source/Additions/GSObjCRuntime.m (GSObjCAddClasses): Version
	for NeXT_RUNTIME.
	(GSObjCAddClassBehavior): Fixes for NeXT_RUNTIME.
	* Source/Additions/behavior.m (behavior_class_add_class): Idem.

2002-12-02  Jonathan Gapen  <jagapen@wisc.edu>

	* Headers/gnustep/base/NSPort.h: Add NSSocketPort interface.
	* Source/NSSocketPort.m: New file. New MacOS X class partially
	implemented; serves as BSD socket wrapper.

2002-12-02  Adam Fedor  <fedor@gnu.org>

	* base.make.in (CONFIG_SYSTEM_LIBS): Set only if shared=no.
	* config.make.in (CONFIG_SYSTEM_LIBS): Set only if shared=yes.
	* Source/Makefile.preamble (libgnustep-base_LIBRARIES_DEPEND_UPON):
	Depend on $(CONFIG_SYSTEM_LIBS) if shared=yes.

2002-11-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/plparse.m: Stefan Urbaneks patch to return 1 on failure.
	* Tools/sfparse.m: Similar code for this tool.
	* Source/Additions/GSObjCRuntime.m: Tidied function names
	* Headers/gnustep/base/GSObjCRuntime.h: ditto.
	* Source/NSKeyValueCoding.m: Use new function names.

2002-11-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Fix so we document static declarations made in
	headers and only ignore them in implementation.
	* Tools/AGSOutput.m: Bugfix to output ivar type information.
	* Tools/AGSHtml.m: Reduce space around examples.
	Bugs reported by Chris B. Vetter
	* Source/Additions/GSObjCRuntime.m: Tidied function name conventions.
	* Headers/gnustep/base/GSObjCRuntime.h: ditto.
	* Source/NSKeyValueCoding.m: Use new function names.
	* Source/mframe.m: When scanning arguments, skip type information
	for things poionted to by a pointer - more efficient than scanning
	the fine structure and then throwing away the scanned information.
	* Source/additions/GSMime.m: Fill in 'type' field in multipart/related
	and fix bug in seaarch by content id.  Also minor consistency change
	to API.

2002-11-27  Manuel Guesdon <mguesdon@orange-concept.com>

	* Source/Additions/GSObjCRuntime.m: fixed type call typo 
	in GSFindInstanceVariable
	
2002-11-27  Adam Fedor  <fedor@gnu.org>

	* configure.ac (INCLUDE_FLAGS): New for holding flags needed for
	compiling base.
	* config.make.in (CONFIG_SYSTEM_INCL): Use it.
	* base.make (CONFIG_SYSTEM_INCL): Remove CPPFLAGS
	(CONFIG_SYSTEM_DEFS): Remove.
	* Source/Additions/GNUmakefile: include config.mak

2002-11-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSObjCRuntime.m: New file with GNUstep extensions
	from NSObjCRuntime, plus renamed behavior functions, plus a few other
	runtime manipulation functions. EXPERIMENTAL
	* Headers/gnustep/base/GSObjCRuntime.h: declarations for above.
	* Source/GSCompatibility.m: Don't use new format plists when writing
	descriptions.
	Also, honor NSWriteOldStylePropertyLists user default to write old
	style property-lists rather than new style or xml style.
	* Source/NSUser.m: Use USERPROFILE for default home directory on
	windoze.
	* Source/NSArray.m: Write non-xml property lists as ascii.
	* Source/NSDictionary.m: Write non-xml property lists as ascii.
	* Source/mframe.m: use objc_alignof_type() as suggested by Roland
	Schwingel.  Long ago the objc runtime version was buggy so mframe
	implemented its own algorithm.  Now the objc runtime one is better.

2002-11-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GCObject.m: Attempt to make garbage collecting
	thread-safe.
	* Source/Additions/GCArray.m: Fix count initialising mutable array.
	* Source/Additions/GSMime.m: Provide a method to generate and return
	a string suitable for use as a boundary.  Make tolerant of multipart
	messages with 'application' as the message type.
	Added ([-setBuggyQuotes:]) method for parsing stuff produced by
	microsoft ;-(

2002-11-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Treat '-' on its own as an argument
	rather than the start of a flag name.
	* Source/Additions/GSMime.m: Place angle brackets around generated
	content ID. Add method to generate message ID.  Tidy comments a
	little.

2002-11-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/libgnustep-base.def: Add garbage collecting classes.

2002-11-20  Adam Fedor  <fedor@gnu.org>

	* Source/NSBundle.m (+preferredLocalizationsFromArray:forPreferences:): 
	Check for array with no objects.
	([NSBundle -localizedInfoDictionary]): Idem.

2002-11-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/Unicode.m: Work around bug in the redhat 8 iconv
	library ... was sucessfully opening the encoding "" when it shouldn't.

2002-11-19  Adam Fedor  <fedor@gnu.org>

	* Version: 1.5.1
	* Documentation/news.texi: Updated.

2002-11-19  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSBundle.h: More documentation. Add missing
	MacOSX methods.
	* Source/NSBundle.m (-executablePath): New
	(-load): Use it.
	(+pathsForResourcesOfType:inDirectory:): New stub.
	(-pathsForResourcesOfType:inDirectory:forLocalization:): Idem.
	(-pathForResource:ofType:inDirectory:forLocalization:): Idem.
	(+preferredLocalizationsFromArray:): New method.
	(+preferredLocalizationsFromArray:forPreferences:): Idem.
	(-localizedInfoDictionary): Idem.
	(-localizations): Idem.
	(-preferredLocalizations): Idem.

	* Source/cifframe.m (cifframe_from_info): Fix so that stucture
	returns get space allocated.

2002-11-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/behavior.m: Moved to Source/Additions/behavior.m
	* Source/Unicode.m: Moved to Source/Additions/Unicode.m
	* Source/Additions/GCObject.m: new experimental GC class.
	* Source/Additions/GCArray.m: ditto
	* Source/Additions/GCDictionary.m: ditto
	* Headers/gnustep/base/GCObject.h: Garbage collection classes intended
	for use by gdl2 and gsweb.

2002-11-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSCompatibility.m: Fix for case where a non property list	
	object is found when outputting a description.

2002-11-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Fix for getting integer, float and bool
	values when they are stored as NSNumbers (problem reported by
	Ludovic Marcotte).  Also optimise a little.

2002-11-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Port pipe to mingw.
	* Tools/gdomap.c: Fix for modern mingw interface lookup.
	Patch by Tom Koelman

2002-11-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Try again ... get
	([-setVolatileDomain:forName:]) and ([-setPersistentDomain:forName:])
	to conform to both the OpenStep standard and the current MacOS-X
	documentation.

2002-11-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: adocument property list stuff.
	* Source/NSUserDefaults.m: set integers, floats and bools as NSNumber
	Bugfix ([-setVolatileDomain:forName:]) was checking wrong list of
	domains.  Tidied.

2002-11-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSObject.h: Removed GNUstep plist extensions.
	* Source/NSObject.m: ditto.
	* Source/GSCompatibility.m: Implement new plist generator.
	* Source/NSArray.m: Use new plist code
	* Source/NSData.m: ditto
	* Source/NSDictionary.m: ditto
	* Source/NSSerializer.m: handle NSNumber and NSDate
	* Source/NSString.m: ditto, plus implement extensions to old plist
	support so we can encode NSNumber and NSDate values.
	Remove GNUstep property list extensions from the api ... make more
	like MacOS and OpenStep spec by having a central mechanism for
	generating property lists rather than spreading the code across the
	plist classes.
	Also ... maintain allocation debug accounting when making objects
	immutable.

2002-11-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: use NSString implementation of
	([descriptionWithLocale:indent:to:])
	* Source/NSUserDefaults.m: ([setObject:forKey:]) validate and raise
	exceptions if given bad info.

2002-11-07 02:21  Alexander Malmberg <alexander@malmberg.org>

	* Source/GSString.m: (-makeImmutableCopyOnFail:): Set isa to correct
	class.

2002-11-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: Ensured some documentation in place for almost all
	methods.
	* Source/Additions/GSMime.m: Fix broken method reference.
	* Source/Additions/GSXML.m: ditto
	* Source/NSScanner.m: ditto
	* Source/NSUnarchiver.m: ditto
	* Tools/AGSIndex.m: Minor fix for superclass reference lookup.
	* Tools/AGSHtml.m: ditto

2002-11-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: Revert to remove unneeded notification setup.
	* Source/NSThread.m: Rewrite pierres changes, scrapping all
	conditionally compiled code that would never be used, rewriting
	unix specific stuff (so it might run under windoze ... not yet tested)
	removed unnecessary code and simplified, etc etc.
	Fixed bugs in usage of condition locks so it actually works.
	* Testing/thread.m: New test to try out
	performSelectorOnMainThread:withObject:waitUntilDone:modes:

2002-11-02  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/NSRunLoop.m ([NSRunLoop -init]): ask to be informed about
	NSWillBecomeMultiThreadedNotification if _willBecomeMultiThreaded:
	method existes.
	* Source/NSRunLoop.m: new GSAppKitInterThreadRunLoopWatcher private
	class.
	([NSRunLoop -_willBecomeMultiThreaded:]): new method, sets up the 
	lock, the socket and new run loop watcher that'll listen on the socket.
	[NSObject -performSelectorOnMainThread:withObject:waitUntilDone:modes:]):
	modified to use the previous changes.

2002-11-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSBundle.h: Tidied/corrected documentation
	markup.
	* Headers/gnustep/base/NSDate.h: Added NSTimeIntervalSince1970 and
	removed GSTimeNow() from public API.
	* Source/NSDate.m: Update to use NSTimeIntervalSince1970
	* Source/NSTimer.m: Declare GSTimeNow() locally
	* Source/NSprocessInfo.m: ditto
	* Source/Additions/GSMime.m: more tolerant parsing ... ignore excess
	data in multi-part document.
 
Thu Oct 31 00:46:23 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/base/NSBundle.h: Added more documentation.

Wed Oct 30 23:42:50 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSBundle.m ([+_addFrameworkFromClass:]): New code
	locating linked frameworks magically - no matter where they are on
	disk - by using objc_get_symbol_path().  If that fails or is not
	available, fall back on the existing code.  Fixed NSLog() message.

2002-10-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSThread.m: Implemented and documented new MacOS-X methods -
	([-performSelectorOnMainThread:withObject:waitUntilDone:modes:])
	and ([-performSelectorOnMainThread:withObject:waitUntilDone:])

Wed Oct 30 03:14:34 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/base/objc-load.h: Added copyright notice.
	(objc_get_symbol_path): Declare to take a Category *, not a struct
	objc_category *, argument; documented.
	* Source/objc-load.m: Include config.h first.  Define _GNU_SOURCE
	if HAVE_DLADDR is defined.
	(objc_get_symbol_path): Fixed crash with classes or categories
	with long names.  Updated declaration.
	* config/objc-sys-dynamic.m4 (OBJC_SYS_DYNAMIC_LINKER): Print a
	message displaying the type of dynamic linker found.  Add -ldl on
	the link line for linux-gnu and other systems, so that dladdr() is
	actually found.  With the 'simple' linker, print a message saying
	if we found dladdr() or not.
	(OBJC_SYS_DYNAMIC): Historical unused macro removed.
	* configure: Regenerated.

2002-10-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: include statvfs.h if available.

2002-10-26  Adam Fedor  <fedor@gnu.org>

	* Source/NSException.m: Document.
	* Source/NSFileHandle.m: Partial Documentation.
	* Source/NSObject.m: Fix typo in docs.

2002-10-25  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSBundle.m ([NSBundle -load]): set _codeLoaded before loading
	the bundle.

2002-10-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Avoid duplication of method comments when
	parsing the same file as both header and source.

2002-10-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSOutput.m: ([-split:]) In links generated from class and
	method specifications in square brackets, place a space between the
	class and the method name.
	* Tools/gsdoc-1_0_0.dtd: Corrected minor entity errors.

2002-10-21  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/unicode/thai.h: New file.
	* Headers/gnustep/base/NSString.h (_NSStringEncoding): Add
	NSISOThaiStringEncoding.
	* Source/NSString.m (-dataUsingEncoding:allowLossyConversion:): 
	Handle it.
	* Source/Unicode.m (struct _strenc_ str_encoding_table[]): Idem. 
	(GSEncodingForRegistry): Idem.
	(GSToUnicode, GSFromUnicode): Idem.
	(Patches, modified, from Banlu Kemiyatorn <id@project-ile.net>).

2002-10-21  Adam Fedor  <fedor@gnu.org>

	* Source/GSLocale.m (GSLanguageFromLocale): Implement regardless
	of HAVE_LOCALE_H.

	* Source/Unicode.m (GSEncodingForRegistry): New (from
	[GSFontInfo +encodingForRegistry:encoding:]).
	(GSEncodingFromLocale): New.
	(GetDefEncoding): Rearrange encoding check.
	* Resources/Languages/Locale.encodings: New file.

2002-10-21  Adam Fedor  <fedor@gnu.org>

	* Documentation/coding-standards.texi: Update.

2002-10-14  Richard Frith-Macdonald <rfm@gnu.org>

	Source/NSObject.m: Add ([-makeImmutableCopyOnFail:]) for use by methods
	wishing to return constant string/array/dictionary etc results after
	building them using mutable objects they created.
	Source/GSArray.m: Implement ([makeImmutableCopyOnFail:])
	Source/GSString.m: ditto
	Source/GSDictionary.m: ditto
	Source/GSSet.m: ditto
	Source/NSFileManager.m: Use it

2002-10-13  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSBundle.m ([NSBundle +_addFrameworkFromClass:]): remove
	the classes in the _loadingBundle that does not belong to it but with
	frameworks linked with it.
	([NSBundle +bundleForClass:]): construct a list of NSFramework_*
	classes loaded with the bundle.
	([NSBundle -load]): call _addFrameworkFromClass: for all linked
	frameworks with the bundle.

2002-10-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.m: Create automatic references to protocols in
	type specifications of the form (id<protocol1,protocol2,...>)
	* Tools/autogsdoc.m: Add -Files option to read names of files
	to process as a property list rather than using command line args.
	Add -Clean flag to remove generated output files and purge
	generated data from templates.  Add -CleanTemplates to completely
	temove template files.
	* Tools/AGSParser.m: Warn about private methods and ivars.

2002-10-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProcessInfo.m: Make safe to reinitialise with args.
	* Source/Additions/GSXML.m: Correct handling of atttribute values.
	* Tools/autogsdoc.m: Initialise NSProcessInfo explicitly.

2002-10-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: ([-initWithContentsOfFile:]) check to see
	if the file is writable and the directory exists.
	If we can't operate properly, run in read-only ,mode where we try
	to read the file if possible, but never write defaults back.

2002-10-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: ([-synchronize]) handle locking more
	carefully ... avoid cpu intensive busy loops and give up after
	a while.

2002-10-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLog.m: Added GSPrintf()
	* Tools/defaults.m: Use GSPrintf()
	* Tools/pldes.m: ditto
	* Tools/plser.m: ditto
	* Tools/plmerge.m: ditto
	* Tools/plparse.m: ditto
	* Tools/sfparse.m: ditto
	* Documentation/Base.gsdoc: Bump gsdoc version to 1.0.0
	* Documentation/Functions.gsdoc: ditto
	* Documentation/TypesAndConstants.gsdoc: ditto
	* Source/NSLog.m: Fix typo in comment.
	* Tools/AGSOutput.m: Bump gsdoc version to 1.0.0
	* Tools/GNUmakefile: Add gsdoc 1.0.0 dtd
	* Tools/autogsdoc.m: Bump gsdoc version to 1.0.0
	* Tools/gsdoc-0_6_7.dtd: Revert to earlier version
	* Tools/gsdoc-1_0_0.dtd: New from latest update to 0.6.7
	I think the documentation dtd is pretty complete now.

2002-10-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/GNUmakefile: revert ... can't build if base library isn't
	installed.

2002-10-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLog.m: Lots of documentation added.
	* Tools/GNUmakefile: build autogsdoc documentation automatically
	if possible.
	* Tools/AGSOutput.m: Make automatic cross references for functions.
	* Source/Docmakefile: Use handcrafted template files.  Document the
	path utilities file.
	* Documentation/Functions.gsdoc: Handcrafted template.
	* Documentation/TypesAndConstants.gsdoc: Handcrafted template.

2002-10-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSDebug.h: Make warn logs de-selectable at
	runtime by setting the NoWarn debug level.  Document.  Say that
	debug levels can be added by putting them in the GNU-Debug
	array in the defaults database.
	* Source/NSUserDefaults.m: Add contents of the GNU-Debug array to
	the set of active debug levels.
	* Tools/AGSParser.m: Updated with support for documenting macros.
	* Tools/AGSOutput.m: ditto
	* Tools/AGSHtml.m: ditto

2002-10-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: Update logging after checks for results of memory
	allocation.
	* Source/NSTimeZone.m: Don't abort on failure to allocate memory ...
	just print a log and continue returning a null pointer.

2002-10-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: readContentsOfFile() fix use of atomic memory
	on GC systems ... problem noticed by Fred.

Sat Oct  5 19:53:03 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSData.m ([NSDataMappedFile
	-initWithContentsOfMappedFile:]): release self and return nil -
	rather than returning NO, if the path is bad.

2002-10-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSOutput.m: Improve warning code, support text output
	in chapter/section/subsection.
	* Tools/AGSParser.m: move concatenation of comments into a single
	method, make it insert a linebreak between concatenated comments,
	and make it refrain from appending the same comment onto itsself
	(which would happen if the same file was parsed twice, as both a
	header and as source).
	Treat the 'main()' function specially ... don't document it as a
	function but insert its comments at the end of the 'chapter' part
	of the output document.  These modifications make it easy to
	document a directory containing tools, by listing the tool source
	files as arguments to autogsdoc.
	Tools/gsdoc_0_6_7.dtd: Fix bug preventing use of text in a chapter!
	* Source/GSString.m: Implement -UTF8String method for better
	performance.
	* Source/NSPortNameServer.m: Improve diagnostic message in exception
	when reporting failure to register ... try to provide all the info
	needed to begin diagnosing any problem.
	* Tools/gdomap.c: Make -M flag work with -N.  Make -M flag work when
	used after -N or -L.  Improve diagnostic messages on failure so
	people know what it is trying to do.

2002-10-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: Tidied init from file to ensure that everything
	is released properly on failure, and we don't generate log messages
	where a lower level API should be doing it.  Added some documentation.
	* Source/NSDictionary.m: ditto
	* Source/NSString.m: ditto.  Also add support for understanding the
	unicode BOM at the start of UTF8 data and stripping it.
	* Source/NSData.m: Tidied read from and write to file,
	adding lots of logging information.  Also documented quite a bit.
	Resolved all conflicts found with Adam's change ... generally in
	favor of the most informative logging.
	* Source/NSPortNameServer.m: On failure to register name, make
	exception message provide lots of detail/advice for newbies.

2002-10-03  Adam Fedor  <fedor@gnu.org>

	* Source/NSData.m (readContentsOfFile): Change NSDebugLog(s) to
	NSWarnLog or NSLog.
	(-writeToFile:atomically:): Idem.
	([NSDataMappedFile -initWithContentsOfMappedFile:]): Idem.
	* Source/NSDictionary.m ([NSDictionary -initWithContentsOfFile:]):
	Release ourselves and return nil if file cannot be read.

2002-10-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: ([-runMode:beforeDate:]) permit the use of a
	nil date and document it.  This is the behavior MacOS seems to have
	and seems to be more useful than prohibiting nil dates.

2002-10-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedLock.m: Document and tidy.
	* Source/NSTimeZone.m: Don't set system zone prematurely.
	* Source/NSString.m: Don't bother to cache constant string
	class.  Document it.

2002-10-01  Adam Fedor  <fedor@gnu.org>

	* config/pathxml.m4: Filter -L/usr/lib out of XML_LIBS.
	* configure: Regenerate.

2002-10-01 02:21  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSUserDefaults.m (-synchronize): Handle lockDate being nil.

2002-09-30  Richard Frith-Macdonald <rfm@gnu.org>

	* NSTimeZones/NSTimeZones.tar: Updated to latest information.
	* Source/NSCalendarDate.m: Tidy up a little.
	* Source/NSTimeZone.m: Rewrite main timezone code for performance -
	Roughly doubles speed of most NSCalendarDate stuff.
	* NSThread.m: Fix for single threaded operation ... suggested by
	Ludovic Marcotte.

2002-09-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFileHandle.m: Encapsulate read and write operations in
	new low level methods to ease subclassing.
	* SSL/GSSSLHandle.m: Use new read and write methods to simplify. 

2002-09-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m: Fix problem with signed/unsigned type
	conversion when initialising a date at a daylight savings time
	boundary, and attempt to improve the code for adding offsets to
	dates.
	* Source/Makefile.postamble: patch to fix some warnings in
	uninstall (by David Ayers).

2002-09-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpPort.m: ([GSTcphandle+initialize]) ignore SIGPIPE in
	case a socket gets closed while we are writing.

2002-09-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Fix typo.

Thu Sep 26 01:28:33 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Tools/make_strings/GNUmakefile: Do not include ctool.make.

2002-09-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Added ([-previousElement]) to match the
	[(-nextElement]) method.

Wed Sep 25 02:46:28 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Tools/make_strings/make_strings.m (main): Remove "" languages
	from the list of languages before processing.

2002-09-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpHandle.m: ([-handleForPort:beforeDate:]) fix bug where
	we could end up using the last (non-matching) handle rather than
	creating a new one.

2002-09-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpHandle.m: ([-connectToPort:beforeDate:]) Added more
	informative logging for problem condition reported by Nicila ...
	perhaps it will help tracking down cause.

2002-09-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFormat.m: Where a %p format prints a null pointer,
	print the text (null).
	* Source/GSTcpHandle.m: Check port for invalidation while looping
	on write events, so we can fail if we become invalid while sending
	or connecting, before the port timeout expires.
	* Source/NSConnection.m: Check connection for invalidation while
	looping waiting for a reply, so we can fail if we become invalid
	before the timeout expires.
	* Source/DocMakefile: Specify template options
	* Tools/autogsdoc.m: Remove hack to turn templates on by default.
	Document the use of templates.
	* Tools/gsdoc-0_6_7.dtd: Hack in more types for indexing ... don't
	know if the software works for them though.

2002-09-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Restructure conversion from unicode slightly,
	to make it clearer and more readable and to include handling of
	lossy conversions.
	* Headers/gnustep/unicode/gsm0338.h: Added table for lossy conversion
	from unicode.

2002-09-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Bugfix ... look for source files more
	intelligently. Try both current directory and relative to header.
	* Tools/AGSOutput.m: When creating template output file for functions
	etc because none was supplied, take account of the -Up flag and
	create an up link in it.
	* Source/GSHTTPURLHandle.m: If response parsing fails, fail the
	load operation and (conditionally when debug enabled) log an error.

2002-09-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Basic/dummy implementations of new MacOS-X
	methods added. Attribute handling totally rewritten to work in a lazy
	way ... so we only set up attribute info in the dictionary when we
	actually need it.  Account 'Number' methods and dictionary keys changed
	to be account 'ID' instead ... in accordance with MacOS-X usage.
	Documented the class.
	* Source/NSData.m: ([-writeToFile:atomically:]) implement workaround
	for bug in windoze implementation of rename()
	* Source/NSString.m: Remove some redundant code duplicating stuff in
	GSMime.m

2002-09-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: MacOS-X ([componentsToDisplayForPath:]) and
	([displayNameAtPath:]) methods implemented.  Creation date added.
	* Source/NSString.m: More alterations to GNUstep extension methods
	to make their names consistent with other methods.
	Q. Should we deprecate/remove them entirely?
	* Tools/gsdoc.m: Update for changes to extension methods... though
	this tool has been deprecated for some time now, so perhaps we
	should remove it?

2002-09-13  Adam Fedor  <fedor@gnu.org>

	* Source/cifframe.m (cifframe_guess_struct_size): Recurse if
	element contains structures.
	(cifframe_from_info): Alloc room for return value even if caller
	doesn't use it.

Thu Sep 12 11:02:03 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSObject.m ([+_becomeMultiThreaded:]): Fixed typo - this
	method was declared to take a 'NSNotification' rather than a
	'NSNotification *' argument.

2002-09-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSLocale.m: Double locking check fix
	* Source/NSFileManager.m: Double locking check fix
	Fixes contributed by David Ayers <d.ayers@inode.at>

2002-09-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSIArray.h: Minor optimisation
	* Headers/gnustep/unicode/gsm0338.h: Correct unicode to gsm table
	* Source/Unicode.m: Correct gsm conversion and optimise unicode to
	8-bit charaacter conversion for other character sets. Also correct
	lossy/non-lossy conversion using iconv.

2002-08-30  Adam Fedor  <fedor@gnu.org>

	* Version: 1.5.0

2002-08-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Implemented new MacOS-X methods -
	([-stringByPaddingToLength:withString:startingAtIndex:]), and
	([-stringByTrimmingCharactersInSet:])
	Tidied a couple of extension method names for consistency and
	documented several methods.

2002-08-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Get libxml to put filename in error
	messages when it is available.

2002-08-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Rewritten the way that iconv is used to decide
	upon the available encodings ... lazy evaluation so that we don't
	try to lookup an encoding until we have to.  This should improve
	process startup time (especially in gdb) since the iconv operations
	seem to be very slow.

2002-08-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Integrated GSXPath code by Nicola Pero
	provides an API to use the xpath support built into libxml from
	version 2.3 onwards.
	* Source/NSThread.m: Implement new priority methods.
	* Source/NSObject.m: Raise exception when passed null selector.

2002-08-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: ([-writeToFile:atomically:]) Removed bogus line
	which deleted files when it shouldn't.
	Added new MacOS-X methods supporting NSData objects where the bytes
	are not owned by the data object.  Removed GNUstep extension which
	provided this functionality before.
	* Source/NSUserDefaults.m: Use distributed lock to ensure that there
	is no possible window when the defaults file is invalid ... not all
	systems guarantee that the rename() system call is atomic.
	* Source/NSArray.m: New MacOS-X methods ([-initWithArray:copyItems:])
	([-exchangeObjectAtIndex:withObjectAtIndex:])
	* Source/NSTimer.m: Update for compatibility with latest MacOS-X
	* Source/NSObject.m: New ([+isSubclassOfClass:]) and perform
	cancellation from MacOS-X
	* Source/NSRunloop.m: New perform cancellation method from MacOS-X
	proofreading help/fixes from David Ayers.
 
2002-08-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/WindowsFileHandle.m: Removed ... no longer used.
	* Source/GSHTTPURLHandle.m: Don't use getpid() ... not portable.
	* Tools/gdomap.c: Don't use getuid() under windoze. 

2002-08-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m: ([-initFileURLWithPath:]) check to see if path is
	a directory and append a trailing slash if necessary.  Remove hack
	to refrain from stripping last patch component in file URLs.

2002-08-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m: Hacks for compatibility with MacOS-X in returning
	path of a file URL ... the RFC says we should only return a path
	for a generic URL (scheme://user:passwd@host:port/path#frag?query)
	which a file URL certainly isn't.  However, for compatibility we
	now treat a file URL more like a generic one.
	Also when creating absolute file URLs from base plus relative,
	the MacOS-X code doesn't strip the last path component of the
	base URL as it should ... we emulate that too.

2002-08-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Fix typo ... missing closing brace under
	windoze. Reported by Alex Stockdale.

2002-08-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: ([-replacementObjectForPortCoder:])
	Documented method and removed unused/unwanted code dealing with
	NSDistantObject (NSDistantObject overrides the method).

2002-08-20  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSObject.m: Fix silly typo.

2002-08-20  Alexander Malmberg <alexander@malmberg.org>

	* Source/NSConnection.m: (-removeProxy:) Remove unbalanced release.

2002-08-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSCountedSet.m:
	* Source/GSFileHandle.m:
	* Source/NSArchiver.m:
	* Source/NSData.m:
	* Source/NSDistributedNotificationCenter.m:
	* Source/NSHashTable.m:
	* Source/NSMapTable.m:
	* Source/NSObjCRuntime.m:
	* Source/NSObject.m:
	* Source/NSPortCoder.m:
	* Source/NSScanner.m:
	* Source/NSString.m:
	* Source/Unicode.m:
	* Source/UnixFileHandle.m:
	* Source/WindowsFileHandle.m:
	* Source/callframe.m:
	* Source/cifframe.m:
	* Source/mframe.m:
	Fix trivial typos and spelling errors pointed out by David Ayers.

2002-08-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSCountedSet.m:
	* Source/NSAutoreleasePool.m:
	* Source/NSCharacterSet.m:
	* Source/NSCountedSet.m:
	* Source/NSData.m:
	* Source/NSDebug.m:
	* Source/NSDictionary.m:
	* Source/NSFileHandle.m:
	* Source/NSLock.m:
	* Source/NSNull.m:
	* Source/NSNumber.m:
	* Source/NSObject.m:
	* Source/NSPipe.m:
	* Source/NSScanner.m:
	* Source/NSSerializer.m:
	* Source/NSSet.m:
	* Source/NSString.m:
	* Source/NSThread.m:
	* Source/NSTimeZone.m:
	* Source/Additions/GSMime.m:
	* Headers/gnustep/base/NSBundle.h:
	* Headers/gnustep/base/NSRange.h:
	* Headers/gnustep/base/NSSet.h:
	Modify comments to include gsdoc documentation for autogsdoc.
	This completes the transfer of all gsdoc documentation into
	the source code.
	* Documentation/gsdoc:  All obsolete files removed.

2002-08-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProxy.m: Documented all methods and corrected implementation
	of some introspection methods.

2002-08-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Base.gsdoc: Moved to Documentation.
	* Source/GNUmakefile: Removed documentation building code.
	* Source/DocMakefile: New file for building refetrence documentation.
	* Documentation/Base.gsdoc: New from source directory.
	* Documentation/GNUmakefile: Set up installation directory name.
	* Documentation/Makefile.postamble: Use ../Source/DocMakefile to build
	library reference documentation and deal with installation.

2002-08-15  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Add NetBSD header/ldflag support (Patch from
	Peter Cooper).

	* Headers/gnustep/base/GNUstep.h: New compatibility file.

2002-08-15  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/GNUmakefile: Added -lgnustep-base and -lobjc to SSL_BUNDLE_LIBS
	So that bundle is linked with a dependency on these libraries ... to
	ensure that dynamic linkage works when the bundle is loaded in from
	java via jigs.

2002-08-15  Adam Fedor  <fedor@gnu.org>

	* SSL/configure.ac: Simplified check for libraries. Added socket
	lib check for Solaris.

	* Headers/gnustep/base/NSDecimalNumber.h: Add NSNumber category
	for decimalValue.
	* Source/NSDecimalNumber.m ([NSNumber -decimalValue]): Implemented.

2002-08-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Allow 'true' as boolean value
	* Source/NSConcreteNumber.m: Output 'YES' as boolean in description.
	* Source/NSNotificationCenter.m: Fix dumb memory leak.
	* Source/NSNumber.m: Output 'YES' as boolean in description.
	* Source/NSUserDefaults.m: Set 'YES' as boolean string.
	* Headers/Foundation/NSObject.h: Fix v dumb memory leak.
	* Source/GSHTTPURLHandle.m: Append crlf to separate headers from body
	rather than just an lf.
	* SSL: Renamed SSL class and source file to reflect the fact
	that the code is not unix specific.

2002-08-11  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.ac: Check for libxml version 2.3.0 or greater to ensure
	we have xpath support.
	* Source/NSDecimalNumber.m: implement ([-getValue:]) and
	([-initWithBytes:objCType:])

2002-08-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNotificationCenter.m: ([-postNotification:]) Correct to
	post the actual notification we are given rather than a notification
	built from that one.  Bug report by Alexander Malmberg.

2002-08-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProcessInfo.m: ([-globallyUniqueString]) Ensure that the
	string contains no dots, so it can be used as a filename under
	windoze.
	* Source/Additions/GSXML.m ([GSXMLNode -setNamespace:]): Documented.

2002-08-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: ([-boolValue]) Accept 'true' as well as 'YES'
	* Source/NSThread.m: Modified to avoid using non-standard notification
	initialisation.
	* Source/NSNotification.m: Rewritten as abstract/cluster class for
	implementation compatibility with MacOS-X
	* Source/NSNotificationCenter.m: Modified posting to behave like the
	MacOS-X implementation.  Implement concrete subclass of
	NSNotification.
	* Source/NSUserDefaults.m: Try to make creation of new defaults
	database an atomic operation.
	* Source/NSObject.m: Remove dealloc notifications hack ... the
	dealloc method can now safely be used to refrain from deallocating
	objects, so I don't think the hack is needed any more.
	* Source/NSProcessInfo.m: ([-globallyUniqueString]) Update to ensure
	uniqueness across all hosts, processes, and threads.
	* Tools/gdomap.c: Tidyup patch by Matthias Klose

2002-07-29  Adam Fedor  <fedor@gnu.org>

	* Merge changes from 1.4.0 onto main branch.

2002-07-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpHandle.m: Always use runloop in NSConnectionReplyMode
	to avoid other NSDefaultRunLoopMode events being triggered while
	executing a DO method.  **EXPERIMENTAL**

2002-08-06  Adam Fedor  <fedor@gnu.org>

	* Source/NSString.m (-getLineStart:end:contentsEnd:forRange:):
	Change location of start of end char search (Patch from Pete
	French).

2002-07-27  Adam Fedor  <fedor@gnu.org>

	* Version: 1.4.0

2002-07-23  Adam Fedor  <fedor@gnu.org>

	* Source/NSInvocation.m ([GSFrameInvocation
	-initWithMethodSignature:]): Return nil if signature is nil.
	* Source/GSFFCallInvocation.m (-initWithMethodSignature:): Idem.
	* Source/GSFFIInvocation (-initWithMethodSignature:): Idem.
	
2002-07-20  Adam Fedor  <fedor@gnu.org>

	* Source/NSDecimal.m: ifdef for compiling on Darwin (report
	from Carl Eugen).
	* Source/NSInvocation.m ([-initWithSelector:): Rewrite to use
	designated initializer.
	(-initWithTarget:selector:): Idem.

2002-07-18  Adam Fedor  <fedor@gnu.org>

	* Tools/gdomap.c (main): Write the pidfile before switching away
	from root, but only if the user is root.

2002-07-17  Adam Fedor  <fedor@gnu.org>

	* Source/NSString.m (-getLineStart:end:contentsEnd:forRange:): Fix
	lineEnd and contentEnd check for \r\n (particularly at end of
	string.

Tue Jul 16 16:43:59 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/base/GSXML.h ([GSXMLNode -setNamespace:]): Added
	missing method essential to use namespaces.
	* Source/Additions/GSXML.m ([GSXMLNode -setNamespace:]): Implemented.
	
2002-07-08  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSFileManager.m: Don't standardise path before converting to
        filesystem representation.
        * Tools/gdomap.c: Security enhancement - call setgroups().

2002-07-03  Adam Fedor  <fedor@gnu.org>

	* Version: 1.3.4
	* configure.ac: Remove warning about libffi
	* Documentation/news.texi: Update.

2002-07-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Ensure mime-version header appears
	before other headers. Fix bug in terminatimg mime data.

2002-07-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Don't write to pidfile until *after* setuid away
	from root. Bug reported by James Kehl <mkehl@gil.com.au>

2002-07-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSMime.m: Correct test for multipart content when
	generating raw data.  Fix by Mark Allison <mark@brainstorm.co.uk>

2002-06-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSFileHandle.h: New version of UnixFileHandle
	for combined unix/windoze use.
	* Source/GSFileHandle.m: New combined unix/windows implementation.
	* Source/NSFileHandle.m: Use GSFileHandle.
	* Source/GNUMakefile: Build GSFileHandle.
	* SSL/GSUnixSSLHandle.m: Update for combined GSFileHandle

2002-06-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: ([-respondsToSelector:]) handle nul selectors.
	Bug report by Andy Ruder <aeruder@yahoo.com>

2002-06-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Change to quote strings in plist output
	aggressively (quote characters that don't really need quoting)
	while still parsing flexibly ... ie handle unquoted strings as
	long as they don't contain 'special' characters.
	Fix for Tom Hageman <th@xs4all.nl>

2002-06-27  Richard Frith-Macdonald <rfm@gnu.org>

        * Tools/AGSParser.m: ([-parseDeclaration:]) Correct wrongly
	positioned autorelease pool in last change. Hope that's the only
	one.

Wed Jun 26 15:32:36 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* base.make.in (OBJC_LIBS): Don't add -lobjc_gc -lgc for gc=yes,
	now should be done by gnustep-make automatically.

Tue Jun 25 13:31:12 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Tools/AGSHtml.m: Tidy up autorelease pool macros so that it
	compiles with gc=yes and old compilers.
	* Tools/AGSParser.m: Idem.
	* Tools/AGSOutput.m: Idem.
	* Tools/HTMLLinker.m: Idem.
	* Tools/autogsdoc.m: Idem.
	* Tools/gdnc.m: Idem.
	* Tools/gsdoc.m: Idem.
	* Tools/make_strings/make_strings.m: Idem.	

Tue Jun 25 13:13:00 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/Additions/GSMime.m ([-rawMimeData:]): Create the
	autorelease pool after the other variables, so that it compiles
	with gc=yes and gcc < 3.x.
	* Source/NSLog.m (NSLogv): Idem.
	
2002-06-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSFileHandle.h: add async read of specific length.
	* Source/NSFileHandle.m: Make the async wconvenience methods call
	the core ones.
	* Source/UnixFileHandle.m: Remove async convenience methods and add
	one to read specified length of data.

2002-06-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSMime.m: add a few consistency checks to raise an exception
	if we try to unparse a GSMimeDocument with inconsistent headers and
	content.

2002-06-19  Adam Fedor  <fedor@gnu.org>

	* Source/GSLocale.m (GSSetLocaleC): Only set locale for LC_CTYPE.

2002-06-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m: Cope with a URL where the path is missing.
	Check user, password, host, port parts for illegal characters.
	Thanks to bug report by Marco Manfredini <mldb@gmx.org>
	* Source/GSMime.m: add convenience method for setting document type.
	Fix error in recent change to base64 encoding.

2002-06-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimer.m: Retain target and user info on initialisation
	Release them on invalidation.  Ensure timer is invalidated on
	deallocation. Documented timer methods.
	Changes based on bug report by Andy Ruder <aeruder@yahoo.com>
	* Source/NSURL.m: Fixed one possible nul pointer indirection,
	and added some comments about the internal data structure.
	Handle percentage escape sequences in user, password, host and port
	even though MacOS-X only seems to do it for the user name and host.
	* Tools/plmerge.m: Fixed some crasher bugs where given bad arguments.

2002-06-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFTPURLHandle.m: simple implementation added
	* Source/NSURLHandle.m: Register GSFTPURLHandle for ftp scheme.
	* Source/GSHTTPURLHandle.m: modified so that data being read is
	reported periodically during the read proces rather than just at end.

2002-06-15  Adam Fedor  <fedor@gnu.org>

	* Source/NSProcessInfo.m: Include sys/fcntl for Solaris.

2002-06-14  Richard Frith-Macdonald <rfm@gnu.org>

	* config/pathxml.m4: Adjust path to headers.
	* Tools/gsdoc.m: Adjust path to headers.  Add warning about
	deprecation.
	Patch by e.sammer <eric@linuxstep.org>
	* Source/NSObject.m: Added some compatibility methods in a
	categpory of Object.
	* Source/Additions/GSMime.m: Add a couple of convenience methods.
	* Source/GSHTTPURLHandle.m: Use one of them.
	* SSL/Makefile.postample: on distclean, don't need to delete
	bundle, but do delete config.h explicitly.

2002-06-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Include NSInvocation.h to avoid
	compiler warning.

2002-06-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Fix a few errors which crept in to the map
	table based reference counting.
	* Examples/GNUmakefile: Permit local makefile to be missing.
	* Source/UnixFileHandle.m: Added outgoing SOCKS5 support.
	* Source/NSFileHandle.m: Added SOCKS5 documentation.
	* Source/Base/gsdoc: Dopcumented SOCKS enironemnet variables and defs.
	* Source/NSNotification.m: Made -description more informative.
	* Testing/call.m: Trivial test program for tcp connections.
	* SSL/GSUnixSSLHandle.m: Updated for socks.
	* Additions/GSMime.m: Utilites to encode/decode base64
	* Source/GSHTTPURLHandle.m: Use encoding.

2002-06-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/UnixFileHandle.m: Avoid some unnecessary autoreleases.

2002-06-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Implemented and documented -className
	* Tools/AGSOutput.m: When Verbose = YES log all documentable
	entities for which no comment text was found.
	* Source/NSException.m: Added NSParseErrorException and tidied other
	general exceptions.
	* Source/extern.m: Removed generic exceptions ... now in NSException.m

2002-06-06  Adam Fedor  <fedor@gnu.org>

	* Source/cifframe.m (cifframe_from_info): Set value locations
	after prepping cifframe.

2002-06-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLog.m: patch by Jeff Teunissen to avoid adding date/time
	info when using syslog.
	* Source/NSURL.m: Fix loading codde to set self as client of handle.
	* Tools/AGSParser.m: Fix to avoid warnings about unimplemented protocols
	* Headers/gnustep/base/GSXML.h:
	* Headers/gnustep/base/NSArchiver.h:
	* Headers/gnustep/base/NSAutoreleasePool.h:
	* Headers/gnustep/base/NSCoder.h:
	* Headers/gnustep/base/NSDictionary.h:
	* Headers/gnustep/base/NSFileHandle.h:
	* Headers/gnustep/base/NSNotification.h:
	* Headers/gnustep/base/NSRunLoop.h:
	* Headers/gnustep/base/NSURL.h:
	* Headers/gnustep/base/NSURLHandle.h:
	* Source/GSHTTPURLHandle.m:
	* Source/NSArray.m:
	* Source/NSCoder.m:
	* Source/NSFileHandle.m:
	* Source/NSNotification.m:
	* Source/NSRunLoop.m:
	* Source/NSURLHandle.m:
	* Source/NSUnarchiver.m:
	* Source/externs.m:
	* Source/Additions/GSXML.m:
	Tidied for documentation purposes ... no substantial code changes

Wed Jun  5 17:46:47 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSLog.m (_NSLog_standard_printf_handler): Fixed
	syslogging of strings: add a NULL at the end of strings before
	feeding them to syslog.

2002-06-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSURL.h: Added a couple of ivars and removed
	non-standard methods.
	* Source/NSURL.m: Rewrite everything apart from the code dealing
	with NSURLHandle objects (and change some of that) to conform to
	the documentation (I hope) and to try to match behavior with that
	of MacOS-X.

2002-06-04  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSByteOrder.h: Hack for bug in gcc 3.1
	* Source/externs.m (_gcc3_1_hack): Idem. (modified patch from 
	benhur@inf.ufsm.br).

	* Source/GSFFIInvocation.m (gs_objc_msg_forward): Alloc closure
	with fastMallocBuffer.

	* Documentation/coding-standards.texi: Update.

2002-06-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSObject.h: Removed  ([_dealloc]),
	([-deallocNotificationsActive]), ([setDeallocNotificationsActive:])
	* Source/NSObject.m: Removed  ([_dealloc]),
	([-deallocNotificationsActive]), ([setDeallocNotificationsActive:])
	as these methods are no longer necessary now that the dealloc method
	itsself is able to refrain from performing deallocation if if wishes
	(the retain count mechanism can no longer reach a zero retain count).

2002-06-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Change NSDecrementExtraRefCountWasZero() to
	refrain from decrementing when the count is zero.  Documented
	the retain/release/retainCount methods (and others).
	* Headers/Foundation/NSObject.h: Documented extra ref count functions.

2002-05-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Change order of zombie initialisation for
	darwin port.

2002-05-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSMime.h: Make set... methods return void.
	* Source//GSMime.m: Make set... methods return void.  Also fix
	parsing to use different 'specials' for HTTP and MIME
	* Headers/gnustep/base/GSIMap.h:
	* Headers/gnustep/base/NSHashTable.h:
	* Headers/gnustep/base/NSMapTable.h:
	* Source/GSArray.m:
	* Source/GSSet.m:
	* Source/GSTcpPort.m:
	* Source/NSBundle.m:
	* Source/NSConnection.m:
	* Source/NSData.m:
	* Source/NSHashTable.m:
	* Source/NSMapTable.m:
	* Source/NSObject.m:
	* Source/NSRunLoop.m:
	Applied patches by James Knight, to improve memory efficiency and
	insertion.deletion speed to hash and map tables.  Also fixes for
	some GC problems.
	Fixed minor problem in patch, and added code to call functions to
	clean up after hash and map enumerations.  Modified cleanup function
	to clear enumerator ... for memory release on GC system.
	Rewrote enumeration code so that it maintains the characteristic
	that objects can safely be removed from maps after being enumerated
	(this feature is used in several places).
	*WARNING* This introduces a binary incompatibility in that the size
	of the map table and hash table enumeration types has grown.
	If you have binaries which use the NSEnumerateHashTable() or the
	NSEnumeratemapTable() functions, you need to rebuild them.

2002-05-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/GSMime.h: Tidy up and add convenience methods.
	* Source/Additions/GSMime.m: Tidy up and add convenience methods.
	Added methods to convert content between string and data for ease
	of use from java.  Added support for most character sets handled
	by GNUstep-base.  Improved ContentID generation to be both unlikely
	to recur, and to be guaranteed unique within a process.
	* Source/NSBundle.m: ([+allBundles]) Don't enumeraste if map table
	has not been created yet.
	* Source/NSLog.m: Allow output descriptor to be changed.
	* Source/NSProcessInfo.m: Add method to change log output to go to
	another file for applications where stderr has been hijacked.

2002-05-26  Fred Kiefer <FredKiefer@gmx.de>

	* Source/Additions/GSXML.m
	Define GSXMLAttribute in the case when libxml is found. 
	Otherwise it wont compile on MS Windows.

2002-05-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/GSMime.h: Add GSMimeHeader class.
	* Source/Additions/GSMime.m: Add GSMimeHeader class.
	Update API to use GSMimeheaders rather than dictionaries.

2002-05-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Fix a few errors in last changes.
	* Source/NSString.m: Updates for GSXML changes.
	* Tools/AGSHtml.m: Updates for GSXML changes.
	* Tools/AGSIndex.m: Updates for GSXML changes.

2002-05-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSXML.h: Add _parent ivars
	* Source/Additions/GSXML.m: Implement memory mangement so that the
	underlying libxml data is not freed unless all objects derived from
	it have been deallocated.  Remove comments warning about original
	memory management scheme.

2002-05-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSeq.h: Fix bug matching sequences with zero length range.
	* Headers/gnustep/base/GSMime.h: Tell autogsdoc where to look for source
	* Headers/gnustep/base/GSXML.h: Updates for consistency etc.
	* Source/Additions/GSXML.m: ditto
	* Tools/AGSHtml.m: Modified for changed GSXML
	* Tools/AGSIndex.m: ditto
	* Tools/AGSParser.m: ditto
	* Tools/autogsdoc.m: ditto
	* Tools/defaults.m: Fixed typo
	Mostly, changes to make methods which were intended to be private
	really private, and lots of modifications to make mathod names
	consistent with OpenStep usage ... suggestions made by many people.
	* configure.ac: Use better names for GMP and ZLIB flags
	* configure: regenerate
	* Headers/gnustep/base/GSConfig.h.in: GMP and ZLIB update
	* Headers/gnustep/base/NSDecimal.h: GMP update
	* Headers/gnustep/base/UnixFileHandle.h: ZLIB update
	* Source/NSDecimal.m: GMP update
	* Source/UnixFileHandle.m: ZLIB update

2002-05-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLog.m: Altered logging format for compatibility with
	MacOS-X (and easier collating).  Thanks to report by lcampbell

2002-05-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: GSFromUnicode(), GSToUnicode(), bugfix - ensure
	that returned memory is allocated from specified zone, rather than
	returning internal buffer.
	* Tools/AGSIndex.m: When a string missmatch is found when merging,
	update the output to the new string as well as warning.
	* Tools/autogsdoc.m: Don't automatically include refs to installed
	copies of the project being documented.

2002-05-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Don't try to release memory using free()
	when it was allocated using NSZoneMalloc().
	* Tools/autogsdoc.m: Improve dependency rule management.
	* Tools/AGSParser.h: ditto
	* Tools/AGSParser.m: ditto
	* Tools/AGSIndex.h: ditto
	* Tools/AGSIndex.m: ditto
	Store all dependency information in the .igsdoc file and keep it up
	to date.  Never regenerate a file that doesn't need it.
	Mostly the changes are to cope with the fact that we now have
	common files into which all functions, constants, variables, and
	typedefs within a project are combined.

2002-05-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Rationalise so that all conversion operations
	go through the two new functions.  Gets rid of a load of old code.
	* Source/GSString.m: ([-replaceCharactersInRange:withString:])
	minor performance enhancement when copying from a 16-bit string
	to an 8-bit string.

2002-05-10  Adam Fedor  <fedor@gnu.org>

	* Source/Additions/GSXML.m: Change libxml strings to UTF8
	(makeText:) New.
	Add GSXMLDummy for MinGW
	* Source/Additions/libgnustep-base.def: Remove GSXMLHandler.
	(patch from Kai Henningsen).

2002-05-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdnc.m: Make gdnc log to syslog by default, and close
	stdin, stdout, stderr to run as daemon.
	* Source/NSUser.m: Restructured path generation code slightly.
	Added support for system-wide .GNUsteprc with force options.
	Removed use of FORCE_USER_ROOT and FORCE_DEFAULTS_ROOT
	* Source/Base/gsdoc: Document the .GNUsteprc files.
	* Source/NSArray.m: Fix bug with GC pointed out by James Knight

2002-05-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPURLHandle.m: Insert port information to URL passed
	to proxy.

2002-05-09  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBundle.m
	Use fileSystemRepresentation instead of cString to get the file 
	name to load. 
	
2002-05-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTask.m: When launching under windoze, don't forget to
	use the fileSystemRepresentation of the program name.

2002-05-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: Fix function prototype ... gets rid of
	compiler warning.
	* Source/GNUmakefile: remove o_vscanf.c ... unused
	* Source/o_vscanf.c: remove unused file.
	* Source/mframe.m: Fix compiler warning about unused function.
	* Source/GSFormat.m: Fix compiler warning about unused var.
	* Source/NSDebug.m: Fix compiler warning about unused var.
	* Source/externs.m: Fix compiler warnings ... move some exceptions
	to source files relating to where they are declared.
	* Source/NSArchiver.m: define exception.
	* Source/NSConnection.m: define exception.
	* Source/NSPort.m: define exception.
	* Tools/gdomap.c: Remove unused variable (log_perror).

2002-05-07  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Make all AC_DEFINES define 1
	* config/objc-con-autoload.m4: Idem.
	* config/objc-sys-dynamic.m4: Idem.

2002-05-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: mingw path fixes and debugging
	* Source/NSFileManager.m: ditto

2002-05-06  Adam Fedor  <fedor@gnu.org>

	* Source/NSMethodSignature.m (-isEqual:): Implemented (from
	znek@mulle-kybernetik.com).

2002-05-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSMapTable.m: Delete line teft over by accident ... could
	cause crach if passes nul table.  Thanks to Lars Sonchocky-Helldorf
	* Source/NSCalendarDate.m: ([-initWithString:calendarFormat:]) don't
	supply current date information as default ... for compatibility
	with MacOS-X use zero date instead. Thanks to lcampbell.

2002-05-04  Adam Fedor  <fedor@gnu.org>

        * Testing/nsbundle.m: Update to work without installing bundle.

2002-05-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: NSHomeDirectoryForUser() ... fix windoze bug ...
	was returning the current users home directory irrespective of the
	user asked for.  Now returns nil for other users ... should really
	find some mechanism to determine home directories for other users.
	* Source/Additions/GSXML.m: If ([_parseChunk:]) is called with nil
	data, terminate parsing.  Report by Alexander Malmberg.

2002-05-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAssertion.m: Added comments and fixed bug in handling
	an assertion in a function ... was calling va_end() before the last
	use of the arguments.  Also, release new handler after adding it to
	thread dictionary ... fix memory leak.
	* Source/NSThread.m: Add fprintf of alert message to STDERR if we
	are unable to determine the current thread.  Don't attempt to use
	NSLog() or similar ... since chances are, without a thread object,
	that would just crash.
	In GSRegisterCurrentThread(), add code to handle the case where the
	NSThread class has not been initialised.
	* Source/NSObject.m: NSAllocateObject() raise exception if passed
	something other than a class to allocate an instance of.

2002-05-02  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/GSUnixSSLHandle.m: Change '#if HAVE...' to '#ifdef HAVE_...'
	* Source/GSFormat.m: ditto
	* Source/GSHTTPURLHandle.m: ditto
	* Source/GSTcpPort.m: ditto
	* Source/NSBundle.m: ditto
	* Source/NSData.m: ditto
	* Source/NSDate.m: ditto
	* Source/NSFileManager.m: ditto
	* Source/NSHost.m: ditto
	* Source/NSLock.m: ditto
	* Source/NSLog.m: ditto
	* Source/NSPage.m: ditto
	* Source/NSPipe.m: ditto
	* Source/NSProcessInfo.m: ditto
	* Source/NSRunLoop.m: ditto
	* Source/NSString.m: ditto
	* Source/NSTask.m: ditto
	* Source/NSThread.m: ditto
	* Source/NSUser.m: ditto
	* Source/UnixFileHandle.m: ditto
	* Source/WindowsFileHandle.m: ditto
	* Tools/gsdoc.m: ditto
	* Tools/autogsdoc.m: ditto
	Fixes to handle configuration changes where AC_DEFINE is setting
	preprocessor constants to be empty (but defined) rather than to be 1

2002-05-02  Adam Fedor  <fedor@gnu.org>

	* configure.ac: Updated to autoconf 2.53 from configure.in
	* configure, config.h.in: Regenerate.
	* Source/mframe/configure.ac: Idem.
	* SSL/configure.ac: Idem.
	* acconfig.h, aclocal.m4: Remove
	* config/pathxml.m4: New from aclocal.m4.
	* config/objc-con-autoload.m4: Updated from aclocal.m4
	* config/procfs-exe-link.m4: Idem.
	* config/procfs.m4: Idem.

2002-05-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLHandle.m: Implement ([-hash]) and ([-isEqual:]) based on
	([-absoluteString]) rather than simple pointer comparison.
	* Source/GSHTTPURLHandle.m: ([-bgdConnect]) check for existing
	headers before writing ... avoid overriding them and only set things
	that the programmer has not bothered to set.
	([-loadInBackGround]) use URL port if available.
	More fixes thanks to lcampbel via savannah
	* Headers/Foundation/NSURLHanlde.h: include NSObject.h
	* Source/UnixFileHadle.h: add missing semicolon thanks to Paul Windey

2002-05-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLHandle.m: ([URLHandleClassForURL:]) Fix to return most
	recently registered class rather than first registered one.
	Bug report via savannah

2002-04-30  Adam Fedor  <fedor@gnu.org>

	* Version: 1.3.2
	* Documentation/news.texi: Update.
	* NEWS Regen.

2002-04-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Standardise handling for windoze drive
	specifiers in file paths.
	* Source/NSUser.m: Use ([-stringWithFileSystemRepresentation:length:])
	when importing file names.
	* Source/NSString.m: Update all path handling methods for windoze 
	changes.  Fix several bugs where we did not conform to documentation.

2002-04-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Port
	([-stringWithFileSystemRepresentation:length:]) to windoze...
	Have it convert backslashes to slashes etc.

2002-04-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Improve handling of identifier mapping so that
	an identifier mapped to an empty string (or //) an any place where
	whitespace is permissable is treated as part of that white space.

2002-04-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Interpret a mapping to '//' in the WordMap as
	meaning that the rest of the line containing the mapped value
	should be ignored.

2002-04-24  Gregory John Casamento <greg_casamento@yahoo.com>

	* Tools/make_strings/GNUmakefile - modified to prevent build
	error when building from scratch
	* Tools/make_strings/GNUmakefile.preamble - added to provide
	paths to include and lib directories for linking make_strings
	tool when building from scratch.
	
2002-04-23  Adam Fedor  <fedor@gnu.org>

	* Source/GSFFIInvocation.m
	(-initWithCallback:returnp:values:frame:signature:): Simplify
	setting values. Structs passed by ref when MFRAME_STRUCT_BYREF.
	(GSFFIInvokeWithTargetAndImp): Encoding values unneedded now.
	(gs_objc_msg_forward): Free the closure via NSData.

	* Source/mframe/powerpc/generic: Fix offset for structs.
	* Source/mframe/powerpc/linux-gnu: Idem.
	* Source/mframe/powerpc/darwin: Idem.
	
2002-04-22  Adam Fedor  <fedor@gnu.org>

	* Tools/gdomap.c (gdomap_log): For LOG_INFO, write to 1, not 0.

	* Tools/make_strings: New tool from Alexander Malmberg
	<alexander@malmberg.org>

	* Source/Additional/Makefile.preamble (ADDITIONAL_OBJCFLAGS):
	Add for building DLL on mingw32

2002-04-20  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSURL.m: ([-absoluteString]) anonymous bugfix applied.

2002-04-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdnc.m: If given -NSHost specification for the current host,
	ignore it and use the standard name.
	* Source/GSTcpPort.m: ([-invalidate]) call superclass implementation
	at end ... so handles can find this port when they are destroying
	themselves.  Reverses last change I made to this.

2002-04-18  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/COPYING.LIB: New file ... just to make it *REALLY* obvious
	this code is under the LGPL

2002-04-18  Adam Fedor  <fedor@gnu.org>

	* Minimally working libffi support. Needs work.
	* configure.in: Allow libffi to be enabled.
	* Source/GSFFIInvocation.m: Rewrite.
	* Source/NSConnection.m (-forwardInvocation:forProxy:): Add libffi
	function.
	* Source/NSInvocation.m: Fixup cifframe arg functions.
	* Source/cifframe.m: Rewrite.
	* Testing/nsinvocation.m: Bug fix.

	* Documentation/coding-standards.texi: Remove info dir tag.
	* Documentation/gnustep-base.texi: Idem.
	* Resources/Languages/Slovak: New file (from Stefan Urbanek).

Thu Apr 18 11:10:04 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/base/NSObjCRuntime.h: Updated #defines and
	Windows DLL export/import machinery to the new gnustep-make
	conventions.

2002-04-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: re-order headers so config.h is used on windoze
	* Source/NSFileManager.m: ([-fileSystemRepresentationWithPath:])
	modified to handle MSYS paths with '/drive/' prefix.
	* Source/GSTcpPort.m: ([-invalidate]) call superclass implementation
	at start, so flag gets set to say we are not valid, and we avoid any
	recursive calls.

2002-04-16  Richard Frith-Macdonald <rfm@gnu.org>

	* config/config.reuseaddr.c: New test for broken SO_REUSEADDR
	* configure.in: test for broken SO_REUSEADDR
	* acconfig.h: Add BROKEN_SO_REUSEADDR
	* configure: regenerated
	* Source/UnixFileHandle.m: Use reuseaddr info.
	* Source/GSTcpPort.m: Use reuseaddr info.
	* Tools/gdomap.c: Use reuseaddr info.
	* Source/NSPortNameServer.m: Improved warnings about launching
	gdomap.
	* Source/NSDistributedNotification.m: Improved warnings about
	launching gdnc.
	* Source/NSException.m: Log uncaught exceptions with executable name.
	* Source/NSProcessInfo.m: New private function for exception msg.
	* Source/GSString.m: Applied fix by Malexander Malmberg for
	transmuting strings where the default encoding is not the same as
	the internal 8-bit encoding.
	* Source/Unicode.m: Logic fix for selecting strict conversion from
	unicode by Alexander Malmberg.

2002-04-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GSXML.m: New method ([-nextElement]) to traverse
	tree skipping non-element nodes.  Also ([-childElement]) to get the
	first child element of a node.

Thu Apr 11 15:34:33 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/GSAttributedString.m ([GSMutableAttributedString
	-sanity]): Renamed to -_sanity, and changed so that we always
	compile this in so that regression testcases can use it.

2002-04-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Resources/GNUmakefile: install new language files.
	* Resources/Languages/Russion: language file added.
	* Resources/Languages/UkraineRussion: language file added.
	Added language files provided by Serg Stoyan <stoyan@on.com.ua>
	* Source/UnixFileHandle.m: Permit accept/connect on descriptors
	by default.
	* Source/WindowsFileHandle.m: ditto
	* Headers/Foundation/NSProcessInfo.h: Added MacOS-X operating system
	methods and enum
	* Source/NSProcessInfo.m: Added operating system methods and documented
	all methods for autogsdoc.

2002-04-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: Tidy initialisers for case where the default
	C-string encoding is not usable internally.
	* Source/NSLog.m: Try default cString encoding.
	* Tools/cvtenc.m: Add -EscapeIn and -EscapeOut flags to handle \u
	escapes in files.
	* Resources/Languages/Italian: Correct to use \u escapes
	* Resources/Languages/French: ditto.
	* Resources/Languages/German: ditto.
	* Resources/Languages/README: New file to tell editors that they
	should use \u escapes ... and suggesting use of the cvtenc tool
	to make the job easy.

2002-04-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Fix error in unicode BOM handling
	Write plist unicode escapes using the conventional \u rather than \U,
	but read in either form.
	* Source/GSString.m: Fix error in length of unicode data produced.
	* Tools/cvtenc.m: Made easy to use and added instructions.

Sat Apr  6 02:42:43 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSUser.m (NSSearchPathForDirectoriesInDomains): Fixed
	typo, gnustep_local_root being used instead of gnustep_user_root
	for developer dirs in user root.
	
2002-04-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Fix locking bug with NSZombie ... was not
	locking when adding/removing zombies.
	* Source/NSString.m: Fix property list parsing code to raise
	exceptions on failure rather than logging messages.  Also check for
	extra data at end of parsed string.
	* Tools/ctvenc.m: new tool for converting string encodings.

2002-03-28  Manuel Guesdon <mguesdon@orange-concept.com>

	* Tools/gsdoc.m: corrected inversed test for missing entities
	
2002-03-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSPrivate.h: Added function to fetch boolean value from env
	* Source/NSException.m: Use new function.
	* Source/NSProcesInfo.m: Implement new function.
	* Source/NSObject.m: Implement NSZombie functionality.
	* Headers/Foundation/NSDebug.h: Document NSZombie functionality.

2002-03-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTask.m: Implement code to watch for child process exit
	under mingw and rewrite various methods to handle process
	termination nicely under windoze.
	* Source/NSException.m: flush stderr ... under windoze stderr is
	not automatically flushed!
	* Source/GSWindowsFileHandle.m: watch for exceptional conditions
	so we can handle socket connection failures in mingw32.
	Added code to try to cope with standard files properly, not just
	network sockets.
	* Source/GSTcpPort.m: ditto.
	* Source/Unicode.m: GSToUnicode(), GSFromUnicode(), if terminate
	option is specified, always produce output with a nul terminator
	even for input of an empty string.

2002-03-22  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/GNUmakefile: Remove -lobjc and -lgnustep-base from bundle
	libraries ... it should not need them.

2002-03-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: Ensure property-list read/write uses UTF8
	* Source/NSDictionary.m: ditto
	* Source/NSConnection.m: Change timeouts to 300 seconds and
	document all methods.

2002-03-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: lossyCString_u() handle case where cString
	contains more bytes than unicode string has characters.
	* Tools/gdomap.c: Suppress unnecessary warnings except under debug.
	Implement spawning to run as daemon under windoze.
	* Toolds/gdnc.m: Run as daemon under windoze.
	* Source/GSTcpPort.m: Fix to stop multiple servers trying to use
	the same port under windoze.
	* Source/WindowsFileHandle.m: Fix to stop multiple servers trying to use
	the same port under windoze.  Fix to return gdomap port even if
	getservbyname() doesn't.
	* Source/UnixFileHandle.m: Fix to return gdomap port even if
	getservbyname() doesn't.
	* Source/NSTask.m: Try appending .exe extension to paths under windoze.
	* Source/Unicode.m: GSFromUnicode() fix lossy conversion  for cases
	where output encoding can't handle the unicode.

2002-03-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: lossyCString_c() fix in line with recent
	changes ... cope with case where internal coding is not same as
	external coding.
	lossyCString_u() fix encoding used.

2002-03-18  Adam Fedor  <fedor@gnu.org>

	* Tools/gdomap.c (gdomap_log): Write to stdout if prio=LOG_INFO.

2002-03-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Some boundary error fixes by Alexander Malmberg.
	Fixes to encoding table initialisation.
	* Source/NSString.m:Fix error in encoding type for initialising from
	data.  By Alexander Malmberg.
	* Source/GSString.m: Correct string length when transmuting an 8-bit
	string to a 16-bit string - by Alexander Malmberg.

2002-03-17  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/GSAttributedString.m 
	([GSMutableAttributedString -replaceCharactersInRange:withString:]): 
	Only keep attribute #0 when removing it would remove all attributes.
	(patch by Alexander Malmberg)

2002-03-16  Adam Fedor  <fedor@gnu.org>

	* configure.in: Also configure SSL.

2002-03-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/Unicode.h: Add more options for character
	encoding conversion routines.
	* Source/GSPrivate.h: Add a couple of private functions for character
	encoding management.
	* Source/GSString.m: Convert throughoput to use new functions for
	converting from one string encoding to another.  Make changes to
	handle setting of default C string encoding to be an encoding which
	is incompatible with internal e-bit string objects.
	* Source/NSString.m: ditto
	* Source/Unicode.m: new string encoding conversion functions extended
	with a few new options.  Also fixed some memory allocation bugs to
	cure memory leaks.

	Rewritten low level support for different character encodings ...
	should provide more efficient and maintainable conversion between
	encodings and permit use of wide character encodings and encodings
	with multibyte sequences as the default C string encoding.
	Testing ... minimal ... we could do with decent tests for this stuff.
	So this version must be viewed as possibly very unstable!

2002-03-14  Adam Fedor  <fedor@gnu.org>

	* Version: 1.3.0
	* Documentation/install.texi, readme.texi, ...: Updated

2002-03-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m; Bug report by Manuel Guesdon prompted me to
	rewrite string trimming extensions.  All the tail end trimming
	was wrong.
	* Source/Unicode.m: Added two new conversion functions ... untested.
	The intention is to replace other string conversion with these ones
	which should localise memory management issues.

2002-03-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Tidy a little ... fix non-static declarations.
	* Source/NSString.m: ([-initWithData:encoding:]) Correct the length
	of the string produced when unicode data is missing its 2 byte
	prefix. Simplification of code based on suggestion by Yen-Ju Chen
	* Source/GSString.m: Fixes for cString infor from unicode by
	Yen-Ju Chen.

Wed Mar 13 16:55:49 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/Additions/GSXML.m ([GSSAXHandler
	-externalSubset:externalID:ystemID:]): Fixed typo, 'ystemID:'
	instead of 'systemID:'.

2002-03-13  Adam Fedor  <fedor@gnu.org>

	* Tools/gdomap.c (log): Redefine to gdomap_log to avoid conflict
	with syslog function on Darwin.

	* Source/NSProcessInfo.m (main): Use STRINGIFY to get proper
	name of constant string class.

2002-03-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSObjCRuntime.h: Remove bad markup in comments.
	* Headers/gnustep/base/NSString.h: Remove private class declaration
	and hide internals of NXConstantString behind dummy interface while
	improving comments.  Fix long overdue declaraction of methods in
	clsses rather than protocols.
	* Source/GSUserDefaults.h: removed
	* Source/GSPrivate.h: added
	* Source/GSCompatibility.m: fix for hidden private info.
	* Source/GSString.m: ditto
	* Source/NSArray.m: ditto
	* Source/NSCalendarDate.m: ditto
	* Source/NSDate.m: ditto
	* Source/NSDecimalNumber.m: ditto
	* Source/NSDictionary.m: ditto
	* Source/NSLog.m: ditto
	* Source/NSObjCRuntime.m: ditto
	* Source/NSScanner.m: ditto
	* Source/NSSerializer.m: ditto
	* Source/NSString.m: ditto
	* Source/NSUser.m: ditto
	* Source/NSUserDefaults.m: ditto
	General tidyups to hide some internal workings which should really
	not be exposed in public headers.

2002-03-12  Richard Frith-Macdonald <rfm@gnu.org>

	* NSTimeZones/NSTimeZones.tar: regenerated with latest data.

2002-03-12  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSString.h: Add extra ivars needed by Darwin
	to NXConstantString.
	* Source/GSString.m: ([NXConstantString +initialize]): Remove constant
	string class reference setup for Darwin.
	* Source/NSProcessInfo.m (main): Put it here.
	
Tue Mar 12 11:13:51 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/Additions/GSXML.m ([-isEqualTo:]): Renamed everywhere to
	isEqual:

Tue Mar 12 09:21:20 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSAssertionHandler.m
	([-handleFailureInMethod:object:file:lineNumber:description:]): Log
	if the object is a class or an instance.

2002-03-12  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/configure.in: Check GNUstep directories for headers and
	libraries as well as standard system directories.

Tue Mar 12 07:37:44 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/Additions/GSXML.m ([GSXMLNode -properties]): Fixed return
	type.

2002-03-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSInvocation.h:
	* Headers/gnustep/base/NSNumberFormatter.h:
	* Headers/gnustep/base/NSObject.h:
	Minor fixes to build with STRICT_OPENSTEP
	* Source/NSDistributedNotificationCentre.m: Attempt to start server
	automatically for other machines.  Improve log messages.

Sat Mar  9 15:21:04 2002  Adam Fedor  <fedor@yogi.doc.com>

	* Source/NSDistributedNotificationCenter.m (-_connect): Move check
	for alternative name so we can get registered.
 	
2002-03-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedNotificationCentre.m: Try alternative name for
	server if NSHost is specified ...in case it is running on another host.

Sat Mar  9 12:02:45 2002  Adam Fedor  <fedor@yogi.doc.com>

	* configure.in: Change constant string to FooConstantString
	* config/config.constant-string-class.m: Work with NeXT_RUNTIME
	(patch from Markus Hitter [mah@jump-ing.de]).

2002-03-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Change copy so that, if the source argument
	is a symbolic link, we copy the link rather than the thing it points
	to.
	* Tools/gdnc.m: Quick hack to register port with other names is NSHost
	is used.

2002-03-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Added BIG5 encoding
	* Headers/Foundation/NSString.h: Added BIG5 encoding
	* Resources/Languages/Locale.aliases: added traditional chinese
	Extensions for traditional chinese requested by Yen-Ju Chen

2002-03-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GNUmakefile: Include ../../base.make
	* SSL/GNUmakefile: Include ../base.make
	from the makefiles directory for builting standalone.
	* Source/Unicode.m: Added some standard string handling for iconv.
	* Source/NSString.m: ([-initWithData:encoding:]) return nil on
	failure to handle encoding.
	* Source/NSMapTable.m: NSMapInsert() fixed to conform to spec.
	* Source/NSHashTable.m: NSHashInsert() fixed to conform to spec.
	Reports by Alexander Malmberg

2002-03-07  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/NSRunLoop.m ([NSRunLoop -acceptInputForMode:]): 
	added a _checkPerformes: call to solve minor issue.
	(performers would only be called after an event was received)
	(credits to Alexander Malmberg)

2002-03-07  Richard Frith-Macdonald <rfm@gnu.org>

	* SSL/Makefile.posramble: store config.h in system specific subdir.
	* SSL/Makefile.preamble: Include headers from Source directory
	so we pick up GSConfig.h

2002-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/autogsdoc.m: store and fetch dependency info in .igsdoc
	so we can parse the correct source files for each header when we
	need to.

2002-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Additions/GNUmakefile: build subproject.
	* Source/Additions/Makefile.preamble: set include flags.
	* Source/Additions/GSXML.m: moved implementation here.
	* Source/Additions/GSMime.m: moved implementation here.
	* Source/GNUmakefile: build subproject.

2002-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* GNUmakefile: build SSL aggregate project
	* config.mak.in: Remove SSL info
	* configure.in: Remove SSL configuration
	* configure: Regenerate
	* SSL/GNUmakefile: Build SSL bundle
	* SSL/GSUnixSSLHandle.m: SSL bundle source from Source directory
	* SSL/Makefile.postamble: Build SSL bundle
	* SSL/Makefile.preamble: Build SSL bundle
	* SSL/config.h.in: Trivial config for SSL bundle
	* SSL/config.mak.in: SSL info for building bundle.
	* SSL/configure.in: Configuration for SSKL bundle.
	* Source/GNUmakefile: Don't build SSL bundle.
	* Source/GSUnixSSLHandle.m: Moved to SSL directory.
	* Source/Makefile.postamble: Don't build SSL bundle.
	* Source/Makefile.preamble: Don't build SSL bundle.
	Alterations to make the SSL bundle capable of standalone
	building - for use on systems where the base package has
	only been installed in binary form.
	Initial attempt!

2002-03-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSAttributedString.m: Applied fix for left-over attributes
	at end of string.  Patch supplied by Alexander Malmberg
	<alexander@malmberg.org>.  Reformatting to conform to GNUstep
	standards, and optimisation by me.

2002-03-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/autogsdoc.m: Output gsdoc as UTF8 as we should.
	* Tools/AGSOutput.m: ditto.

2002-03-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: When reading .GNUsteprc, if a per user version is
	not available, use the one in the configured system root directory.

2002-02-28  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h: Add objc-runtime.h
	* Source/Makefile.preamble: Add ..DEPEND_UPON for all darwin versions.

	* Source/NSPortCoder.m
	(-initWithReceivePort:sendPort:components:): Change cast to make
	MacOSX compiler happy.

2002-02-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: rewrite user and defaults root code to standardise
	and to use .GNUsteprc configuration.  Also permit forcing of fixed
	roots at compile time.

Thu Feb 28 16:46:31 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSUser.m (NSSearchPathForDirectoriesInDomains): Changed
	'Apps' to read 'Applications'.

2002-02-27  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/GSString.m ([GSMutableString -substringWithRange:]): 
	create a new string which size is the range length, not the original
	string's length.

2002-02-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Removed obsolete code for shrinking data structures.
	Added memmove() for overlapped memory moves (Alexander Malmberg) and
	removed a couple of obsolete functions.
	* Source/GSValue.m: attempt to correct encoding.
	* Source/NSKeyValueCoding.m: Fix termination of method names with nuls
	from report by Manuel Guesdon.
	* Source/NSDictionary.m: Implement MacOS-X compatible KVC behavior.
	Include webobjects/eof extension, with warnings.
	* Headers/Foundation/NSProtocolChecker.h: Change deprecated import to
	include.

2002-02-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Improve fetching interface info on mingw ...
	ignore non-internet interfaces.
	NB. The mingw winsock2.h header is buggy ... to work properly
	you need to change the size of a struct sockaddr field from
	sa_data[14] to sa_data[22]

Tue Feb 26 18:01:26 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSBundle.m: Removed all _releasedBundles machinery.
	Removed custom implementation of -release.  Retain a bundle after
	we load it.  This fixes -bundleForClass: and simplifies
	considerably the code.

	* Source/NSBundle.m: Whenever possible, use [self method] rather
	than [NSBundle method] to invoke a class method, for efficiency.

	* Source/NSBundle.m (objc_executable_location): Compute directly
	from _executable_path - using mainBundle is unsafe.
	
Tue Feb 26 17:35:03 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSBundle.m (_bundle_load_callback): Completely ignore
	categories.  (Suggestion by Gerrit Van Dyk
	<GerritVD@decillion.net>).

2002-02-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTemplateValue.m: Implement initialize method to set the
	version of concrete classes to be that of the abstract class which
	actually performs encoding/decoding ... should correct archiving.
	Problem reported by Gerrit Van Dyk
	* Tools/GSIndex.m: tidied a little
	* Tools/GSParser.m: mark when things are implemented.
	* Tools/GSOutput.m: warn about unimplemented items.

2002-02-26  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Source/NSUnarchiver.m 
	([NSUnarchiver +classNameDecodedForArchiveClassName:]): 
	([NSUnarchiver -classNameDecodedForArchiveClassName:]): 
	return nil if the class name is not present.

2002-02-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpPort.m: Fixes to work on mingw.
	* Source/NSHost.m: Update for current winsock on mingw.
	* Source/NSPortNameServer.m: Update for current winsock on mingw.
	* Source/WindowsFileHandle.m: Fix to work for basic socket I/O.
	* Tools/gdomap.c: many changes ... several fixes to work on mingw
	rewrite some clumsy inefficient code, make variables and functions
	local. etc.
	* Source/NSUnarchiver.m: ([versionForClassName:]) return NSNotFound
	if the class name was not present.

Mon Feb 25 15:26:38 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSBundle.m ([-initWithPath:]): Return nil if the path
	can't be read.  Fixed memory leak in case of nil argument.
	* Headers/gnustep/base/NSBundle.h: Documented some methods.
	
2002-02-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile: Move xml and mime classes into an additional
	library, and make base library depend on it.  EXPERIMENTAL.
	* Tools/gdomap.c: Try to get output working again after last changes.
	Add first attempt at MINGW support for getting network interface info.
	library, and make base library depend on it.
	EXPERIMENTAL - activate using 'make add=yes'

2002-02-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Rewrote key-value coding key manipulation to use
	a char array for speed.  Moved functions for converting between object
	internals in scalar types and NSNumbers etc to NSObjCRuntime.m.
	Re-implemented path methods to fix incorrect implementation as pointed
	out by Manuel Guesdon.
	* Headers/Foundation/NSObjCRuntime.h: New functions from NSObject
	* Source/NSObjCRuntime.m: New functions from NSObject
	* Source/NSKeyValueCoding.m: Put key value coding methods here for
	clarity and ease of documentation.

2002-02-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTask.m: Removed NSLogs() accidantally left in after
	debugging. Reported by Fred Kiefer.
	* Tools/gdomap.c: Use syslog for logging ... patch by Matthias Klose
	<doko@cs.tu-berlin.de> almost entirely rewritten to be portable.
	* configure.in: Minor additions for time header/functions
	* configure: regenerated

2002-02-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSObjCRuntime.h: Fix error in last change ...
	GSSelectorFromName() should not create a new selector while
	HSSelectorFromNameAndTypes() should.

2002-02-22  Alexander Malmberg <alexander@malmberg.org>

	* Headers/gnustep/base/NSArray.h: insertion position api update.
	* Source/NSArray.m: insertion position api update.
	* Source/GSArray.m: insertion position api update.
	Make insertion position api consistent with sorting api.

2002-02-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSValue.m: Fixed bug in archiving NSValue objects ... was
	creating faulty archives which would crash on unarchiving.
	* Headers/Foundation/NSObjCRuntime.h: Made GS... function names more
	consistent with NeXT/Apple ones.  Provide new ivar handling API.
	Don't crash when asked for a class which does not exist.
	* Source/NSObject.m: partial conversion to new runtime api.
	* Source/NSData.m: partial conversion to new runtime api.  Don't
	raise an exception if a class we are deserializing does not exist.
	Just warn and return a nul class.
	* Source/NSArchiver.m: better clasname handling. 
	* Source/NSUnarchiver.m: try to gracefully handle the case where an
	archive contains the name of a class we don't have linked in to our
	code.
	* Source/NSPortCoder.m: ditto.

2002-02-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: locking erro fixed by Stephen brandon

2002-02-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSInvocation.h: Remove _argframe ivar
	* Source/NSInvocation.m: Simplify by removing _argframe ivar and
	using _frame throughout to hold arguments. Fix checks for valid frame.
	* Source/callframe.m: Initialise newly created frame with zeros so
	that setting an object in an invocation should work when the
	invocation is retaining its contents.
	* configure.in: Disable ffi and warn about it.
	* configure: regenerated
	* Source/NSRunLoop.m: ([acceptInputForMode:beforeDate:]) block until
	limit date even if no I/O is possible.
	* Source/NSUserDefaults.m: Patch by Alexander Malmberg to try all
	listed locales rather than giving up at first failure.
	* Headers/gnustep/base/GSUnion.h: Enclose types bitmask in brackets
	to avoid *all* types being included in the union!  Should decrease
	memory footprint and increase speed of many classes.
	* Source/NSString.m: ([stringByStandardizingPath]) memory leak
	fixed and windows path check fixed ... patch by Michael Scheibler.
	Also commented/documented the method.

2002-02-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Removed some code that was doing nothing,
	and tidied a little.

2002-02-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSPathUtilities.h: GSDefaultsRootForUser()
	function added.
	* Source/NSUser.m: Many alterations to do with correcting the
	file paths used to use GNUSTEP_USER_ROOT, and to get them to
	vary nicely when GSSetUserName() is called.  Added function
	GSDefaultsRootForUser() to get a defaults directory based on
	a new environment varibale, or use GNUSTEP_USER_ROOT.
	* Source/NSUserDefaults.m: Use GSDefaultsRootForUser()
	Fix a few bugs in setting up defaults database.
	Move defaults database to the Defaults subdirectory.
	* Source/Headers/GSIMap.h: Fix error in last commit.

2002-02-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: ([stringByExpandingTildeInPath]) fix bug in
	handling ~username/... format.
	* Headers/Foundation/GSIMap.h: GSIMapCleanMap() rewrote to empty
	the map efficiently.  Added an option to refrain from calling it
	when emptying a map that doesn't need keys and values releasing.
	* Source/GSAttributedString.m: don't clean maps on emptying.
	* Source/GSFFCallInvocation.m: ditto
	* Source/NSArchiver.m: ditto
	* Source/NSConnection.m: ditto
	* Source/NSObject.m: ditto
	* Source/NSPortCoder.m: ditto
	* Source/NSSerializer.m: ditto
	Changes inspired by Pierre-Tves Rivaille

2002-02-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.m: support for merging types and functions etc.
	* Tools/AGSIndex.m: ditto
	* Tools/AGSOutput.h: ditto
	* Tools/AGSOutput.m: ditto
	* Tools/autogsdoc.m: ditto
	Put stuff in place for merging info
	revert key-value coding changes.
	* Source/NSString.m: Fix bug in datausingEncoding:allowLossyConversion:
	pointed out by Stephen Brandon.

Mon Feb 11 15:11:31 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/GSString.m (NSImmutableString): Implemented copy,
	copyWithZone:, mutableCopy, mutableCopyWithZone:, so that the
	string can be copied, and the copy no longer tracks the parent.

2002-02-10  Michael Hanni <mhanni@sprintmail.com>

        * Source/NSObjCRuntime.m: changed NSAssert() to NSCAssert() from
        last change. Also added NSException.h include to make compile
        correctly and quietly.

2002-02-10  Manuel Guesdon <mguesdon@orange-concept.com>

	* Source/NSObject.m: changes to enable derived object KeyValueCoding 
		process chnages (EOGenericRecord for example).
               o added:
                _infoForInstanceVariableNamed:retType:retSize:retOffset:
                _getValueForKey:selector:type:size:offset:
                _setValueForKey:object:selector:type:size:offset:
                _handleQueryWithUnboundKey:
                _handleTakeValue:forUnboundKey:
               o modified:
                storedValueForKey:
                takeStoredValue:forKey:
                valueForKey:
                takeValue:forKey:
                To use added method.
        * Source/NSObjCRuntime.m:
               o added NSAssert in GSGetInstanceVariable() and 
                 GSSetInstanceVariable()
	* Headers/gnustep/base/NSKeyValueCoding: 
               o added:
                _infoForInstanceVariableNamed:retType:retSize:retOffset:
                _getValueForKey:selector:type:size:offset:
                _setValueForKey:object:selector:type:size:offset:
                _handleQueryWithUnboundKey:
                _handleTakeValue:forUnboundKey:

Sat Feb  9 01:45:48 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSBundle.m ([+bundleForTool:]): Removed.  We switch to a
	better API, which is to have a tool use +mainBundle, in the same
	way as applications do, to retrieve the main resource bundle for
	itself.
	([+mainBundle]): Modified to support tools as well as
	applications.
	* Headers/gnustep/base/NSBundle.h ([+bundleForTool:]): Removed.
	
2002-02-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSTask.h: New method -validatedLaunchPath to
	check that an executable exists at the specified path or any
	alternative version corresponding to host, OS, and library-combo
	directories.  Returns the actual path to the binary.
	* Source/NSTask.m: Implemented new mathod and added autogsdoc
	comments.
	* Source/NSBundle.m: Cotrrected error in comments.

2002-02-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSString.m: Additioanl method -immutableProxy
	* Source/NSString.m: ditto
	* Source/GSString.m: New classes for immutable proxy, one generic
	version, and one efficient version for accessing the main GNUstep
	mutable striong objects.
	* Source/GSAttributedString: use immutable proxy.
	New code to provide a proxy for a mutable string which will provide
	read-only access to it.

2002-02-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: ([-rangeOfCharacterFromSet:options:range:])
	fix to return NSNotFound as location if character not present -
	bug reported by Nicola Pero.

2002-02-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gsdoc.m: loader() if entity id is missing, try to load url as
	a file.
	* Tools/AGSParser.m: Fixes for handling typedefs, constants, varibales
	and functions.
	* Tools/AGSOutput.[hm]: ditto
	* Tools/AGSHtml.m: ditto
	Preliminary support for C language added.

2002-02-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile: use -WordMap flag with autogsdoc to cope with
	C-preprocessor constants that would otherwise confuse parsing.
	* Source/NSDictionary.m: Tidy to match interface.
	* Source/NSDistantObject.m: Tidy to match interface.
	* Source/NSPortCoder.m: Tidy to match interface.
	* Source/NSScanner.m: Tidy to match interface.  Remove some illegal
	semicolons after method names.
	* Source/NSTimer.m: Tidy to match interface.
	* Tools/AGSParser.h: Handle word mappings.
	* Tools/AGSParser.m: Handle word mappings and deal with function
	attributes.
	* Tools/autogsdoc.m: Handle word mappings and make default logging
	less verbose.

2002-02-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Fix some maptable problems when using non-local
	reference counts.
	* Source/NSMapTable.m: Improve warning logging for dodgy practices.
	* Source/NSHashTable.m: ditto
	* Tools/AGSHtml.m: A couple of minor fixes for systems where the xml
	parser does not discard whitespace as it should.

2002-02-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/manual: New directory containing Objective-C and
	GNUstep-base programming manual/tutorial produced at Brainstorm.
	The intention was to produce a pretty complete manual and then
	release it, but we ran out of funding, so I'm releasing the work
	to date.
	* Source/NSObject.m: Go back to using local refcounts now that new
	map table code is thoroughly tested.

2002-02-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Makefile.preamble: remove old GSI api support
	* Headers/Foundation/NSHashTable.h: ditto
	* Headers/Foundation/NSMapTable.h: ditto

2002-02-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSAttributedString.m: Move to assuming new GSI api.
	* Source/NSHashTable.m: ditto
	* Source/NSMapTable.m: ditto
	* Source/GSCountedSet.m: ditto
	* Source/GSDictionary.m: ditto
	* Source/GSFFCallInvocation.m: ditto
	* Source/NSArchiver.m: ditto
	* Source/NSConnection.m: ditto
	* Source/NSFileManager.m: ditto
	* Source/NSNotificationCenter.m: ditto
	* Source/NSObject.m: ditto
	* Source/NSPortCoder.m: ditto
	* Source/NSRunLoop.m: ditto
	* Source/NSSerializer.m: ditto
	* Source/NSUnarchiver.m: ditto

2002-02-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSHashTable.m: Fixed bug intorduced by last change to add
	error checking!!
	* Source/GSAttributedString.m: Make new or old GSI stuff optional.
	* Source/GSCountedSet.m: ditto
	* Source/GSDictionary.m: ditto
	* Source/GSFFCallInvocation.m: ditto
	* Source/NSArchiver.m: ditto
	* Source/NSConnection.m: ditto
	* Source/NSFileManager.m: ditto
	* Source/NSNotificationCenter.m: ditto
	* Source/NSObject.m: ditto
	* Source/NSPortCoder.m: ditto
	* Source/NSRunLoop.m: ditto
	* Source/NSSerializer.m: ditto
	* Source/NSUnarchiver.m: ditto
	Interim phase ... version of source which should build with new or
	old GSIMap and GSIArray APIs at the defination of GSI_NEW

2002-01-31  Adam Fedor  <fedor@gnu.org>

	* Old/*: Removed (now at
	ftp://ftp.gnustep.org/pub/gnustep/old/gnustep-obsolete.tar.gz).

2002-01-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSMapTable.m:
	* Source/NSHashTable.m: Add checks for nul tables and either log
	warnings and be tolerant, or raise exceptions.

Thu Jan 31 15:35:21 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSObject.m ([-doesNotRecognizeSelector:]): Modified
	exception message to print out if we are an instance or a class
	object.  For example, no longer 'IvarProxy does not recognize
	initWithClass:' but rather 'IvarProxy(class) does not recognize
	initWithClass:'.
	([-doesNotRecognize:]): Idem.
	([-subclassResponsibility:]): Similar change.
	([-shouldNotImplement:]): Similar change.
	([-notImplemented:]): Similar change.

2002-01-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSIArray.h: Use array as parameter to macros.
	* Source/GSAttributedString.m: Update for GSIArray change.
	* Source/GSCountedSet.m: Update for GSIArray change.
	* Source/GSDictionary.m: Update for GSIArray change.
	* Source/GSFFCallInvocation.m: Update for GSIArray change.
	* Source/NSArchiver.m: Update for GSIArray change.
	* Source/NSConnection.m: Update for GSIArray change.
	* Source/NSFileManager.m: Update for GSIArray change.
	* Source/NSNotificationCenter.m: Update for GSIArray change.
	* Source/NSObject.m: Update for GSIArray change.
	* Source/NSPortCoder.m: Update for GSIArray change.
	* Source/NSRunLoop.m: Update for GSIArray change.
	* Source/NSSerializer.m: Update for GSIArray change.
	* Source/NSUnarchiver.m: Update for GSIArray change.

2002-01-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSRunLoop.h: Go back to new version.
	* Source/NSRunLoop.m: Back to new (hopefully bug-free) version ...
	fixed a fence-post error in examining descriptors.  Enabled poll()
	support if the O/S supports it.  Converted to use standard debug
	logging keyed on NSRunLoop.  Fixed poll code to call any available
	event handler when an error occurs on a descriptor.
	* configure.in: Improve check for sa_len

2002-01-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSIMap.h: Fix bug cleaning table and add
	option to specify type of enumerator structure externally.
	* Headers/gnustep/base/NSHashTable.h: Modify to conform to MacOS-X
	documentation and to work with GSIMAP stuff.
	* Headers/gnustep/base/NSMapTable.h: ditto
	* Headers/gnustep/base/o_array.h: deleted
	* Headers/gnustep/base/o_cbs.h: deleted
	* Headers/gnustep/base/o_hash.h: deleted
	* Headers/gnustep/base/o_list.h: deleted
	* Headers/gnustep/base/o_map.h: deleted
	* Headers/gnustep/base/o_x_bas.h.in: deleted
	* Headers/gnustep/base/o_x_cbs.h.in: deleted
	* Source/GNUmakefile: Remove o_... rules
	* Source/GSTcpPort.m: Remove unused include file
	* Source/Makefile.postamble: remove o_... rules
	* Source/NSCallBacks.h: Remove o_... info
	* Source/NSCallBacks.m: remove o_... info
	* Source/NSHashTable.m: Rewrite to use GSIMAP
	* Source/NSMapTable.m: Rewrite to use GSIMAP
	* Source/NSObject.m: Use GSIMAP for reference counts.
	* Source/NSRunLoop.m: Fix function prototypes for map table callbacks.
	* Source/externs.m: Remove o_... stuff and tidy callbacks.
	* Source/o_array.m: deleted
	* Source/o_cbs.m: deleted
	* Source/o_cbs_char_p.m: deleted
	* Source/o_cbs_id.m: deleted
	* Source/o_cbs_int.m: deleted
	* Source/o_cbs_int_p.m: deleted
	* Source/o_cbs_void_p.m: deleted
	* Source/o_hash.m: deleted
	* Source/o_list.m: deleted
	* Source/o_map.m: deleted
	* Source/o_x_bas.m.in: deleted
	* Source/o_x_cbs.m.in: deleted
	Masses of changes to simplify codebase and standardise all maptable
	code.  Hopefully, the new NSMapTable code now conforms to the spec.

2002-01-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSRunLoop.h: revert
	* Source/NSRunLoop.m: revert
	Revert to earlier version temporarily, while I try to track down
	an obscure bug causing problems with some DO applications.

Tue Jan 29 13:49:23 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* configure.in: Removed garbage left over - doubled message
	for objc thread flags checking.
	* configure: Regenerated.

Tue Jan 29 10:57:30 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* Makefile.postamble (configure): Rule removed.  It was causing
	problems on systems without autoconf.
	(base.make, config.mak): Do not depend on configure.
	
2002-01-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSRunLoop.h: More updates to ivars.
	* Headers/Foundation/NSRunLoop.m: Completed re-entrancy fixes in
	(I hope) a reasonably efficient manner.

2002-01-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSRunLoop.h: Removed previously deprecated methods.
	Completely changed ivar layout.
	* Headers/Foundation/NSRunLoop.m: Removed previously deprecated methods.
	Completely changed ivar layout.  Modified most methods to work with
	changed ivar layout.  Now stores per-mode context information in a
	new GSRunLoopCtxt class - one instance for each mode used in each
	runloop instance.  Rewrite select() and poll() based mechanisms
	using the new class - should hopefully be more efficient and fix
	minor and obscure problems with re-entrancy.
	### WARNING ... radical change ... may be buggy ... WARNING ###

2002-01-23  Kaelin Colclasure  <kaelin@acm.org>

       * configure.in: Check for poll(2) system call and header file.
       * configure: Regenerated.
       * config.h.in: Regenerated.
       * Source/NSRunLoop.m ([-acceptInputForMode:beforeDate:]):
       Refactored to put all code specific to the select(2) system call
       into a separate method.
       ([-_pollInputForMode:withTimeout:]): New private method with two
       implementations. If HAVE_POLL is defined, the poll version is
       used. Otherwise, we fall back to select.

2002-01-25  Richard Frith-Macdonald <rfm@gnu.org>

	* acconfig.h: Add HAVE_SA_LEN
	* configure.in: Check for sa_len in sockaddr in struct ifreq
	* configure: regenerate
	* Headers/gnustep/base/config.h.in: regenerate
	* Tools/gdomap.c: Add patch by Pete French <pete@twisted.org.uk>
	to handle variable length socket addresses ... modified to work
	with the rest of the world where we don't have such things.

2002-01-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: Correct returns from within exception handler.
	* Source/NSUserDefaults.m: use NSDefaultRunLoopMode.
	* Headers/gnustep/unicode/gsm0338.h: New character set mapping.
	* Source/Unicode.m: Add support for the GSM default alphabet.
	* Headers/gnustep/base/GSIMap.h: Add support for macros update when
	built with GSM_NEW defined (for use with NSMapTable in future).
	Various source files updated to use new GSI macros.

Mon Jan 21 17:08:42 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/Makefile.postamble (after-uninstall): Removed GSConfig.h 
	and mframe.h when uninstalling.

2002-01-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: Wrap code in exception handlers to reset current
	runloop mode if an exception occurs ... may remove this again if the
	performance is too bad.
	Use initialiser for NSTimer to avoid having to put timers into the
	autorelease pool.
	* Headers/Foundation/NSTimer.h: Expose GNUstep initialiser since
	OpenStep and MacOS-X don't have one.

Wed Jan 16 13:46:24 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	Fixed dynamical loading of frameworks.
	* Source/NSBundle.m ([-_addFrameworkForClass:]): Fixed, should never
	be run during dynamical loading.
	* Source/NSBundle.m (_bundle_load_callback): Major simplification.
	Most code removed.  Should run faster too.
	([-load]): Do not DESTROY _bundle_load_callback's related
	variables.
	
Wed Jan 16 12:30:20 2002  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSBundle.m (_addFrameworkFromClass:): Fixed third argument
	of strncmp to be 12, not 12*sizeof(char).

2002-01-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSRunLoop.m: Modify to have a nil current mode if the loop
	is not running (MacOS-X compatibility) and documented the change
	for autogsdoc.

Tue Jan 15 02:53:56 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/Makefile.postamble (after-distclean): Always remove
	SSL.bundle, regardless of any flags.

2002-01-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSParser.m: Mostly implemented parsing of C declarations
	(function, typedef, constant and variable).

2002-01-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSArchiver.h: tidyups
	* Source/NSDictionary.m: tidyups
	* Tools/AGSParser.m: a couple of declaration parsing fixes added,
	along with quite a bit of debugging.  Function declaration parsing
	not yet working.

2002-01-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistributedNotificationCentre.m: Use NSHost user default
	to determine which server to connect to.
	* Tools/AGSParser.m: Minor parsing fixes ... correct GS_EXPORT

Wed Jan  9 11:55:54 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* configure.in: Call AC_CONFIG_AUX_DIR with
	$GNUSTEP_SYSTEM_ROOT/Makefiles arg so that gnustep-make's
	config.guess and config.sub are used.
	* configure: Regenerated.
	* config.guess: Removed.
	* config.sub: Removed.
	* install-sh: Removed.
	* mkinstalldirs: Removed.
	* Source/mframe/configure.in: Set AC_CONFIG_AUX_DIR to
	$GNUSTEP_SYSTEM_ROOT/Makefiles.
	* Source/mframe/configure: Regenerated.
	* Source/mframe/config.guess: Removed.
	* Source/mframe/config.sub: Removed.
	
Wed Jan  9 11:08:57 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* config.guess: Updated to latest version.
	* config.sub: Idem.
	
2002-01-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.h:
	* Tools/AGSHtml.m:
	* Tools/AGSIndex.h:
	* Tools/AGSIndex.m:
	* Tools/AGSOutput.h:
	* Tools/AGSOutput.m:
	* Tools/AGSParser.h:
	* Tools/AGSParser.m:
	* Tools/autogsdoc.m:
	* Tools/gsdoc-0_6_7.dtd:
	Updated for several changes ...
	Support documentation of instance variables
	Index class and category method names identically
	Extend index to have a listing of methods by unit
	Extend index to have a listing of ivariablese by class
	Use new extensions to double speed of generation of method
	indexes for classes.

2002-01-07  Adam Fedor  <fedor@gnu.org>

	* Version: 1.1.0
	* Documentation/news.texi: Update

	* Source/NSObject.m (GSGetValue): Add case for void return
	(suggestion from ml@sbuilders.com).

	* Resources/Languages/Dutch: Change currency to Euro.
	* Resources/Languages/French: Likewise.
	* Resources/Languages/German: Likewise.
	* Resources/Languages/Italian: Likewise.
	* Old languages files renamed to *.Old

2002-01-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.m: Minor speedup.
	* Tools/AGSOutput.m: Put something in place of empty descriptions.
	* Tools/AGSParser.m: Rewrite handling of standards information to fix
	bug in NO_GNUSTEP handling.
	* Source/GNUmakefile: Don't document concrete number stuff ... not
	public.

Sun Jan  6 22:33:55 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Tools/HTMLLinker.m: Rewritten to fixup links by link name rather
	than link file.  Can now be used to link HTML files generated by
	autogsdoc.
	* Tools/HTMLLinker.html: Updated for changes.
	* Tools/GNUmakefile: Install HTMLLinker.html.
	
2002-01-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/autogsdoc.m: Minor bugfix ... any .h file processed should
	also be processed as a .gsdoc file to produce indexes and html.
	* Tools/AGSHtml.m: List *all* methods for a class in its method
	summary, even if they are in categories or are documented in
	other files.

2002-01-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/autogsdoc.m: Simplify by removing SourceDirectory default.
	Change mechanism for handling multiple source files for one header
	(need capability to write dependency rules for make).
	* Tools/AGSParser.[hm]: Add mechanism to return list of source
	files on which a document depends.
	* Tools/gsdoc-0_6_7.dtd: Permit wider use of index element.
	* Tools/AGSHtml.m: ditto, and support indexing of category methods
	along with class methods.
	* Source/GNUmakefile (Base_AGSDOC_FLAGS): Remove the SourceDirectory
	option ... now assumed to be the current directory for simplicity.
	* Source/Base.gsdoc: Add class and protocol indexes.

2002-01-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile (Base_AGSDOC_FLAGS): Fix to use
	-HeaderDirectory and -SourceDirectory to get docs to build again...
	hopefully with both sets of make rules.

Fri Jan  4 15:44:02 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* base.make.in (GNUSTEP_BASE_HAVE_LIBXML): Define.
	* Source/GNUmakefile (Base_AGSDOC_FLAGS): Do not use
	-HeaderDirectory.
	(Base_HEADER_FILES_DIR): Define.
	* Source/GNUmakefile: Include documentation.make only if doc=yes
	is passed on the command line.
	* Tools/GNUmakefile: Idem.
	
2002-01-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/autogsdoc.m: Rearrange code somewhat and remove auto
	generation of index and 'up' links ... now requires an explicit
	-Up if you want one.  Fix to support multiple source files parsed
	per interface file.
	* Tools/GNUmakefile: Add -Up for documentation generation
	* Source/GNUmakefile: ditto

Fri Jan  4 11:42:23 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Tools/HTMLLinker.m: Implemented -FixupAllLinks, -PathMappings,
	-PathMappingsFile options.  Made -CheckLinks default to YES.
	Added support for specifying a directory as input or destination
	file, meaning all html files found in the directory.  Never
	attempt to fixup links starting with mailto: or news: or without a
	filename, even if running with -FixupAllLinks YES.
	* Tools/HTMLLinker.html: New file.
	
2002-01-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/autogsdoc.m: Fixup bug in html relocation code ... was
	failing to adjust string length variable correctly.

2002-01-03  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSString.h: Extern constant string class
	reference for Darwin added.  
	* Source/GSString.m ([NXConstantString +initialize]): Setup constant
	string class reference variable for Darwin.
	* Source/NSObject.m: Don't put reference count and zone with object
	on Darwin.
	* Source/behavior.m (NeXT_RUNTIME/behavior_class_add_class): Use NeXT 
	runtime	functions. Pass only one method_list at a time.
	(NeXT_RUNTIME/behavior_class_add_methods): Only look at one 
	method_list at a time.
	(NeXT_RUNTIME/search_for_method_in_list): Use NeXT runtime functions.

Thu Jan  3 19:38:42 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Tools/HTMLLinker.m: New tool.
	* Tools/GNUmakefile: Compile the new tool.
	* Tools/Makefile.preamble (ADDITIONAL_OBJCFLAGS): Use -Wall.
	
2002-01-03  Adam Fedor  <fedor@gnu.org>

	* Source/GSFFCallInvocation.m (gs_method_for_receiver_and_selector): 
	Correct test for class.

	* Source/GNUmakefile (AUTHORS): Remove target.
	* AUTHORS: Remove.
	* Admin/: Remove.
	* configure.bat: Likewise.

2002-01-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Header/Foundation/GSXML.h: Correction standards complience
	* Source/GSXML.m: A few documentation tidyups
	* Tools/autogsdoc.m: Some tidyups for improved performance
	and added code to relocate html documents.
	* Source/AGSIndex.[hm]: Minor API change to ease index handling,
	bugfix for class index generation.
	* Source/AGSHtml.m: Made index handling more consistent.

2002-01-02  Adam Fedor  <fedor@gnu.org>

	* configure.in: Show openssl as enabled by default in help. Check for
	more headers.
	* Source/NSTask.m: Move #includes to front, remove redundancies.

	* Source/GSXML.m ([(non-libxml)GSXMLNode +forwardInvocation]):
	Implement.

	* Documentation/GNUmakefile: Remove gnustep-base.texi
	* Documentation/install.texi: Update.
	* Documentation/news.texi: Likewise.

	* Tools/autogsdoc.m (main): When no libxml, abort with a useful error
	message.

2002-01-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSXML.m: Tidied some methods and added autogsdoc comments.
	* Source/NSData.[hm]: implement ([-writeToURL:atomically:])
	* Source/GSXML.[hm]: Tidy document API to be more consistent
	with other classes.  Add some autogsdoc comments.
	* Tools/AGSIndex.m: Bugfix in setting links to superclasses.
	* Tools/AGSOutput.m: Infinite recursion fix.

2002-01-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile: Use new -Standards flag for autogsdoc
	* Tools/AGSparser.[hm]: New support for standards and some tidyups
	* Tools/AGSHtml.[hm]: Improved output and simplified a little.
	* Tools/autogsdoc.m: New Standards flag to turn on support for
	generation of standards complience notes in documentation.

Tue Jan  1 11:18:35 2002  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSFileManager.m (custom_strdup): New inline function
	to simplify code.  (append_file_to_path): Use it.
	([NSDirectoryEnumerator -initWithDirectoryPath:
	recurseIntoSubdirectories:followSymlinks:justContents:]):
	Idem.
	([NSDirectoryEnumerator -nextObject]): Fixed memory leak (Reported
	by Brian Alliet <brian@brian-web.com>).

2001-12-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/behavior.m: behavior_class_add_methods() bugfix to ensure
	that despatch table is updated properly.
	search_for_method_in_list() deleted ... use version in gnu runtime.
	* Source/NSUserDefaults.m: Removed use of distributed lock ... we
	use atomic writes to file, so we don't need it.  Also restructured
	a little to reduce file accesses when synchronising.  Also tidied
	comments a little for autogsdoc.

2001-12-29  Adam Fedor  <fedor@gnu.org>

	* Source/behavior.m (class_add_behavior): Add depreciated function 
	back.

2001-12-27  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h: Disable __builtin functions
	for GCC < 3.x (darwin).
	
	* Headers/gnustep/base/behavior.h: New defs for darwin/NeXT. Remove
	depreciated function.
	* Source/GSSet.m (+initialize): Use new behavior function in place
	of depreciated one.
	* Source/behavior.m (behavior_class_add_class): On darwin, allow
	NXConstantString class to increase in size.
	(behavior_class_add_category): New/rewrite for darwin methodLists 
	structure.
	(behavior_class_add_methods): Likewise.
	(search_for_method_in_list): Likewise.
	
	* Source/NSObject.m: Move ALIGN definition outside of #if
	(NSDecrementExtraRefCountWasZero): Change NSAssert to NSCAssert.

	* Source/mframe.m (method_types_get_first_argument): Use
	method_types_get_next_argument.

	* Source/Makefile.preamble: Additional flags for darwin linking.

	* Source/libgnustep-base.def: Updated for new/removed classes.

2001-12-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/autogsdoc.m: Add options for better control of index file and
	turning off dependency checking (for slightly more efficient running
	under make).  Also added flag to enable/disable html generation.
	* Tools/AGSHtml.m: Fix a few errors in achnors and links to document
	titles.

2001-12-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/autogsdoc.m: Fix bug in handling args introduceed by last
	modification.  Removed next and prev linkage at Nicolas suggestion.

2001-12-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/autogsdoc.m: Simplify file processing and cleanup so that
	spurious linkage and indexing is not done when run on a single file.

Fri Dec 21 13:50:50 2001  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSBundle.m ([+bundleForLibrary:]): New method.
	([+bundleForTool:]): New method.
	* Headers/gnustep/base/NSBundle.h: Declare them.

Fri Dec 21 11:48:49 2001  Nicola Pero  <nicola@brainstorm.co.uk>
	
	* NSTimeZones/Makefile.postamble (timezonedir, before-install):
	Unused targets removed.

2001-12-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSXML.m: Check validation status at parse completion.
	* Source/NSUserDefaults.m: Ensure flags are initialised.
	* Source/GSCompatibility.m: Set GNUstep DTD for propertyLists.
	* Tools/plist-0_9.dtd: GNUstep property list DTD.
	* Source/autogsdoc.m: Improve dependency checking ... only regenerate
	project index when necessary, thus avoiding some gsdoc file parsing.

Wed Dec 19 02:17:09 2001  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSThread.m (GSRegisterCurrentThread): Use @defs to 
	access protected variables of NSThread otherwise GCC 3.1 refuses to 
	compile it. 
	(GSUnregisterCurrentThread): Idem.

Tue Dec 18 18:02:07 2001  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSObject.m ([+conformsToProtocol:]): Fixed - it was
	checking that the metaclass conforms to the protocol rather than
	the class, which was causing it to fail for protocols implemented
	in categories.

2001-12-18  Richard Frith-Macdonald <rfm@gnu.org>

	Many source files modified to contain date, version, and title info.
	* Tools/AGSHtml.m: Fix 'standards' output.  Implement date and version.
	* Tools/AGSOutput.m: Add 'standards' support for class, category,
	and protocol.  Use new standards info from parser.
	* Tools/AGSParser.h: New method to set current standards.
	* Tools/AGSParser.m: Implement simplistic parsing of preprocessor
	conditionals to set current standards based on STRICT_MACOS_X,
	STRICT_OPENSTEP, and NO_GNUSTEP.  The presence of <standards>
	markup in the comments still takes precedence over this mechanism.

2001-12-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSXML.m: Bugfixes in setting parse behavior ... now turns
	on validation properly.
	* Tools/gsdoc-0_6_7.dtd: added 'scope' to index element and
	added a 'title' type to list files in a project.
	* Tools/AGSHtml.h:
	* Tools/AGSHtml.m: Output tidyups and general format improvements.
	Add links to other documents in project.  Add support for 'index'
	element with both file and project scope.
	* Tools/autogsdoc.m: Clean up a little and handle gsdoc files
	listed as source files better .... now looks for them in the
	source directory.  Added automatic generation of an 'index' file
	for a project where the first source file listed in the project
	is not a gsdoc file.

2001-12-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/GSMime.h: Updates for autogsdoc
	* Headers/gnustep/base/GSXML.h: ditto
	* Headers/gnustep/base/NSArray.h: ditto
	* Headers/gnustep/base/NSAttributedString.h: ditto
	* Headers/gnustep/base/NSAutoreleasePool.h: ditto
	* Headers/gnustep/base/NSCalendarDate.h: ditto
	* Headers/gnustep/base/NSCharacterSet.h: ditto
	* Headers/gnustep/base/NSCoder.h: ditto
	* Headers/gnustep/base/NSConnection.h: ditto
	* Headers/gnustep/base/NSData.h: ditto
	* Headers/gnustep/base/NSDate.h: ditto
	* Headers/gnustep/base/NSDistantObject.h: ditto
	* Headers/gnustep/base/NSDistributedNotificationCenter.h: ditto
	* Headers/gnustep/base/NSInvocation.h: ditto
	* Headers/gnustep/base/NSLock.h: ditto
	* Headers/gnustep/base/NSMethodSignature.h: ditto
	* Headers/gnustep/base/NSNotification.h: ditto
	* Headers/gnustep/base/NSObject.h: ditto
	* Headers/gnustep/base/NSProxy.h: ditto
	* Headers/gnustep/base/NSRunLoop.h: ditto
	* Headers/gnustep/base/NSSet.h: ditto
	* Headers/gnustep/base/NSTimeZone.h: ditto
	* Headers/gnustep/base/NSTimer.h: ditto
	* Headers/gnustep/base/NSURL.h: ditto
	* Headers/gnustep/base/NSUndoManager.h: ditto
	* Headers/gnustep/base/NSUserDefaults.h: ditto
	* Headers/gnustep/base/NSValue.h: ditto
	* Source/GSArray.m: ditto
	* Source/GSAttributedString.m: ditto
	* Source/GSCompatibility.m: ditto
	* Source/GSCountedSet.m: ditto
	* Source/GSDictionary.m: ditto
	* Source/GSFFCallInvocation.m: ditto
	* Source/GSFFIInvocation.m: ditto
	* Source/GSFormat.m: ditto
	* Source/GSHTTPURLHandle.m: ditto
	* Source/GSLocale.m: ditto
	* Source/GSMime.m: ditto
	* Source/GSSet.m: ditto
	* Source/GSString.m: ditto
	* Source/GSTcpPort.m: ditto
	* Source/GSUnixSSLHandle.m: ditto
	* Source/GSValue.m: ditto
	* Source/GSXML.m: ditto
	* Source/NSArchiver.m: ditto
	* Source/NSArray.m: ditto
	* Source/NSAssertionHandler.m: ditto
	* Source/NSAttributedString.m: ditto
	* Source/NSAutoreleasePool.m: ditto
	* Source/NSBitmapCharSet.m: ditto
	* Source/NSBundle.m: ditto
	* Source/NSCalendarDate.m: ditto
	* Source/NSCallBacks.m: ditto
	* Source/NSCharacterSet.m: ditto
	* Source/NSClassDescription.m: ditto
	* Source/NSCoder.m: ditto
	* Source/NSConnection.m: ditto
	* Source/NSCopyObject.m: ditto
	* Source/NSCountedSet.m: ditto
	* Source/NSData.m: ditto
	* Source/NSDate.m: ditto
	* Source/NSDateFormatter.m: ditto
	* Source/NSDebug.m: ditto
	* Source/NSDecimal.m: ditto
	* Source/NSDecimalNumber.m: ditto
	* Source/NSDictionary.m: ditto
	* Source/NSDistantObject.m: ditto
	* Source/NSDistributedLock.m: ditto
	* Source/NSDistributedNotificationCenter.m: ditto
	* Source/NSEnumerator.m: ditto
	* Source/NSException.m: ditto
	* Source/NSFileHandle.m: ditto
	* Source/NSFileManager.m: ditto
	* Source/NSFormatter.m: ditto
	* Source/NSGeometry.m: ditto
	* Source/NSHashTable.m: ditto
	* Source/NSHost.m: ditto
	* Source/NSInvocation.m: ditto
	* Source/NSLock.m: ditto
	* Source/NSLog.m: ditto
	* Source/NSMapTable.m: ditto
	* Source/NSMethodSignature.m: ditto
	* Source/NSNotification.m: ditto
	* Source/NSNotificationCenter.m: ditto
	* Source/NSNotificationQueue.m: ditto
	* Source/NSNull.m: ditto
	* Source/NSNumber.m: ditto
	* Source/NSNumberFormatter.m: ditto
	* Source/NSObjCRuntime.m: ditto
	* Source/NSPage.m: ditto
	* Source/NSPipe.m: ditto
	* Source/NSPort.m: ditto
	* Source/NSPortCoder.m: ditto
	* Source/NSPortMessage.m: ditto
	* Source/NSPortNameServer.m: ditto
	* Source/NSProcessInfo.m: ditto
	* Source/NSProtocolChecker.m: ditto
	* Source/NSProxy.m: ditto
	* Source/NSRange.m: ditto
	* Source/NSRunLoop.m: ditto
	* Source/NSScanner.m: ditto
	* Source/NSSerializer.m: ditto
	* Source/NSSet.m: ditto
	* Source/NSString.m: ditto
	* Source/NSTask.m: ditto
	* Source/NSThread.m: ditto
	* Source/NSTimeZone.m: ditto
	* Source/NSTimer.m: ditto
	* Source/NSURL.m: ditto
	* Source/NSURLHandle.m: ditto
	* Source/NSUnarchiver.m: ditto
	* Source/NSUndoManager.m: ditto
	* Source/NSUser.m: ditto
	* Source/NSUserDefaults.m: ditto
	* Source/NSValue.m: ditto
	* Source/NSZone.m: ditto
	* Source/Unicode.m: ditto
	* Source/UnixFileHandle.m: ditto
	* Source/WindowsFileHandle.m: ditto
	* Source/behavior.m: ditto
	* Source/callframe.m: ditto
	* Source/cifframe.m: ditto
	* Source/externs.m: ditto
	* Source/libgnustep-base-entry.m: ditto
	* Source/mframe.m: ditto
	* Source/o_array.m: ditto
	* Tools/AGSParser.m: ditto
	Ensure that initial comments in source code are sutogsdoc comments
	so copyright and author information will be used.
	Fix inconsistencies between arguments in headers and source files.
	Fix various bugs exposed by autogsdoc ... mostly cases where there
	is a semicolon after a method name in a method implementation
	(this is illegal, but the gcc compiler currently ignores it).

2001-12-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSHtml.m: Provide list of methods in each class.
	* Tools/AGSIndex.m: New method to list methods in a unit.
	* Tools/AGSIndex.h: New method to list methods in a unit.
	* Tools/AGSOutput.m: Support (name) syntax for specifying a protocol
	cross reference using [(name)-method]
	* Tools/autogsdoc.m: Improve documentation of method references.
	* Tools/AGSparser.m: Handle @class statements. Improve standardisation
	of the format of types.

2001-12-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Make initial comment an autogsdoc comment.
	* Tools/gsdoc-0_6_7.dtd: Fix protocol error reported by Adam
	* Tools/AGSHtml.h:
	* Tools/AGSHtml.m:
	* Tools/AGSIndex.h:
	* Tools/AGSIndex.m:
	* Tools/AGSOutput.h:
	* Tools/AGSOutput.m:
	* Tools/AGSParser.h:
	* Tools/AGSParser.m:
	* Tools/autogsdoc.m: Tidied initial comments to take advantage of
	new code to parse author and copyright details.  Fixed several
	minor bugs in various parts of the software.  Updated documentation.

2001-12-15  Fred Kiefer <FredKiefer@gmx.de>

	* Tools/pl2link.m
	Better handling of MIME types.

2001-12-15  Richard Frith-Macdonald <rfm@gnu.org>

	Many minor cleanups and bugfixes for autogsdoc.  Alpha-test support
	for building base library documentation using autogsdoc ... lots of
	work remains to be done to improve the html output from autogsdoc
	and to add autogsdoc comments to the base library source code.
	* Tools/AGSIndex.h: improve merge control
	* Tools/AGSIndex.m: ditto
	* Tools/AGSHtml.h: new methods for cleaner indexing.
	* Tools/AGSHtml.m: ditto
	* Tools/AGSParser.m: minor bugfixes.
	  Tools/GNUmakefile: Build autogsdoc documentation using autogsdoc.
	* Tools/autogsdoc.m: Fix minor dependency error.  Fix for indexing
	where a version of the project being built is already installed.
	* Tools/gsdoc-0_6_7.dtd: Fix ivar support
	* Source/GSFFCallInvocation.m: minor debug output improvement.
	* Source/GNUmakefile: add basic instructions to build (but not install)
	documentation using autogsdoc.  Don't want to install yet, as this is
	very much alpha-test stuff.

2001-12-13  Adam Fedor  <fedor@gnu.org>

	* Tools/pl2link.m: New file (from FredKiefer@gmx.de).

2001-12-12  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSDebug.h: Include NSDebugLog functions
	when GSDIAGNOSE is defined.

2001-12-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPURLHandle.m: Remove GSHTPPropertyBodyKey ... make
	the ([writeData:]) method do nothing until the page is reloaded,
	so its behavior is consistent with ([writeProperty:forKey:]) and
	can be used in conjunction with background loading (ie all I/O
	is done during the load).
	* Source/NSURL.m: load resource data after setting it to force I/O

2001-12-11  Manuel Guesdon <mguesdon@orange-concept.com>

	* Source/NSString.m: corrected  bug in +stringByTrimmingSpaces 
		(there was an exception when the string contains only spaces).

2001-12-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/gsdoc/NSDistantObjectRequest.gsdoc: note that the
	class does not exist (and why).

2001-12-08  Gregory Casamento <greg_casamento@yahoo.com>
	* Source/GNUmakefile added SSL_LIB_DIRS += -L$(GNUSTEP_OBJ_DIR)
	to prevent build from failing when building from scratch.
	
2001-12-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAttributedString.m: ([initWithCoder:]) fix typo.

2001-12-07  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSDebug.h: Add NSDebugLog functions
	when GSWARN is defined (not DEBUG).

2001-12-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPURLHandle.m: Understand GSHTPPropertyBodyKey so we
	can set data to be posted in background.

2001-12-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile: Add library dependencies for SSL bundle ...
	it needs libobjc and libgnustep-base to be linked.
	* Source/NSFileHandle.m: Only try to load SSL bundle if asked for.

Mon Dec  5 16:32:31 2001  Adam Fedor  <fedor@yogi.doc.com>

	* Source/GSHTTPURLHandle.m: Include sys/fcntl.h for O_WRONLY, etc
 	(on Solaris).

2001-12-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile: Add flags for SSL and rules to build bundle
	* Source/GSHTTPURLHandle.m: use +sslClass
	* Source/GSUnixSSLHandle.m: Extract SSL support for bundle to this file.
	* Source/Makefile.preamble: Add flags for SSL
	* Source/NSFileHandle.m: Add +sslClass and automated loading of bundle
	* Source/UnixFileHandle.m: Remove SSL support.
	* Headers/gnustep/base/NSFileHandle.h: Add +sslClass
	* Headers/gnustep/base/UnixFileHandle.h: Tidy a little.
	* config.mak.in: Add variables needed by SSL bundle
	* configure.in: Update to build SSL bundle by default.
	* configure: regenerated
	The above changes made to move SSL support into a bundle and add a
	+sslClass to NSFileHandle to return the class from the bundle if it
	is available.  Changed the http url handle support to use this.

2001-12-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSValue.m: polish last set of changes -
	Optimisation ... cut memory allocation/deallocation to a minimum.
	Versioning ... set NSValue version number and attempt to decode
	old format objects.
	Simplification ... remove redundant code in placeholder class.
	Fixes ... allocate new objects in correct memory zone, I think a few
	others I forgot.
	* Source/NSNumberFormatter.m (-initWithCoder:): Avoid unnecessary
	autorelease/retain sequences. (-init): Fix illegal re-initialisation
        of initialised values and avoid unnecessary use of autorelease.

2001-12-03  Laurent Julliard  <laurent@moldus.org>

	* Source/NSNumberFormatter.m (-initWithCoder:): decoded objects
	must be retained

2001-12-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSValue.m: Fix coding/decoding to use serialization code to
	maintain byte order and word size compatibility.
	* Source/GSValue.m: ditto
	* Testing/values.m: added encoding/decoding tests.
	* Source/GSMime.m: Tidied handling of continuations a little.
	* Source/GSHTTPURLHandle.m: Added some debug logging.

Sat Dec  1 10:11:18 2001  Nicola Pero  <n.pero@mi.flashnet.it>

	* Makefile.postamble (base.make): Depend on configure.
	(config.mak): Idem.

Sat Dec  1 09:29:43 2001  Nicola Pero  <n.pero@mi.flashnet.it>

	* Makefile.postamble (base.make): New target.
	(config.mak): New target.

2001-11-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSScanner.m: Fix memory leak when initialised with something
	other than a constant string.

2001-11-28  Adam Fedor  <fedor@gnu.org>

	* Documentation/gsdoc/Base.gsdoc: Add NSLanguages summary.

2001-11-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: Put a limit of around a second on how long
	the delay between polling for incoming packets can grow to ...
	improve response on heavily loaded systems.
	* Source/GSHTTPURLHandle.m: ditto
	* Tools/autogsdoc.m: Tidied structure a little and added file
	modification date checks to see whether files should be regenerated
	or not.

2001-11-24  Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Foundation/NSURL.h
	Declare NSNumber, so that it compiles without complaining.
	
2001-11-23  Laurent Julliard  <laurent@julliard-online.org>

	* Source/NSNumberFormatter.m (-encodeWithCoder:, -initWithCode:):
	fixed buggy encoder and decoder and code cleanup.

2001-11-22  Laurent Julliard  <Laurent.Julliard@xrce.xerox.com>

	* Headers/gnustep/base/Foundation.h: Fixed NSNumberFormatter.h
	missing.

Thu Nov 22 00:52:57 2001  Nicola Pero  <n.pero@mi.flashnet.it>

	* GNUmakefile (CVS_MODULE_NAME): Define.

2001-11-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSOutput.m:
	* Tools/AGSOutput.h:
	* Tools/AGSIndex.h:
	* Tools/AGSIndex.m:
	* Tools/AGSParser.h:
	* Tools/AGSParser.m:
	* Tools/AGSHtml.h:
	* Tools/AGSHtml.m:
	* Tools/autogsdoc.m: Many bugfixes and enhancements ... generate
	html as well as gsdoc.

2001-11-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSXML.m: Implement NSCopying protocol for most classes.

2001-11-19  Adam Fedor  <fedor@gnu.org>

	* Source/simple-load.h (__objc_dynamic_get_symbol_path): Fix
	typo.

	* Tools/gdomap.c (nameServer): Print strerror before exiting for
	more helpful message.
	
2001-11-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m:
	* Headers/Foundation/NSUserDefaults.h:
	* Documentation/gsdoc/NSUserDefaults.gsdoc:
	* Source/NSUserDefaults.m: Changed the method name +resetUserDefaults
	to be +resetStandardUserDefaults for compatibility with MacOS-X, which
	has now implemented an equivalent for the GNUstep method.
	* Source/NSPortNameServer.m: When removing a port, remove from
	internal name tables even if gdomap reports no name to unregister.
	In ([-removePort:]) retain set of names for duration of operation -
	fix suggested by Gerrit Van Dyk

2001-11-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSNumber.m: describe char and unsigned char as numbers
	rather than ascii characters.  Use g format for floats.
	Use 'true' and 'false' for boolean output ... for MacOS-X compatibility.
	* Source/NSConcreteNumber.m: ditto
	* Source/GSFormat.m: Fix bug in formatting short integers - was trying
	to treat them as full sized.
	* headers/Foundation/NSString.h: Fix error in initWithFormat:locale:,...
	* Source/NSString.m: ditto ... was missing varargs
	* Documentation/gsdoc/NSNumber.gsdoc: document changes.
	* Documentation/gsdoc/NSString.gsdoc: document changes.
	* Testing/values.m: Added some number output tests.
	* Source/NSUserDefaults.m: Locking bug fixed ... was locking before
	lock had been created.
	* Source/libgnustep-base.def: Removed defunct class
	* Source/NSHost.m: Support initialisation with an address for which
	there is no corrsponding host name.

2001-11-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/gsdoc/Base.gsdoc:
	* Source/GSCompatibility.m:
	* Source/GSMime.m:
	* Source/GSUserDefaults.h:
	* Source/NSArray.m:
	* Source/NSCalendarDate.m:
	* Source/NSDate.m:
	* Source/NSDecimalNumber.m:
	* Source/NSDictionary.m:
	* Source/NSFileHandle.m:
	* Source/NSGeometry.m:
	* Source/NSLog.m:
	* Source/NSScanner.m:
	* Source/NSString.m:
	* Source/NSUserDefaults.m: Modify user defaults usage to cache some
	defaults used internally and provide private accessors for speed.
	Add default to force logging to be done via syslog since logging
	to stderr within code called via JIGS from a servlet engine may
	cause severe problems if the servlet engine is using descriptor 2
	for other purposes.

2001-11-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSMime.m: modifications made to support HTTP continuation
	responses for buggy webservers which send them when they shouldn't.

2001-11-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSHTTPHURLHandle.m: handle writing of nil properties and
	use of empty strings as proxy settings.  Minimise delays when
	tunneling SSL
	* Source/UnixFileHandle.m: Improve error logging with ssl.

2001-11-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/foundation/NSUserDefaults.h: Add _lock ivar
	* Source/NSUserDefaults.m: initial attempt at thread-safety.

2001-11-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSString.h: removed stringByTrimming...Whitespace
	methods as they just duplicate the stringByTrimming...Spaces
	* Source/NSString.m: ditto
	Optimised the space trimming methods - avoid using character sets and
	creating unnecessary intermediary objects.

2001-11-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: force defaults data to be read/write
	only to the user.  Supplied by Ludovic Marcotte

Wed Nov  7 09:04:51 2001  Nicola Pero  <n.pero@mi.flashnet.it>

	After this change you need the latest gnustep-make to compile.
	* Source/Makefile.postamble: Removed rules to manually compile
	NSInvocation.m, NSConnection.m and mframe.m.
	(mframe.m_FILE_FILTER_OUT_FLAGS): Set to filter out optimization
	flags when compiling mframe.m.
	(NSConnection.m_FILE_FILTER_OUT_FLAGS): Idem.
	(NSInvocation.m_FILE_FILTER_OUT_FLAGS): Idem.
	
2001-11-01  Adam Fedor  <fedor@gnu.org>

	* Source/NSData.m: Add an include to avoid some warnings.

Tue Oct 30 14:33:48 2001  Nicola Pero  <nicola@brainstorm.co.uk>

	* Testing/benchmark.m (bench_object): Added test showing that a
	call to super in a category method - no matter if a class or an
	instance method - has the same big performance hit that a class
	method invocation has - at least with the current GNU runtime.

2001-10-28  Adam Fedor  <fedor@gnu.org>

	* Source/NSFileManager.m (_attributesAtPath:traverseLink:forCopy:): 
	Make NSLog message into fprintf to avoid recursion.

	* Source/NSUserDefaults.m (pathForUser): Create ~/GNUstep/Library
	if it doesn't exist.

2001-10-26  Adam Fedor  <fedor@gnu.org>

	* configure (z): Check for gzseek in zlib since older zlibs don't
	have it. Fix check for LLONG_MAX (check if includes exist), same
	with uintmax_t
	* Source/GSFormat.h: Include stdint.h or inttypes.h if we have it.
	Proper check for LONG_LONG_MAX or LLONG_MAX.

2001-10-25  Adam Fedor  <fedor@gnu.org>

	* aclocal.m4 (AC_SYS_PROCFS): Typo fix, use AC_ARG_ENABLE. Make
	sure cache var is set to no if disabled.
	(AC_SYS_PROCFS_EXE_LINK): Likewise.

	* configure.in: Check for LLONG_MAX. Check for -lcipher.
	(Patch from chrisv@web4inc.com with modifications).
	* Source/GSFormat.m: If we have LLONG_MAX, define LONG_LONG_MAX
	to match.
	* Source/NSScanner.m: Likewise.

2001-10-24  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.in: Check for zlib
	* Headers/gnustep/base/GSConfig.h.in: Define HAVE_ZLIB
	* Headers/gnustep/base/NSFileHandle.h: Add useCompression extension
	* Headers/gnustep/base/UnixFileHandle.h: ditto
	* Source/UnixFileHandle.m: Add support for read/write with compression
	using zlib.  Activate with -useCompression

2001-10-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSNumberFormatter.h: ivars aded and updated.
	* Source/NSNumberFormatter.m: implemented dealloc, copy, coding and
	all the ivar setting/getting methods.

2001-10-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: ([+stringWithCString:]) check for nul pointer.

2001-10-17  Adam Fedor  <fedor@gnu.org>

	* configure.in (GNUSTEP_LDIR): Look for libobjc in
	.../$LIBRARY_COMBO first.

2001-10-16  Adam Fedor  <fedor@gnu.org>

	* Source/GNUmakefile: Strip drive names from paths.

	* Source/GSXML.m: Add dummy GSXMLParser when not using libxml.
	* Source/NSBundle.m (_absolutePathOfExecutable:): Check for
	'Path' variable also (for Windows).
	* Source/NSUser.m (GSStringFromWin32EnvironmentVariable): New
	function.
	(NSHomeDirectoryForUser): Use it.
	(setupPathNames): Prepend systemDrive to compiled in root
	paths.
	(patches from stephen@brandonitconsulting.co.uk).

	* Source/NSFileManager.m (_attributesAtPath:traverseLink:forCopy:):
	On (sparc && DEBUG) disable the setgrent functions which cause gdb
	to crash.

2001-10-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GNUmakefile:
	* Source/GSXML.m:
	* Headers/Foundation/GSXML.h: Build and install dummy version if
	libxml is not available.
	* Tools/GNUmakefile:
	* Tools/AGSIndex.h:
	* Tools/AGSIndex.m:
	* Tools/AGSOutput.h:
	* Tools/AGSOutput.m:
	* Tools/AGSParser.h:
	* Tools/AGSParser.m:
	* Tools/autogsdoc.m: Many bugfixes and additions, bew code to
	generate indexes.

2001-10-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/AGSOutput.m: Added new 'unit' pseudo-markup to permit
	control over chapter layout for a chapter containing class,
	category, or protocol documentation.

2001-10-14  Fred Kiefer <FredKiefer@gmx.de>

	* Source/Unicode.m: 
	In iconv_cstrtoustr() and iconv_ustrtocstr() report if a iconv
	conversion cannot be found. Also added a type convert to the iconv
	call, so that the compiler wont report a type mismatch.
	
2001-10-13  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSPathUtilities.h (GSSystemRootDirectory): 
	New function.
	* Source/GNUmakefile: Define GNUSTEP_LOCAL_ROOT and
	GNUSTEP_NETWORK_ROOT paths on compile line.
	* Source/NSUser.m (setupPathNames): Use compiled in paths as backup
	if environment variables not found.
	(GSStandardPathPrefixes): Make sure a non-nil result is returned.
	(GSSystemRootDirectory). Implement.
	* Source/NSDistributedNotificationCenter.m (_connect): Use it to
	find gdnc.
	* Source/NSPortNameServer.m (initialize): Use it to find gdomap.

2001-10-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFFCallInvocation.m: Change #import to #include
	* Source/NSProtocolChecker.m: Change #import to #include
	* Testing/containers.m: Change #import to #include
	* Tools/AGSOutput.h: Return string rather than writing to file
	* Tools/AGSOutput.m: Return string rather than writing to file
	* Tools/autogsdoc.m: Hnalde file writing.
	* Tools/plmerge.m: Change #import to #include

2001-10-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/GNUmakefile: Addend new files.
	* Tools/AGSOutput.h: Support class for autogsdoc
	* Tools/AGSOutput.m: ditto
	* Tools/AGSParser.h: ditto
	* Tools/AGSParser.m: ditto
	* Tools/autogsdoc.m: New tool to generate gsdoc files from ObjC
	header and source files.  Uses comments with a '/**' prefix
	(like javadoc) to provide nice information about classes and/or
	methods.
	This is very much an initial/alpha version but it is already
	quite useful.

2001-10-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: Increase default timeouts to max value.
	Improve algorithm for polling for messages when waiting for a reply
	in multithreaded mode ... use fibonacci sequence for delays rather
	than doubling each time.
	* Headers/Foundation/NSConnection.h: Remove default timeout constant.
	* configure.in: Check for float.h, not for values.h
	* Documentation/gsdoc/NSConnection.gsdoc: updated.

2001-10-05  Richard Frith-Macdonald <rfm@gnu.org>

	* NSTimeZones/NSTimeZones.tar: Updated to latest info.

2001-10-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLog.m: _NSLog_standard_printf_handler() modified to output
	message as UTF8 data if it can't be done as ASCII

2001-09-27  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSString: setupQuotables() ... add several characters to the
	set of those valid in an unquoted string ... so read back of NSNumber
	values encoded as strings works ... problem reported by Rene Cornilis.

2001-09-26  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/GNUmakefile: install DistributedObjects.h in gnustep/base
	rather than Foundation .... but it's an internal header - should
	it be installed at all?

2001-09-25  Adam Fedor  <fedor@gnu.org>

	* configure.in: Typo in saving CPPFLAGS during iconv test.

2001-09-21  Adam Fedor  <fedor@gnu.org>

	* configure.in: Typo in iconv cached value.
	* Headers/gnustep/base/NSGeometry.h: Make const values static also.
	* Source/NSConnection.m: Remove obsolete BROKEN_NESTED code.
	* Source/Unicode.m: Dynamically determine best Unicode encoding.

2001-09-21  Richard Frith-Macdonald <rfm@gnu.org>

        * Headers/gnustep/base/DistributedObjects.h:
        * Source/GSFFCallInvocation.m:
        * Source/NSConnection.m:
        * Source/NSInvocation.m:
        * Source/callframe.h:
        * Source/callframe.m:
	Modifications to callframe handling to store pointers to data to
	be freed in order to be able to tidy up after an exception ...
	Appears to cure memory leak in ffcall code.
	No fix yest for mframe or ffi code.

2001-09-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Testing/nsconnection_client.m: Added simple exception tests
	* Testing/nsconnection_server.m: Added simple exception tests
	* Testing/server.h: Added simple exception tests

2001-09-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: rewrite ethod call code.
	* Source/callframe.h: ditto
	* Source/callframe.m: ditto
	* Source/cifframe.h: ditto
	* Source/cifframe.m: ditto
	* Source/mframe.m: ditto
	* Source/mframe/mframe.head: ditto
	* Headers/gnustep/base/DistributedObjects.h: Adde new DOContext struct.
	Rewrite code for moving data to/from method call stackframes and
	encoding/decoding it.  The functions to encode/decode each data item
	are no longer nested, and pass a context structure around which
	provides for more information to be passed between the various layers
	of the process so that the whole thing is thread-safe and we don't
	get cases where code in one place tries to work with an object that
	was released in another place.
	Tested pretty extensively for libffcall stuff, with the simple test
	programs for maframe, and not at all for libffi.

2001-09-19  Adam Fedor  <fedor@gnu.org>

	* configure.in: Put CPPFLAGS in quotes

2001-09-14  Adam Fedor  <fedor@gnu.org>

	* configure.in: Remove redundancies in iconv checking. Remove
	redundant AC_SUBST(LIBS) lines.

2001-09-12  Adam Fedor  <fedor@gnu.org>

	* Source/thr-pthread.m (objc_yield): Replace pthread_yield with 
	sched_yield.

2001-09-11  Adam Fedor  <fedor@gnu.org>

	* configure.in: Make sure to subst HAVE_PTHREAD_H into config.mak

2001-09-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSCompatibility.m: GSXMLPlMake() unused argument removed.
	* Source/NSData.m: Unused and commented out XML plist code removed.
	* Source/NSString.m: ditto
	* Source/NSArray.m: Generate XML plists only when writing to file
	or to URL, not for the -description... methods.
	This is what MacOS-X does.
	* Source/NSDictionary.m: ditto

2001-09-05  Adam Fedor  <fedor@gnu.org>

	* configure.in: Define BROKEN_NESTED_FUNCTIONS if compiler sucks.
	* Source/NSArray.m (-sortedArrayUsingSelector:): Remove nested
	function.
	([NSMutableArray -sortUsingSelector:]): Likewise.
	* Source/NSConnection.m (-forwardForProxy:selector:argFrame:): 
	Use external encode/decode functions if BROKEN_NESTED_FUNCTIONS.
	(-forwardInvocation:forProxy:): Likewise.
	(-_service_forwardForProxy:): Likewise.
	* Source/mframe.m (mframe_build_return_opts): Remove and
	consolidate nested functions.
	(mframe_handle_return): Likewise.
	
2001-08-31  Adam Fedor  <fedor@gnu.org>

	* Resources/French/Localizable.strings: Update (from
	Michael Scheibler <michael.scheibler@onevision.de>).

Fri Aug 31 11:58:42 2001  Nicola Pero  <nicola@brainstorm.co.uk>

	* Documentation/gsdoc/NSFunctions.gsdoc: Documented the
	localization functions/macros: NSLocalizedString,
	NSLocalizedStringFromTable, NSLocalizedStringFromTableInBundle,
	NSLocalizedStaticString, _ and __.

2001-08-30  Adam Fedor  <fedor@gnu.org>

	* Tools/sfparse.m: Add code to convert files to Unicode.
	* Resources/German/Localizable.strings: Convert to Unicode.
	* Resources/French/Localizable.strings: Likewise.

Thu Aug 30 20:03:19 2001  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/objc-load.m (objc_load_module): Reset the load callbacks
	to 0 when we abort loading the module because of an error
	(Reported by Michael Scheibler <michael.scheibler@onevision.de>).

Thu Aug 30 13:08:17 2001  Nicola Pero  <nicola@brainstorm.co.uk>

	* Documentation/gsdoc/NSObject.gsdoc: Added description of the
	class; documented alloc, allocWithZone:, class, new, dealloc
	methods.

2001-08-29  Adam Fedor  <fedor@gnu.org>

	* Source/objc-gnu2next.m (next_objc_msg_send): Fix incorrect def.

Mon Aug 28 23:45:15 2001  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSCalendarDate.m ([+dateWithString:calendarFormat:]):
	Call alloc on self, rather than on the hardcoded NSCalendarDate
	class, so it works in subclasses.
	([+dateWithString:calendarFormat:locale:]): Idem.
	([+dateWithYear:month:day:hour:minute:second:timeZone:]): Idem.
	
2001-08-28 Georg Fleischmann <georg@vhf.de>

	* base/Source/NSCalendarDate.m [NSCalendarDate
	descriptionWithCalendarFormat:locale:]: make milliseconds
	work (%F)

2001-08-28  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h: More defs.
	* Source/NSObject.m (-methodSignatureForSelector:): Use sel_get_type.

	* Source/mframe.m (method_types_get_first_argument): New function.
	(method_types_get_sizeof_arguments): Likewise.
	* Source/objc-gnu2next.m (next_objc_msg_sendv): Use them.
	
2001-08-21  Willem Rein Oudshoorn  <woudshoo@xs4all.nl>

	* Source/GSFFCallInvocation.m: Clearified comments
	(gs_method_for_receiver_and_selector) added 
	(GSInvocationCallback): Check if forwardInvocation: is
	implemented to avoid infinite recursion bug.

Fri Aug 24 12:34:56 2001  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSUserDefaults.m ([-__createArgumentDictionary]): Make
	sure we don't crash trying to parse an argument as a property
	list.

Fri Aug 24 10:23:02 2001  Nicola Pero  <nicola@brainstorm.co.uk>

	* Resources/Italian.lproj/Localizable.strings: New file.
	* Resources/GNUmakefile (LANGUAGES): Added Italian.

2001-08-21  Adam Fedor  <fedor@gnu.org>

	* Resources/English.lproj/Localizable.strings: New file
	* Resources/German.lproj/Localizable.strings: Likewise.
	* Resources/French.lproj/Localizable.strings: Likewise.
	* Resources/GNUmakefile: Install them. (files from 
	michael.scheibler@onevision.de)
	
	* config/config.loadtest.m: Make Test inheret from Object 
	(Darwin objc checks that classes implement forward::).
	* config/config.objc.m: Likewise.

2001-08-20  Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>

	* Documentation/gsdoc/ NSPipe.{gsdoc, html}: this class has been 
	forgotten
	* Documentation/gsdoc/{Base, NSObject, NSPort}.{gsdoc, html}:
	updates to the links to show NSPipe

2001-08-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gsdoc.m: ([-initWithFileName:]) call xmlKeepBlanksDefault(0)
	to handle change in recent libxml whitespace handling.

2001-08-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistantObject.m: Tidy method lookup code.
	* Source/NSString.m: Handle nil content when parsing xml elements.

2001-08-06  Willem Rein Oudshoorn  <wim@xs4all.nl>

        * Source/GSFFCallInvocation.m: Forwarding:
        thread safe, handle missing typeinformation better,
        performance improvement.
	Minor tidyups by RFM

2001-08-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSMime.m: ([-decodeData:fromRange:intoData:withContext:])
	One line fix suggested by Stephen Brandon
	* Source/GSMime.m: ([-_decodeBody:]) fix parsing multipart documents
	as there was an error in the logic for testing to see if the sub docs
	had been parsed correctly.

2001-08-03  Adam Fedor  <fedor@gnu.org>

	* Source/NSObject.m: Don't decl __objc_responds_to on Darwin
	* Source/NSProxy.m: Likewise.

2001-08-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/Unicode.h: API Change
	* Source/Unicode.m: API Change ... remove old string conversion
	functions and replace with two functions, both of which differentiate
	between lengths of the source strings and sizes of destination buffers.
	* Source/NSString.m: Update for changes to Unicode.[hm]
	* Source/GSString.m: Update for changes to Unicode.[hm]
	
2001-08-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPortNameServer.m: Log the host we are connecting to
	when we produce a warning for a failure of a link to gdomap.
	* Source/GSHTTPURLHandle.m: ([-propertyForKeyIfAvailable:]) return
	nil if the property is not available.

2001-08-01  Richard Frith-Macdonald <rfm@gnu.org>

	* Documentation/gsdoc/Base.gsdoc: Documented all the uses of
	environment variables I could find.
	* Source/NSUserDefaults.m: __createArgumentDictionary ... handle
	property lists as arguments correctly.
	* Source/NSUser.m: Added GSTooldDirectory to listable paths.

2001-07-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFFCallInvocation.m: attempt to guess type signature
	when compiler gives us an untyped selector.
	* Headers/Foundation/NSObject.h: ASSIGN(), ASSIGNCOPY(), minor
	reordering to make these macros thread-safe.

2001-07-30  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSObjCRuntime.h: Export additional functions
	and variables for Windows DLLs.
	* Headers/gnustep/base/NSObject.h: Likewise.
	* Headers/gnustep/base/Unicode.h: Likewise.

	* Headers/gnustep/base/preface.h.in: Define __WIN32__ ifndef on 
	MINGW32.

	* Testing/nsarray.m: Use NSCParameterAssert.
	* Testing/nsconnection.m: Cleanup for MinGW/Cygwin.

Sat Jul 21 23:25:14 2001  Wim Oudshoorn
	* Source/NSHost.m ([NSHost +hostWithName:]):
	Added forgotten argument to NSLog().

2001-07-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/UnixFileHandle.m: Don't abort aread/write attempts that
	fail on EAGAIN or EINTR ... retry them instead.  Avoid unexpected
	exceptions when trying to write a large volume of data quicker
	then the output device can handle.
	* Source/WindowsFileHandle.m: ditto

2001-07-19  Adam Fedor  <fedor@gnu.org>

	* Documentation/readme.texi: Explain the license for GNUstep more
	clearly.
	* README: Regen.

Thu Jul 19 12:41:22 2001  Nicola Pero  <nicola@brainstorm.co.uk>

	* config/config.objc.m: New file.
	* configure.in: Added new test to check whether Objective-C really
	works.  If it doesn't, abort immediately telling the user to fix
	their compiler installation first.
	(AC_CHECK_HEADERS): Don't check for libguile.h
	* configure: Regenerated.
	
2001-07-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Removed bogus tests for character zero in 
	string conversion functions ... OpenStep strings are not nul
	terminated, so the code terminated conversions prematurely.

Tue Jul 17 15:00:52 2001  Nicola Pero  <nicola@brainstorm.co.uk>

	* Makefile.postamble (after-distclean): Depend on
	remove-header-links; do not remove links here.
	(remove-header-links): New target removing header links; different
	implementation on mingw32 and on non-migw32.  Do not remove
	Source/Foundation.
	(.PHONY): Added, with header-links and remove-header-links.

2001-07-16  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h: New definitions for sel
	functions, rearrange some things.
	* Headers/gnustep/base/objc-load.h: Change category type for 
	compatibility with NeXT.
	* Source/objc-load.m: Likewise.

	* Source/GSCompatibility.m (+defaultsChanged:): Typo in method name.

2001-07-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Finish off and enable XML property list code
	* Source/GSCompatibility.m: ditto

2001-07-16  Adam Fedor  <fedor@gnu.org>

	* Source/NSUserDefaults.m ([NSUserDefaults +userLanguages]): Put
	MINGW languages in array (Fix from "Michael Scheibler"
	<michael.scheibler@onevision.de>).

2001-07-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: Added ([writeToURL:atomically:]) for
	MacOS-X compatibility
	* Source/NSDictionary.m: ditto

2001-07-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProcessInfo.m: Added -processIdentifier for compatibility
	with MacOS-X
	* Source/NSTask.m: Added -processIdentifier, -suspend, and -resume
	for compatibility with MacOS-X
	* Source/NSPortNameServer.m: Modified removal methods to return a
	boolean success/failure status for MacOS-X compatibility.

2001-07-14  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h: More function defs.
	* Headers/gnustep/base/objc-load.h (objc_get_symbol_path): Correct
	def to match function decl.
	* Source/NSDistantObject.m (-selectorTypeForProxy:): Declare
	variable in NeXT implementation.
	* Source/NSInvocation.m (-invokeWithTarget:): Special def for NeXT.
	* Source/thr-pthread.m: Add forward decl of __objc_thread_detach.

2001-07-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSAttributedString.m: ([addAttributes:range:]) corrected
	bogus range check (report by Michael Scheibler)
	* Source/NSString.m: ([descriptionWithLocale:...]) as special case
	quote strings beginning with a slash ...  property lists can
	otherwise confuse strings with leading slashes as comments.

2001-07-11  Adam Fedor  <fedor@gnu.org>

	* Source/objc-load.m: Include objc-load.h on NeXT systems.

2001-07-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: ([fileSystemRepresentationWithPath:])
	MINGW fix contributed by Michael Scheibler

2001-07-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Update date/time designations to arrays
	* Source/NSDate.m: Update to use date/time designation arrays.

2001-07-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/objc-load.m: Remove bogus include of objc-load.h
	on non-NeXT systems.

2001-07-09  Adam Fedor  <fedor@gnu.org>

	* configure.in: Check for pthread.h - for compiling on Darwin.
	* Source/GNUmakefile: Compile thr-pthread.m conditionally.
	* Source/thr-pthread.m: New file.

	* Source/null-load.h (__objc_dynamic_get_symbol_path): New def.
	* Source/objc-load.m: Use NeXT load methods on Darwin.

2001-07-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: NSSearchPathForDirectoriesInDomains() Set up
	default values if environment variables are missing.
	Use common code for getting path prefixes and search directories.

2001-07-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: readContentsOfFile() hack added to permit reading
	of files like those in the /proc filesystem which don't support
	lengths.
	* Source/NSString.m: ([-initWithFormat:locale:]) use dummy local
	variable to try to get compilation to work on alpha ... untested
	as I don't have an alpha system.

2001-07-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Never init nocopy with null pointer - increase
	chance of double initialisation being detected.

2001-06-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/callframe.m: callframe_do_call_opts(),
	callframe_build_return_opts() fixed memory leaks.
	Performance improvements -
	callframe_from_info() use a single malloc to allocate memory for
	the entire callframe. callframe_free() use a single free()
	* Source/NSConnection.m: Wait only 0.1 millisecond for first try
	checking for events ... CPUs are getting faster.
	* Source/NSTimer.m: Set minimum timer to 0.1 milliseconds ...

2001-06-26  Adam Fedor  <fedor@gnu.org>

	* Source/NSUserDefaults.m (+userLanguages): On MingW systems, check
	locale for language name.

2001-06-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSerializer.m: While deserializing, check strings to see
	if they are really unicode, and create cStrings if they are not.
	Minor memory usage optimisation.

2001-06-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: Change some deprecated runloop methods for
	standard ones.
	* Source/NSRunLoop.m: ([runMode:beforeDate:]) Check for task
	completion and send out notifications if required.
        * Source/NSTask.m: ([waitUntilExit]) schedule a timer so that the
	run loop waits rather than polling as fast as the CPU allows.

2001-06-20  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSTask.m: handleSignal() ... reset signal handler for
	systems that don't have BSD signal semantics.
	Report by jan trembulak
	* Source/GSString.m: getCString_c(), getCString_u() reverse logic
	of returning remaining range ... report by Michael Scheibler

2001-06-15  Adam Fedor  <fedor@gnu.org>

	* Version: 1.0.2

2001-06-15  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSFileManager.m: ([-removeFileAtpath:handler:])
	Check for illegal paths as specified in the MacOS-X documentation.
	* Source/Makefile.postamble: Update to rebuild files for XML and SSL
	support when config.h changes.

2001-06-14  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSuserDefaults.m: Fix +resetUserDefaults to retain the
        NSRegistrationDomain information ... was losing it when this method
        was called in response to the user name being initially set.
        ([-registerDefaults:]) fix for when no dictionary found.
        Use NSLanguages rather than Languages as key for the languages list.
	* Source/NSUser.m: GSSetUserName() ... only reset the user defaults
	if the name is actually changed - and not if it is being initialised.
	When standardUserDefaults are first obtained, the user name should be
	initialised as part of that process anyway.
        * Source/NSFileManager.m: ([-removeFileAtpath:handler:])
        Fix this method so it *doesn't* follow symbolic links.
        This makes it conform to the documentation and prevents
        accidental removal of entire directory hierarchies!

Wed Jun 13 19:43:16 2001  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSFileManager.m
	([-createSymbolicLinkAtPath:pathContent:]): Fixed - the call to
	symlink was using old path instead of new path and viceversa.
	
2001-06-12  Adam Fedor  <fedor@gnu.org>

	* Documentation/news.texi: Update

	* Documentation/gsdoc/NSArray.gsdoc: Updates (from
        Pierre-Yves Rivaille <pyrivail@ens-lyon.fr>).

2001-06-11  Adam Fedor  <fedor@gnu.org>

	* configure.in (enable-openssl): New option, disabled by default.
	* Documentation/install.texi: document it.

2001-06-09  Adam Fedor  <fedor@gnu.org>

	* Source/externs.m: Change definition of exception strings and some
	functions to match headers.

2001-06-09  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: parseQuotedString() ... fix for parsing octal
	and hex escape sequences.

2001-06-09  Nicola Pero  <n.pero@mi.flashnet.it>

	* configure.in (VERSION): Output a message saying that we are
	checking for the version, and which version we find.

2001-06-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: Control caching of port coders by a simple
	boolean, and disable it by default.

2001-06-07  Adam Fedor  <fedor@gnu.org>

	* aclocal.m4: Add special case for cygwin in CON_AUTOLOAD.

2001-06-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSAttributedString.m: When caching attribute dictionaries
	we make an immutable copy of the dictionary with shallow copy.

2001-06-06  Nicola Pero  <n.pero@mi.flashnet.it>

	Configuration part of constant string support with gcc-3.0
	* config/config.constant-string-class.m: New config test.
	* configure.in: Added test for -fconstant-string-class option in
	compiler, by compiling and running config.constant-string-class.m.
	Output different NX_CONST_STRING_CLASS and
	NX_CONST_STRING_CPPFLAGS depending on results of this test.
	* base.make.in (CONFIG_SYSTEM_INCL): Added
	NX_CONST_STRING_CPPFLAGS.
	* Headers/gnustep/base/GSConfig.h.in: Renamed NXCONST to
	NX_CONST_STRING_CLASS.
	* configure: Updated.

2001-06-06  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSScanner.m: ([scanHexInt:]) fix for scanning number
	consisting just of a zero.  Reported by Tom Koelman

2001-06-06  Richard Frith-Macdonald <rfm@gnu.org>

	Changes for constant string support with gcc-3.0
	* configure.in: Just substitute NXCONST
	* Headers/gnustep/base/GSConfig.h.in: Use NXCONST to redefine
	NXConstantString
	* Headers/gnustep/base/NSString.h: new constantStringClass method.
	* Source/GSString.m: new constantStringClass method.
	* Source/NSObject.m: Use NSConstantStringClass.
	* Source/NSScanner.m: Use NSConstantStringClass.
	* Source/NSString.m: implement constantStringClass method.

2001-06-06  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/mframe.m: Reactivated inling nested functions after 
	gcc 3.0 was fixed to compile them again.

2001-06-05  Nicola Pero  <n.pero@mi.flashnet.it>

	* GNUmakefile: If GNUSTEP_MAKEFILES is not set, tell the user it
	needs to source GNUstep.sh and then exit with an error.

2001-06-05  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/mframe.m: Disabled inlining of nested functions.  This
	should allow gnustep-base to be compiled using gcc 3.0.

2001-06-05  Richard Frith-Macdonald  <rfm@gnu.uk>

	* Source/GSString.m: ([replaceCharactersInRange:withString:])
	Fix error appending unicode string to C string.

2001-06-01  Richard Frith-Macdonald  <rfm@gnu.uk>

	* Source/NSString.m: Patch by David Relson applied

2001-06-01  Richard Frith-Macdonald  <rfm@gnu.uk>

	Optimisations suggested by Guenther Fuerthaller
	* Source/NSZone.m: NSZonefromPointer() check for empty zones
	list before locking.
	* Source/NSData.m: more efficient dealloc implementation for
	NSMutableDataMalloc.

2001-06-01  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSCalendarDate.m
	([-descriptionWithCalendarFormat:locale:]): Fixed %w (day of the
	week) to output a single digit number rather than a two digit one.

2001-05-31  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSObjCRuntime.h (GSLastErrorStr): Define new
	OS-independant strerror like function.
	* Source/GSFormat.m: Use it.
	* Source/GSTcpPort.m, Source/NSData.m, Source/NSDistributedLock.m,
	Source/NSFileManager.m, Source/NSPipe.m, Source/NSRunLoop.m, 
	Source/NSTask.m, Source/UnixFileHandle.m, Source/WindowsFileHandle.m:
	Likewise.
	* Source/NSObjCRuntime.m (GSLastErrorStr): New function
	(suggestion from "Michael Scheibler" <michael.scheibler@onevision.de>).

	* Headers/gnustep/base/behavior.h: Include objc-class.h on 
	NeXT_RUNTIME.
	* Headers/gnustep/base/objc-gnu2next.h: New inline functions.
	* Source/NSDistantObject.m (-selectorTypeForProxy): Simplify 
	NeXT_RUNTIME implementation.

2001-05-29  Adam Fedor  <fedor@gnu.org>

	* Version: 1.0.1

	* Resources/Languages/Dutch: New file (from Dennis Leeuw
	<dleeuw@made-it.com>).

2001-05-28  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h (class_is_class): New.
	* Source/NSAssertionHandler.m (-handleFailureInMethod...): Use
	OpenStep functions to get class/sel names.
	* Source/NSBundle.m (+initialize): NeXT_RUNTIME method to find
	classes.

2001-05-26  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSDebug.m (_NSPrintForDebugger): new function to support print
	object (po) cmd of gdb.

2001-05-25  Adam Fedor  <fedor@gnu.org>

	* configure.in: Use -lobjc with NeXT_RUNTIME.
	* Headers/gnustep/base/behavior.h: Include objc.h on NeXT_RUNTIME.

	* Source/GSFormat.m: Replace assert with NSCParameterAssert

2001-05-23  Adam Fedor  <fedor@gnu.org>

	* configure.in: Check for libgiconv
	* Unicode.m: Include giconv.h if available.

2001-05-22  Adam Fedor  <fedor@gnu.org>

	* configure.in: Check CPP handling of LONG_LONG_MAX
	* Source/GSFormat.m: Undef LONG_LONG_MAX if not handled

	* Source/GSeq.h: Set static selectors to NULL.
	* Source/NSString.m (+initialize): Set selectors here instead.
	* Source/GSString.m (setup): ...And here.

2001-05-22  Richard Frith-Macdonald <rfm@gnu.org>
	* Headers/Foundation/NSSet.h: Added ([-setSet:])
	* Source/GSSet.m: Optimise ([-unionSet:])
	* Source/GSArray.m: Tidy NSWarnMLog macros.
	* Source/GSAttributedString.m: ditto
	* Source/GSCountedSet.m: ditto
	* Source/GSDictionary.m: ditto
	* Source/NSArray.m: ditto
	* Source/NSDictionary.m: ditto
	* Source/NSSet.m: Implement ([-setSet:])

2001-05-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDate.m: check for nil dates in some init methods so
	we return nil on initialisation failure rather than raising an
	exception.  I believe that init failures should deallocate their
	objects and return nil.
	* Source/NSArray.m: ([-initWithContentsOfFile:]) include filename in
	NSWarnMLog() message.
	* Source/NSDictionary.m: ([-initWithContentsOfFile:]) use NSWarnMLog

2001-05-14  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h: Add apply_t prototype.
	* Source/objc-gnu2next.m: Include stdio.h.
	* Source/GSFormat.m: Don't compare LONG_LONG_MAX if not defined

2001-05-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: ([stringByDeletingPathExtension]) rewrite to
	conform to MacOS-X documentation.
	([pathComponents]) ditto.
	* Headers/Foundation/NSInvocation.h: Added extra methods for
	setting an invocation to invoke super implementation of method.
	* Source/NSInvocation.m: Added extra methods for
	setting an invocation to invoke super implementation of method.
	* Source/GSFFCallInvocation.m: support invoke of super implementation.

2001-05-14  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h: Add error prototypes.
	* Source/objc-gnu2next.m: Include preface.h, define error funcs.

2001-05-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Removed some unused obsolete code.
	* Source/NSProxy.m: Modified ([methodSignatureForSelector:]) and
	([respondsToSelector:]) to work for existing methods and raise
	exception for non-existant methods.  The MacOS-X docs says they raise
	exceptions, but I think it makes sense for them to work for methods
	that are actually implemented in the proxy.

2001-05-11  Adam Fedor  <fedor@gnu.org>

	* Source/NSArchiver.m ([NSArchiver -encodeValueOfObjCType:at:]): Use
	signed char to encode _C_CHR.
	* Source/NSPortCoder.m ([NSPortCoder -decodeValueOfObjCType:at:]): 
	Be lenient about decoding [un]signed chars.
	* Source/NSUnarchiver.m: Likewise.
	* Source/GSTemplateValue.m (-encodeWithCoder:): Use signed char to
	encode/decode type info.
	* Source/GSValue.m: Likewise.
	* Source/NSConcreteNumber.m: Likewise.
	* Source/NSNumber.m: Likewise.
	* Source/NSValue.m: Likewise.

2001-05-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: Use respondsToSelector rather than respondsTo
	* Source/NSRunLoop.m: ditto ... and tidy up categories to avoid
	compiler warnings.
	* Source/NSAutoreleasePool.m: Add ([+freeCache]) method to clear out
	the cache of pools in the current thread.
	* Documentation/gsdoc/NSAutoreleasePool.gsdoc: basic class
	documentation inlcuding normal GNUstep extensions.

2001-05-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Fixes to last modifications - provided by
	Chris B Vetter.
	* Source/NSString.m: Fix memory allocation of a unichar buffer to
	correct size.
	* Source/NSPipe.m: Log an error if we can't open a new pipe.
	* Source/NSTask.m: Slight tidyup

2001-05-04  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSObject.m (GSGetValue): Call handleQueryWithUnboundKey:
	rather than handleTakeValue:forUnboundKey: when no property
	binding is found.

2001-05-04  Nicola Pero  <n.pero@mi.flashnet.it>

	* configure.in: Abort if GNUSTEP_SYSTEM_ROOT is empty, printing a
	message saying that you must run the GNUstep configuration script
	before configuring the base library.
	* configure: Regenerated.

2001-05-04  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h: Add arglist_h def. Add
	encoding functions defs.
	* Source/mframe.m: Include stdio and ctype.
	* Source/mframe/mframe.foot (mframe_arg_addr): Use marg_getRef if
	NeXT_RUNTIME.

2001-05-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDate.m: GSTimeNow() remove volatile typespec and move
	initialisation of interval in the hope of fixing a problem with
	float operations.  In any case, the code is tidier.
	* Tools/gdomap.c: If started as root, try to become user nobody
	before resorting to uid -2 (like NFS).

2001-05-03  Adam Fedor  <fedor@gnu.org>

	* configure.in: Don't use -lobjc with NeXT_RUNTIME. Check for -lm.

	* Headers/gnustep/base/objc-gnu2next.h: Add sel_register_name
	* Source/behavior.m: Add define hacks for Darwin.

2001-05-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject: ([+initialize]) Move GSSetLocale() after platform
	specific code with conditionally compiled variable declarations.
	Should make this work on BSD and MINGW again.

2001-05-02  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSObject.m ([NSObject +initialize]): fixed a FreeBSD specific
	code bug introduced by the call of GSSetLocaleC().

Wed May  2 13:19:13 2001  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/UnixFileHandle.m (id): Redefine `id' when including
	openssl header files to avoid syntax errors from 3.x serie gcc
	compilers.

2001-05-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTimeZone: ([-initWithName:]) fix for trivial locking bug.

2001-04-30  Adam Fedor  <fedor@gnu.org>

	* Source/behavior.m: Rewrite to work with NeXT runtime.
	* Headers/gnustep/base/objc-gnu2next.h: Add some extra translations.

2001-04-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: parseQuotedString() handle \U escape sequences
	of eight digit hex encoded unicode values.
	([descriptionWithLocale:indent:to@]) handle unicode strings by using
	\U escape sequences in output C string.

2001-04-28  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSString.m: 
	Corrected bug in last optimization for the parsing of property
	list. Now the bitmap representation is retained not the
	characterset itself. This did cause undeterministic problems when
	reading in the Info.plist.

2001-04-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSLog.m: Use RETAIN/RELEASE
	* Source/GSLocale.m: Set up NSDecimalSeparator and NSThousandsSeparator
	from locale if possible.  Fix bug dereferencing nil pointer.
	* Source/GSFormat.m: Hack to rewrite output from sprintf of floats and
	doubles to use the value in NSDecimalSeparator.

2001-04-27  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSString.m: Minor optimization for parsing property
	lists: cache the bitmap representation of hexdigit, quotable and
	whitespace character sets, and use it directly to determine
	whether a character is member or not of these sets.
	
2001-04-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: ([+initialize]) protect with flag so it is safe
	to call this method more than once.
	* Source/externs.m: GSBuildStrings() call +initialize method for
	NSString to ensure that the class is properly initialised even if
	this function has been called from NSObjects +initialize, which was
	in turn called in preparation for NSString initialisation!

2001-04-25  Adam Fedor  <fedor@gnu.org>

	* configure.in: Much simplified NeXT checks. Just use LIBRARY_COMBO
	to check runtime.
	* Source/o_vscanf.c: Remove objc-gnu2next.h

2001-04-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/GSXML.h: Many changes to restore encapsulation
	of libxml previously broken by someone...  Partly as a matter of
	good OO programming practice, partly so that the library can be
	used effectively from Java (via JIGS).
	Moved libxml header includes out of this file.
	Removed typedefs for libxml constants and changed 'type' methods
	to return 'int'.
	Added class methods for mapping between integer type values
	and constant string type values.
	Added a typeDescription method to GSXMLAttribute for consistency.
	* Source/GSXML.m: include required headers and update to implement
	changes in API.  Also fixed bug in implementation of typeDescription
	method for GSXMLNamespace.
	* Documentation/gsdoc/GSXMLNode.gsdoc: Updated to reflect current API
	* Documentation/gsdoc/GSXMLNamespace.gsdoc: ditto
	* Documentation/gsdoc/GSXMLAttribute.gsdoc: ditto

2001-04-25  Nicola Pero  <nicola@brainstorm.co.uk>

	* base.make.in: (GNUSTEP_BASE_VERSION),
	(GNUSTEP_BASE_MAJOR_VERSION), (GNUSTEP_BASE_MINOR_VERSION),
	(GNUSTEP_BASE_SUBMINOR_VERSION): New variables providing the
	gnustep-base version.
	
2001-04-24  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/objc-gnu2next.h: Remove TypedStream defs

2001-04-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Fixes for string capitalisation in
	key-value methods.

2001-04-23  Adam Fedor  <fedor@gnu.org>

	* configure.in: Simplify NeXT checks.
	* Headers/gnustep/base/NSLock.h: Fix NeXT_RUNTIME typo.
	* Headers/gnustep/base/objc-gnu2next.h: Change *_EXPORT to extern
	* Source/o_vscanf.c: include objc-gnu2next.h
	* Source/NSConnection.m: Fix test for NeXT_RUNTIME define.
	* Source/NSDistantObject.m: Likewise.
	* Source/callframe.m: Likewise.
	* Source/cifframe.m: Likewise.
	* Source/mframe.m: Likewise.

2001-04-24   Nicola Pero  <n.pero@mi.flashnet.it>

	* Testing/benchmark.m (bench_object): Use a choice of the 10 more
	used classes when benchmarking class method invocation, rather
	than always using `NSObject'.  Added bench for NSClassFromString.

2001-04-23  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/GSValue.m ([-getValue:]): Fixed typo - was raising
	exception on non-NULL buffer rather than NULL.

2001-04-23  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSBundle.m ([+initialize]): Fixed segmentation fault when
	NSSearchPathForDirectoriesInDomains returns an empty array.  This
	used to appear when GNUSTEP_SYSTEM_ROOT was unset.
	* Source/NSUser.m (NSSearchPathForDirectoriesInDomains): Read
	GNUSTEP_SYSTEM_ROOT, GNUSTEP_LOCAL_ROOT, GNUSTEP_NETWORK_ROOT and
	GNUSTEP_USER_ROOT only once, then cache them.  Do not crash if
	some of them are nil.  If GNUSTEP_SYSTEM_ROOT is nil, fprintf a
	log message, and try using /usr/GNUstep/System.  Use new ADD_PATH
	macro to simplify code.  Autorelease returned array which was
	previously leaked.

2001-04-22  Georg Fleischmann

	* Source/GSAttributedString.m:
	([replaceCharactersInRange:withString:])
	recalculate effective range after removing attributes.

2001-04-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSLocale.m: Only call setlocale() in GSSetLocaleC()
	* Source/NSObject.m: ([+initialize]) call GSSetLocaleC() after other
	initialisation, to try to ensure that locale stuff is set up early
	before any attempt is made to use locale dependent code.
	* Source/NSString.m: ([-stringByExpandingTildeInPath:]) fix suggested
	by David Wetzel.
	* Source/GSValue.m: Fix abort when initialising value with illegal
	type.  Also fix all other uses of objc_sizeof_type(), add some checks
	to conform to documentation, and some optimisations.

2001-04-22  Nicola Pero  <n.pero@mi.flashnet.it>

	* Testing/benchmark.m: Modified messages to give a better idea of
	the order of magnitudes involved; added benchmarks for
	retain/release, autorelease/retain and locking/unlocking.

2001-04-21  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSString.m ([-fileSystemRepresentation]): Cache the
	default file manager.
	
2001-04-21  Richard Frith-Macdonald <rfm@gnu.org>

	* config/config.proccmd.c: New test for behavior of /proc cmdline
	* acconfig.h: New CMDLINE_TERMINATED constant
	* configure.in: Use test to set CMDLINE_TERMINATED
	* configure: regenerated
	* Headers/Foundation/config.h.in: regenerated
	* Source/NSProcessInfo.m : ([+load]) modified to use CMDLINE_TERMINATED
	to decide how to use /proc/$$/cmdline when determining process args.
	Should now work 100% on all linux versions I hope.

2001-04-20  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m ([NSMutableDataMalloc
	-replaceBytesInRange:withBytes:]): Check length, not capacity!
	Conform to documentation, and avoid possibility of 'hole' in data.
	* Source/NSInvocation.m: _get_arg() indirection fix suggested by
	Michael Scheibler.

2001-04-20  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSFileManager.m (NSDirectoryEnumerator): Rewritten to be
	faster.  ([NSFileManager -directoryContentsAtPath:]),
	([NSFileManager -subpathsAtPath:]): Use the new init method for
	NSDirectoryEnumerator.  ([NSFileManager
	-contentsEqualAtPath:andPath:]): Spare some method calls.
	([NSFileManager -fileSystemRepresentationWithPath:]): Cleaned
	preprocessor directives.
	* Headers/gnustep/base/NSFileManager.h (NSDirectoryEnumerator):
	Changed ivars in sync.
	
2001-04-19  Nicola Pero  <nicola@brainstorm.co.uk>

	* Documentation/gsdoc/NSFunctions.gsdoc: Documented
	GSDebugAllocation* functions.
	* Documentation/gsdoc/NSRecursiveLock.gsdoc: Fixed syntax error.
	* Documentation/gsdoc/*.html: Regenerated.
	
2001-04-19  Nicola Pero  <nicola@brainstorm.co.uk>

	To help with debugging memory leaks, you can now ask to the
	library to track all allocated instances of a certain class.
	* Source/NSDebug.m (table_entry): Added fields to allow recording
	the list of allocated instances if required.
	(GSDebugAllocationActiveRecordingObjects): New function.  
	(GSDebugAllocationAdd): Modified to take an additional argument -
	the object being allocated -, and to record it in the list of
	instances for the class if recording instances of that class has
	been activated.
	(GSDebugAllocationRemote): Add a similar additional argument;
	remove the object from the list of instances if recording
	instances is activated.
	(GSDebugAllocationListRecordedObjects): New function.
	* Source/NSObject.m: Updated all occurrences of
	GSDebugAllocationAdd and GSDebugAllocationRemove to pass the 
	allocated/removed object as well.
	* Headers/gnustep/base/NSDebug.h: Updated.

2001-04-19  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/GSTcpPort.m ([GSTcpPort -dealloc]): Fixed memory leak:
	release address string.

2001-04-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTask.m: Tidied code a little, added safety checks for
	usePseudoTerminal method.
	* Source/NSData.m: ([writeToFile:atomically:]) create new files
	with permission 0644 modified by umask.
	Init tmppath for MINGW.
	* Tools/gsdoc.m: Use memory management macros and attempt to get
	back to something like conformance with coding standards.
	* Documentation/gsdoc/NSTask.gsdoc: documentation fleshed out.

2001-04-16  Adam Fedor  <fedor@gnu.org>

	* aclocal.m4: Detect the xm2-config script.

2001-04-14  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* configure.in: fixed fake main for 'new' FreeBSD targets.

2001-04-13  Adam Fedor  <fedor@gnu.org>

	* Source/GSFFCallInvocation.m (GSInvocationCallback): Generate
	an exception for an invalid selector.

2001-04-12  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSObjCRuntime: Revert to using class_pointer.
	* Headers/gnustep/base/objc-gnu2next.h: Redefine class_pointer.

2001-04-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProcessInfo.m ([load]): Fixed single line change somehow
	missed from last patch.

2001-04-12  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/NSLock.h: Include thrmach.h if NeXT_RUNTIME.
	* Headers/gnustep/base/NSThread.h: Likewise.
	* Headers/gnustep/base/NSObjCRuntime: Include objc-gnu2next.h if
	NeXT_RUNTIME, use common objc functions for compatibility.
	* Headers/gnustep/base/objc-gnu2next.h: Update, simplify.
	* Headers/gnustep/base/thr-mach.h: New file
	* Source/thr-mach.m: New file
	* Source/GNUmakefile: Update to conditionally compile NeXT files

	* Documentation/gsdoc/NSRecursiveLock.gsdoc: Update.

2001-04-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: For efficiency, use _DefaultStringEncoding
	throughout, rather than calling +defaultCStringEncoding.  This is
	safe since the documentation explicitly states that the encoding
	cannot be changed programmatically ... so we don't have to worry
	about someone adding a category to change that.
	When converting data to/from strings, optimise to simple cString
	stuff if the specified encoding is the defautl encoding.
	Tidied some stuff to conform better to coding standards.
	* Source/Unicode.m GetDefEncoding(): prohibit UTF8 from being the
	default cString encoding ... the default cString encoding must
	consist of 7 or 8 bit characters, and must contain ASCII as a
	subset.  We really should think of a generalised test for that.
	Use GetDefEncoding() throughout rather than defaultCStringEncoding.
	* Source/GSString.m: Use GetDefEncoding() to get c string encoding.

2001-04-11  Nicola Pero  <nicola@brainstorm.co.uk>
	
	* Source/NSString.m ([-initWithData:encoding:]): When working with
	a generic but non-unicode encoding, do not treat a single
	character string with no null terminator as an empty string.  This
	should fix passing single character strings over DO.
	* Source/NSThread.m ([+registerCurrentThread]),
	([+unregisterCurrentThread]): Removed.

2001-04-11  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFFCallInvocation.m: bugfix encoding ... pass correct
	method type information so that the other end knows whether this
	is a oneway message or not.  Corrects major memory leak.
	* Source/NSConnection.m: bugfix to handle situations where the
	other end sends a response and we are not expecting it.  Also
	added various bits of debugging and ensured that all NSPortCoder
	objects are cached.

2001-04-10  Adam Fedor  <fedor@gnu.org>

	* Headers/gnustep/base/preface.h.in: Correct NeXT_RUNTIME name

	* Documentation/gsdoc/NSLock.h: Documented.

2001-04-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTask.m: Bugfix to send out task termination notification
	and clean up correctly when a task is killed by a signal rather than
	exiting cleanly.

2001-04-09  Adam Fedor  <fedor@gnu.org>

	* 1.0 branch merged into main.

2001-04-06  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSString.m (pathSepMember): Made trivial and inlined.
	([-stringsByAppendingPaths:]): Count the array only once, not for
	any loop in the cycle.
	
2001-04-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: NSTemporaryDirectory() rewrite for improved
	security and reliability.  Expect MINGW update soon.

2001-04-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUser.m: Tidied some stuff to conform to coding standards.
	Added FIXME where unsure of code.  Tidied code to get name of user.
	* configure.in: Added checks for a few functions needed to get user.

2001-03-37  Jonathan Gapen  <jagapen@home.com>

	* Source/NSString.m: New private function to compute the scalar value
	of a high-low surrogate pair.  New surrogate range class variables.
	Optimize ([-hasPrefix]) and ([-hasSuffix]) by using NSAnchoredSearch.
	Add UTF-8 code to ([-dataUsingEncoding:allowLossyConversion:]).

2001-03-26  Jonathan Gapen  <jagapen@home.com>

	* Source/Makefile.preamble: No need to define HAVE_LIBXML here.
	* Source/NSBundle.m: ([+initialize]) and ([+pathForGNUstepResource:
	ofType:inDirectory:]) now use NSSearchPathForDirectoriesInDomains()
	to find directories, rather than use env vars directly.
	* Source/NSCharacterSet.m: Ditto for ([_-bitmapForSet:]).
	* Source/NSDictionary.m: Make NSLog() include the filename
	in ([-initWithContentsOfFile:]).
	* Source/NSUser.m: Re-implement NSStandardApplicationPaths() and
	NSStandardLibraryPaths() with NSSearchPathsForDirectoriesInDomains().
	In latter function, support $GNUSTEP_SYSTEM_ROOT/Developer/Demos.

2001-03-21  Jonathan Gapen  <jagapen@home.com>

	* config/nextcc.m4, config/objc-con-autoload.m4, config/procfs.m4,
	config/objc-sys-dynamic.m4, config/procfs-exe-link.m4: Autoconf
	macros used by configure.in.

2001-04-08  Adam Fedor  <fedor@gnu.org>

	* Version: 1.0.0
	* NEWS: Regenerated.

	* Source/NSLock.m (-tryLock): Return NO if our thread has
	already has the lock (like OpenStep).
	(-lockBeforeDate:): block until date if our thread already has 
	the lock (like OpenStep).

	* Source/NSData.m ([NSMutableDataMalloc
	-replaceBytesInRange:withBytes:]): Check capacity, not length.

2001-04-04  Adam Fedor  <fedor@gnu.org>

	* config.guess: Update to latest version
	* config.sub: Likewise.

2001-04-01 2001  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/GSValue.m ([-description]): Bug fix - was crashing upon
	using %@ instead of %s for a char *.

2001-03-31  Adam Fedor  <fedor@gnu.org>

	* Documentation/announce.texi: Update.
	* Documentation/install.texi: Likewise.

	* Testing/Makefile.preamble: Set BUNDLE_LIBS on mingw and cygwin.
	* Testing/nsbundle.m: add NSProcessInfo's initializeWithArguments:...

2001-03-28  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSProcessInfo.m: ([+load]) Fix in parsing of command line
	arguments from /proc filesystem.  On newer kernels the command line
	arguments are terminated by a nul, on older systems they are separated
	by a nul.  The old code would add an extra (empty) argument to all
	processes on newer kernels.  The new code will lose a trailing empty
	argument on older kernels :-(  I view it as the lesser of two evils
	since the extra empty arg confuses/breaks a lot of tools.

2001-03-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: Fix file copying for MINGW by using
	windows native copy function - fix by Michael Scheibler.
	Also tidied to conform to coding standards, and fixed to use
	O_BINARY where the system defines it.

2001-03-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSObject.h: GS_EXPORT updates for MINGW
	* Headers/Foundation/NSObCRuntime.h: ditto
	* Headers/Foundation/NSRange.h: ditto
	* Source/NSRange.m: ditto
	Fixes suggested by Michael Scheibler
	
2001-03-24  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: ([-replaceBytesInRange:withBytes:]) bugfix ...
	revert to check using '>' rather than '>=' to conform to documentation
	and to be consistent with use of ranges in general.
	* Documentation/gsdoc/NSMutableData.gsdoc: documented primitive methods.
	* Documentation/gsdoc/NSFunctions.gsdoc: Some documentation for NSRange
	added.

2001-03-23  Adam Fedor  <fedor@gnu.org>

	* Source/NSData.m: ([-replaceBytesInRange:withBytes:]) Check location
	>= size.

2001-03-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSData.m: ([-replaceBytesInRange:withBytes:]) bugfix ...
	extend data if range has location in data, but extent beyond data.

2001-03-23  Adam Fedor  <fedor@gnu.org>

	* Source/NSSerializer.m (serializeToInfo): Use memcpy to serialize
	strings on machines that need word alignment.
	* Source/NSTimeZone.m (decode): For decoding, likewise.

	* Testing/thread-except.m: Use autorelease pools.

2001-03-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSFileManager.m: MINGW fixes by Michael Scheibler.
	([_attributesAtPath:traverseLink:forCopy:]) fix 'cos windows lacks
	symbolic links.  ([-changeFileAttributes:atPath:]) workaround for
	windows directories not having modification times.
	([-fileSystemAttributesAtPath:]) fix for large volumes (matching
	change for unix too ... use unsigned long long).

2001-03-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: ([-methodSignatureForSelector:]) try to get a
	valid method signature any way we can ... check for a valid method
	first, use selector types next.  Avoid crash when given nul selector
	as an argument.
	* Source/NSMethodSignature.m: ([+signatureWithObjCTypes:]) don't
	crash when given nul pointer as argument.

2001-03-19  Jonathan Gapen  <jagapen@home.com>

	* Source/NSString.m: Implement ([-localizedStringWithFormat:]).
	Fix ([-localizedCompare:]) and ([-localizedCaseInsensitiveCompare:]).
	(They will work when ([-compare:options:range:locale:]) works.)
	Fix ([-initWithContentsOfFile:]) and ([-initWithContentsOfURL:]) so
	that they deal with 1 byte of data, and clarify Unicode BOM test with
	new class variables byteOrderMark and byteOrderMarkSwapped.
	In ([-initWithData:encoding:]) and ([-initWithCoder:]), don't treat
	the default C string encoding the same as ASCII.  GCC 3.0 supports
	UTF-8 as a C string encoding, so this behavior is undesirable.

2001-03-19  Jonathan Gapen  <jagapen@home.com>

	* Source/NSAutoreleasePool.m, Source/NSCharacterSet.m,
	Source/NSHashTable.m, Source/NSMapTable.m, Source/NSZone.m:
	Update from %s/([-cString]) to %@ for format strings.
	* Source/NSDecimal.m: In GSDecimalFromString(), use ([-lossyCString])
	instead of ([-cString]) which should (in the future) always return
	ASCII-range decimal digits in place of digits from other languages.

2001-03-19  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSThread.m: registerCurrentThread and
	unregisterCurrentThread turned into functions - called
	GSRegisterCurrentThread and GSUnregisterCurrentThread.
	* Headers/gnustep/base/NSThread.h: Updated for change.

	* Source/NSThread.m (GSRegisterCurrentThread): Call
	objc_thread_add before creating the NSThread object using a method
	call.  (GSUnregisterCurrentThread): Post the NSThreadWillExit
	notification.
	
2001-03-19  Jonathan Gapen  <jagapen@home.com>

	* Source/NSString.m: In ([-rangeOfComposedCharacterSequenceAtIndex:]),
	use the NSCharacterSet non-base character set to identify non-base
	characters.  In ([-cStringLength]), do not allow lossy string
	conversion.  In ([+localizedNameOfStringEncoding:]), use NSBundle's
	([-gnustepBundle]) rather than looking in root path.

2001-03-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSThread.h: Remove unused ivar.
	* Source/NSThread.m: Revise scheme for deallocation of thread
	dictionary ... keep it operating to avoid problems with stuff
	trying to use it while deing deallocated.  Log memory leaks.
	* Source/NSRunLoop.m: ([+currentRunLoop]) return nil if there is
	no thread dictionary available (shouldn't happen).
	* Source/NSString.m: MINGW path handling fixes by Michael Scheibler
	stringByAppendingPath, isAbsolurtePath, and stringByStandardizingPath.
	
2001-03-16  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/Makefile.postamble (after-install): Removed old 
	code for creating /etc/services.add when packaging.
	
	* Makefile.postamble
	($(INSTALL_ROOT_DIR)$(GNUSTEP_MAKEFILES)/Additional): New target;
	create the directory.  (before-install): Don't create the
	directory, but depend on the new target.
	* Resources/GNUmakefile.postamble: Idem for $(languagedir).
	* NSCharacterSets/Makefile.postamble: Idem for $(charsetdir).
	* NSTimeZones/Makefile.postamble: Idem for $(timezonedir).
	
2001-03-16  Manuel Guesdon <mguesdon@orange-concept.com>

	* Tools/pl*.m: added #include <Foundation/Foundation.h> to avoid 
		GNUSTEP Internal Error

2001-03-14  Adam Fedor  <fedor@gnu.org>

	* Source/libgnustep-base.def: Remove some classes that aren't
	used on MinGW32.

2001-03-13  Adam Fedor  <fedor@gnu.org>

	* configure.in: Check and set EXEEXT needed by some tests.
	* aclocal.m4: Fixes for constructor test.

2001-03-12  Jonathan Gapen  <jagapen@home.com>

	* Headers/gnustep/base/NSString.h: Change NSCyrillicStringEncoding
	to NSISOCyrillicStringEncoding, and likewise for Greek, Arabic, and
	Hebrew, to avoid ambiguity.  Add enum values for all remaining
	ISO-8859 character sets, plus UTF-7.
	* Source/GSXML.m: Update pursuant to above changes.
	* Source/NSString.m: Ditto.
	* Source/Unicode.m: Ditto.

2001-03-11  Adam Fedor  <fedor@gnu.org>

	* Source/NSThread.m: Remove runtime.h include since this isn't
	normally installed by objc, add back in extern variables.

2001-03-10  Adam Fedor  <fedor@gnu.org>

	* Version 0.9.2
	* Makefile.postamble (before-install): Remove extra '/' before
	GNUSTEP_MAKEFILES

	* configure.in: Check for objc_thread_add in runtime.
	* Source/NSThread.m (objc_thread_add): Define only if not in runtime
	(objc_thread_remove): Likewise.

2001-03-10  Manuel Guesdon <mguesdon@orange-concept.com>

	* GSXML.m/.h: added errer, warning and fatal error methods with 
		line and col parameters in GSSAXHandler.

2001-03-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSCalendarDate.h:
	* Headers/gnustep/base/NSTimeZone.h: New files for MacOS-X compatibility
	* Headers/gnustep/base/Foundation.h: Add NSCalendarDate and NSTimeZone
	* Headers/gnustep/base/NSDate.h: Remove info in new files.
	* Source/GNUmakefile: Add new NSCalendarDate and NSTimeZone files.
	* Source/NSCalendarDate.m: Update for header changes.
	* Source/NSDate.m: ditto
	* Source/NSDateFormatter.m: ditto
	* Source/NSLog.m: ditto
	* Source/NSString.m: ditto
	* Source/NSTimeZone.m: ditto

2001-03-07  Adam Fedor  <fedor@gnu.org>

	* Source/NSInvocation.m (-initWithTarget:selector:): Correct copying
	of unhandled argument types.

2001-03-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: ([methodSignatureForSelector:]) reliability
	fix suggested by  Manuel Guesdon <ml@sbuilders.com>

2001-03-06  Adam Fedor  <fedor@gnu.org>

	* Source/libgnustep-base.def: Regenerate.

2001-03-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Changed ([+setUserLanguages:]) to use
	NSLanguages.
	* Documentation/gsdoc/NSUserDefaults.gsdoc: documented the
	([+setUserlanguages:]) method.

2001-03-04  Jonathan Gapen  <jagapen@home.com>

	* Documentation/gsdoc/NSCharacterSet.gsdoc: Documented some methods.
	* Headers/gnustep/unicode/caseconv.h: Updated case-mapping tables.
	* Source/NSBitmapCharSet.m: Added sanity check to initWithBitmap:
	* Source/Unicode.m: Changed uni_toupper() and uni_tolower() to use
	direct lookup in two-level tables, rather than a linear search.

2001-03-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: Corrected 
	([-_bundleResourcePathsWithRootPath:subPath:]) to use
	([NSUserDefaults +userLanguages]) to get language array again.
	* Documentation/gsdoc/NSUserDefaults.gsdoc: Updated and added
	information about +userLanguages

2001-03-03  Adam Fedor  <fedor@gnu.org>

	* Source/NSInvocation.m: Add missing static inline to __get_arg
	(patch from David Relson <relson@osagesoftware.com>).

2001-03-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSSerializer.m:
	* Source/NSURLHandle.m:
	* Source/NSUnarchiver.m:
	* Source/GSFormat.m:
	* Source/GSHTTPURLHandle.m:
	* Source/GSMime.m:
	* Source/GSString.m:
	* Source/NSDictionary.m:
	* Source/NSPortNameServer.m:
	Various minor changes to avoid compiler warnings.
	* Source/NSFileManager.m: ([-fileSystemRepresentationWithPath:])
	Use CYGWIN_HOME as suggested by Michael Scheibler
	* Source/NSUser.m: NSHomeDirectoryForUser() fix for home path
	on NT by Michael Scheibler.

2001-03-01  Jonathan Gapen  <jagapen@home.com>

	* NSCharacterSets/whitespaceCharSet.dat,
	NSCharacterSets/whitespaceAndNlCharSet.dat: Add tab character.

2001-03-01  Nicola Pero  <n.pero@mi.flashnet.it>

	* aclocal.m4 (AC_SYS_PROCFS): Reverted last change in code to detect
	the /proc filesystem as it didn't work on my gnu-linux: /proc/0 does
	not exist, but the /proc filesystem works perfectly.
	* configure.in (GS_FAKE_MAIN): Fixed typo in last change which
	caused fake main definition to take place even when both +load and
	/proc worked.
	* configure: Regenerated.

2001-02-28  Jonathan Gapen  <jagapen@home.com>

	* configure.in: Begin autoconf clean-up; replace tests for NeXT
	compiler, /proc, and exe link with external macros; add support
	for FreeBSD /proc/curproc/file link.
	* acconfig.h: Remove definition now handled by macro.
	* aclocal.m4, configure, Headers/gnustep/base/config.h.in: Regen.
	* Source/NSBundle.m: Take exe link from PROCFS_EXE_LINK define.
	* Source/NSProcessInfo.m: HAVE_PROC_FS -> HAVE_PROCFS

2001-02-28  Adam Fedor  <fedor@gnu.org>

	* Source/win32-load.h (__objc_dynamic_get_symbol_path): New function.

	* Source/GSHTTPURLHandle.m ([GSHTTPURLHandle -loadInBackground]): Use
	GSUnixSSLHandle only if not __MINGW__

2001-02-27  Jonathan Gapen  <jagapen@home.com>

	* NSCharacterSets/README.CharSet: Update notes.
	* NSCharacterSets/*.dat: Regenerate with v3.0.1 of UnicodeData.txt
	(ftp://ftp.unicode.org/Public/UNIDATA/UnicodeData.txt)

2001-02-27  Adam Fedor  <fedor@gnu.org>

	* configure.in: Fix openssl config so it defines HAVE_OPENSSL only
	if all headers and libs available.
	* configure, acconfig.h, Headers/gnustep/base/config.h.in: Regen.
	* Source/UnixFileHandle.m: Use HAVE_OPENSSL.

2001-02-27  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/NSLock.m: Commented out extra token after #endif
	directive.
	* Headers/gnustep/base/GSXML.h: Idem.
	
2001-02-27  Nicola Pero  <n.pero@mi.flashnet.it>

	* configure.in (Version): source it as ./Version rather than
	Version (suggested by Juliusz Chroboczek <jch@pps.jussieu.fr>).
	* configure: Regenerated.

2001-02-26  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSConcreteNumber.m (NumberTemplate): added precision to float
	and double TYPE_FORMAT.

2001-02-25  Adam Fedor  <fedor@gnu.org>

	* configure.in (cppflags_temp): Corrected to save CPPFLAGS not
	CFLAGS>

2001-02-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSLocale.m: Removed YESSTR and NOSTR support for simplicity.

2001-02-24  Nicola Pero  <n.pero@mi.flashnet.it>

	* Resources/Languages/French: New file (contributed by Frederic De
	Jaeger).
	* Resources/GNUmakefile (LANGUAGES): Added French.

2001-02-23  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gdomap.c: Fixed bug in handling '-a' option and enhanced
	to support multicast probing of networks specified in '-a' file.

2001-02-22  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/base/NSBundle.h: Added three new localization
	macros: _(), __() and NSLocalizedStaticString ().
	
2001-02-22  Nicola Pero  <n.pero@mi.flashnet.it>

	* Resources/Languages/Italian: New file.
	* Resources/GNUmakefile (LANGUAGES): Added Italian.
	
2001-02-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Fixes to prevent problems obtaining
	languages array due to attempts to use partially constructed
	standard user defaults object.

2001-02-21  Adam Fedor  <fedor@gnu.org>

	* Documenation/install.texi: Update.
	* Documenation/news.texi: Likewise.
	* INSTALL, NEWS: Regen.

2001-02-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Fix memory leak reported by thoran@free.fr
	parsePlItem()

2001-02-17  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/GNUmakefile (PACKAGE_NAME): Fixed typo - was gnutep-base
	rather than gnustep-base.

2001-02-20  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/GSXML.m|.h ([GSXMLAttribute -ns]): get attribute namespace.

2001-02-19  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSLocale.m: Tidy, defined __USE_GNU to get YESSTR and NOSTR
	on later versions of glibc.
	* Source/NSString.m: Log more info when parsing a property list fails.

2001-02-13  Adam Fedor  <fedor@gnu.org>

	* Version: 0.9.1

	* configure.in: Fix test for stdint.h

2001-02-11  Manuel Guesdon <mguesdon@orange-concept.com>

	* GSXML.m: testing lib!=NULL and string!=NULL before doing something in 
                -GSXMLNode content
                -GSXMLNode name
                -GSXMLNode ns
                -GSXMLNode nsDef
	* NSString.m: handle NULL bytes in -initWithUTF8String:
	(Treat it as zero length string and NSDebugMLog a warning).

2001-02-09  Jonathan Gapen  <jagapen@home.com>

	More FreeBSD build fixes:
	* acconfig.h: Add recent definitions.
	* configure.in: Add test for wchar.h header.
	* configure: Regenerate.
	* Headers/gnustep/base/config.h.in: Regenerate.
	* Source/GSFormat.m: Typedef wint_t if wchar.h not available.
	* Source/NSTask.m: Change #if TIOCNOTTY to #ifdef TIOCNOTTY.

2001-02-08  Nicola Pero  <n.pero@mi.flashnet.it>

	* INSTALL: Updated installation instructions.

2001-02-08  Richard Frith-Macdonald <rfm@gnu.org>

	Fixes reported by David Wetzel ...
	* Source/GSFormat.h: Add header for wchar
	* Source/NSCoder.m: Remove spurious semicolon
	* Source/dynamic-load.h: correct argument to dlsym()

2001-02-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: permit nil string when replacing characters
	in range.  Treat as an empty string rather than raising exception.

2001-02-07  Jonathan Gapen  <jagapen@home.com>

	* Source/NSFileManager.m: Make disk space report work on FreeBSD.
	On all Unix platforms, report disk space available to non-root users.

2001-02-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFormat.m: merged in some more fixes by Kai.

2001-02-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSFormat.m: Fixed error in PAD() macro - it was failing to
	decrement a counter - and looping forever.
	Fixed error in formatted output of string arguments ... was
	crashing with range exception.

2001-02-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSTask.m: Added gnustep specific feature to run task in
	pseudo terminal.

2001-02-02  Richard Frith-Macdonald <rfm@gnu.org>

	Integrated patch for unicode support for ([-initWithFormat:]) by
	Kai Henningsen.  Modified to support efficient append with format
	to a unicode string.
	* configure.in: Test for data type used by GSFormat
	* Headers/gnustep/base/GSFormat.h: file declaring GSFormat info.
	* Source/GSFormat.m: Source for format support.
	* Source/NSString.m: Use GSFormat() to implement ([-initWithFormat:])
	* Source/GSString.m: use GSFormat() to implement ([-appendFormat:])

2001-01-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDate.m: pass dates over DO bycopy unless explicitly byref.
	* Source/NSTimeZone.m: pass time zones over DO bycopy unless
	explicitly byref.
	Use placeholder class for newly created objects - to improve
	eficiency of selection of classes in cluster.
	Updated to use MacOS-X initialisation methods.

2001-01-30  Michael Hanni  <mhanni@sprintmail.com>

	* Source/.cvsignore: tweaked to cover a few more items.
	* Makefile.postamble: distclean removes created file: base.make.
	* configure.in: patched to fix bug in libxml detection macro
	(reviewed by: Nicola Pero <nicola@brainstorm.co.uk>)
	* configure: Regenerated.

2001-01-30  Nicola Pero  <nicola@brainstorm.co.uk>

	* gnustep-base.script.spec.in: Fixed, tidied.
	* configure.in (CPPFLAGS): Added -I$GNUSTEP_HDIR so that custom
	libobjc headers are used - this should fix ffcall detection.
	* configure: Regenerated.
	
2001-01-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSDate.h: Partial support added for MacOS-X
	* Source/NSTimeZone.m: Updates to encode all time zones as the
	abstract class, and added MacOS-X methods.
	* Source/NSCalendarDate.m: Use NSTimeZone rather than NSTimeZoneDetail
	throughout ... provide MacOS-X compatibility.
	* Source/NSDate.m: Fix milliseconds error creating date on MINGW

2001-01-29  Adam Fedor  <fedor@gnu.org>

	* configure.in: Remove check for alternate libobjc and Headers
	include. Fix typo in setting cppflags_temp in GMP test.
	* Source/Makefile.preamble (ADDITIONAL_INSTALL_DIRS): Don't
	make .../gnustep/Foundation
	* Source/Makefile.postamble (after-install): Don't install headers
	in .../gnustep/Foundation

2001-01-29  Nicola Pero  <nicola@brainstorm.co.uk>

	* GNUmakefile: Include local base.make.
	* Admin/GNUmakefile: Idem.
	* Documentation/GNUmakefile: Idem.
	* Documentation/gsdoc/GNUmakefile: Idem.
	* Examples/GNUmakefile: Idem.
	* NSCharacterSets/GNUmakefile: Idem. 
	* NSTimeZones/GNUmakefile: Idem.
	* Testing/GNUmakefile: Idem.
	* Tools/GNUmakefile: Idem.
	* Resources/GNUmakefile: Idem.
	* Source/GNUmakefile: Idem.
	* configure.in (tests for ffi): set CONFIG_SYSTEM_LIBS too
	(test for iconv): test taken from the make package.  (AC_OUTPUT):
	Generate base.make.
	* configure: Regenerated.
	* base.make.in: New file.
	* Makefile.postamble (before-install): Install base.make.
	
2001-01-29  Nicola Pero  <nicola@brainstorm.co.uk>

	* NSTimeZones/NSTimeZones.tar: Updated.

2001-01-28  Jonathan Gapen  <jagapen@home.com>

	* Source/NSUser.m: In NSSearchPathForDirectoriesInDomains(), added
        support for NSDeveloperDirectory, NSAdminDirectory, and the new
        GSLibrariesDirectory.
	* Headers/gnustep/base/NSPathUtilities.h: Added new enum value
        GSLibrariesDirectory, to support GNUstep's Libraries dir.

2001-01-26  Adam Fedor  <fedor@gnu.org>

	* gnustep-base.script.spec.in: New file, rpm script for installing 
	gdomap, updating ld.conf, etc.

2001-01-26  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSArray.m: Fix failure to assign result of init to self
	(similar fixes in various other files).
	* Tools/gsdoc.m: Fix error in parsing items containing mixed elements.
	* Documentation/gsdoc/NSTimeZone.gsdoc: Fix erro in markup.

2001-01-25  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.in: Add check for rexcent versions of gmp

2001-01-25  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSException.m: Modify default handler to permit simple
	exit as well as abort.
	* Documentation/gsdoc/Base.gsdoc: documented environmnet variable
	CRASH_ON_ABORT

2001-01-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Fixes for OPENSTEP compatibility in string path
	operations - patch provided by Pierre-Yves Rivaille, plus another fix
	by me.

2001-01-19  Nicola Pero  <nicola@brainstorm.co.uk>

	* gnustep-base.spec.in: Updated copyright and attempt at improving
	description.

2001-01-19  Nicola Pero  <nicola@brainstorm.co.uk>

	* config/config.loadtest.m: Added dummy NXConstStr implementation 
	for libobjc which do not include it. 
	* configure.in: Simplified check for thread flags.  gnustep-make
	already gets them - simply get them from config.make here.
	* configure: Regenerated.
	* config/config_thread.m: Removed.
	
2001-01-17  Adam Fedor  <fedor@gnu.org>

	* Version: Prerelease version 0.9.0
	* configure.in: Change check for installed libobjc to match gstep-make

2001-01-18  Nicola Pero  <nicola@brainstorm.co.uk>

	* Source/GNUmakefile: Simplified name to gnustep-base.
	* gnustep-base.spec.in: Changed Group to Development/Libraries.
	* gnustep-base-debug.spec.in: Idem.
	* NSTimeZones/NSTimeZones.tar: Removed hard links to avoid rpm
	problems with hard links.

2001-01-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSHost.m: New method ([-_addName:]) to add a name to a host.
	Use it to add the local hostname to the 127.0.0.1 host if there is
	no IP address set up for the local machine.
	* Source/NSRunLoop.m: ([-acceptInputForMode:beforeDate:]) improve
	handling of available descriptors - each descriptor may be available
	for more than one type of event.

2001-01-17  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/GSXML.m|.h ([GSXMLDocument -stringValue]): dump document in a
 	string.

Wed Jan 17 16:46:09 2001  Nicola Pero  <nicola@brainstorm.co.uk>

	* GNUmakefile: Added PACKAGE_NEEDS_CONFIGURE and
	RPM_DISABLE_RELOCATABLE.
	* GNUmakefile: Simplified name to gnustep-base.
	* gnustep-base.spec.in: New file.
	* gnustep-base-debug.spec.in: Idem.
	* gnustep-base.spec: Move to gnustep-base.spec.old.

2001-01-13  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSMime.m: ([-decodeData:fromrange:intoData:withContext:])
	Added destination data cpacity information to context so that
	correct positioning can be maintained over a sequence of calls
	using a chunked http context.
	* Source/GSAttributedString.m: Fixed bug initialising from an
	empty attributed string, and fixed bug replacing characters in
	range, when an attribute range location is the same s the location
	of the replaced characters.
 
2001-01-12  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSXML.m: ([-GSXMLDocument setRoot:]) set root node to be
	owned by libxml, so we don't free it's memory ourselves.
	* Headers/gnustep/base/NSValue.h: Added range methods.
	* Source/GNUmakefile: Rename value files to GS prefix and remove
	concrete value header.
	* Source/Makefile.postamble: Build GS value files. rather than NS
	* Source/NSValue.m: Added range methods and updated for change to
	naming conventions.  Added abstract placeholder class.  Fixed encoding
	to store the abstract class in the archive.
	* Testing/values.m: Added range check
	* Source/GSTemplateValue.m: Renamed for consistency.
	Adapted encoding/decoding for storing abstract class in archive.
	* Source/GSValue.m: ditto
	* Headers/gnustep/base/NSConcreteValue.h: private info removed
	* Source/NSCTemplateValue.m: Renamed for consistency
	* Source/NSConcreteValue.m: ditto

2001-01-10 Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/GSAttributedString.m ([GSAttributedString -length]),
	([GSMutableAttributedString -length]): Added for speed.

2001-01-10  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Fix bug in checking possible default string
	encodings . reported by Stefan Urbanek

2001-01-10  Richard Frith-Macdonald <rfm@gnu.org>

	Tidyup by removing 'NonCore' categories.

2001-01-09  Richard Frith-Macdonald <rfm@gnu.org>

	General tidyups to simplify code and to make class names
	consistent with the other libraries.
	* Headers/Foundation/NSGAttributedString.h: removed
	* Source/NSGAttributedString.m: renamed to GSAttributedString.m
	concrete classes renamed for consistency with other gstep libs.
	* Source/NSGDictionary.m: renamed to GSDictionary.m
	concrete classes renamed for consistency with other gstep libs.
	* Source/NSAttributedString.m: classes renamed
	* Source/NSDictionary.m: classes renamed
	* Source/GNUmakefile: replace NSGAttrinbutedString with and
	NSGDictionary with GS prefixed classes.
	Don't try to install old header.
	* Source/NSString.m: updates for class renaming.
	* Source/NSSerializer.m: ditto

2001-01-08  Adam Fedor  <fedor@gnu.org>

	* configure.in: Enable ffcall by default (unless the libraries
	don't exist).

2001-01-08  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/NSGArray.h: removed
	* Headers/Foundation/NSArray.h: merge core/non-core classes.
	* Source/GNUmakefile: replace NSGArray with GSArray.
	* Source/NSGArray.m: converted to GSArray.m
	* Source/NSArray.m: simplified by merging core/non-core classes.
	Use placeholder class when allocating constant arrays.
	* Source/GSArray.m: simplified version of GSArray.m
	Added GSPlaceholderArray.
	* Source/NSSerializer.m: use GSInlineArray where possible.
	* Source/GSSet.m: Provide decoding of NSGSet for backward compatibility.
	* Source/NSException.m: Avoid recursion in exception handler.

2001-01-04  Richard Frith-Macdonald <rfm@gnu.org>

	* Tools/gsdoc.gsdoc: Tidied and fixed a few typos/spelling errors.

2001-01-04  Jonathan Gapen  <jagapen@home.com>

	* configure.in, aclocal.m4, acconfig.h: Replace libxml detection with
	autoconf macro from libxml 2.2.10 installation.
	* configure, Headers/gnustep/base/config.h.in: Regenerate.
	* Headers/gnustep/base/GSXML.h, base/Source/GSXML.m,
	base/Tools/gsdoc.m: Use proper libxml #includes.

2001-01-03  Adam Fedor  <fedor@gnu.org>

	* configure.in: Change test for objc forwarding hook to match gcc
	patch.
	* Source/GSFFCallInvocation.m: Use new forwarding hook.

2001-01-03  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: fix for checking windows executable file
	extensions - reported by michael.scheibler@onevision.de

2001-01-03  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSObjCRuntime.m (GSInstanceVariableInfo): fixes.
	* Source/NSObject.m ([NSObject -handleQueryWithUnboundKey:]): raise an
	exception.
	([NSObject -handleTakeValue:forUnboundKey:]): changed exception.
	([NSObject -unableToSetNilForKey:]): likewise.
	([NSObject -storedValueForKey:]),
	([NSObject -valueForKey:]): check for null selector before calling
	respondsToSelector:
	([NSObject -takeStoredValue:forKey:]),
	([NSObject -takeValue:forKey:]): likewise. Call GSSetValue with correct
	values.
	(GSSetValue): fixed ivar implementation.
	(GSGetValue): likewise.
	([NSObject -methodSignatureForSelector:]): FreeBSD fix.
	* Source/NSEnumerator.m|.h ([NSEnumerator -allObjects]): implemented.
	* Source/Unicode.m (GetDefEncoding): do not emit the warning for
	NSISOLatin1StringEncoding.

2000-12-26  Adam Fedor  <fedor@gnu.org>

	* configure.in: Look for libxml2 (patch from Kim Shrier
	<kim@tinker.com>).
	* acconfig.h: Define LIBXML2
	* Headers/gnustep/base/config.h.in: Regenerate
	* Headers/gnustep/base/GSXML.h: Include libxml2.h if found.
	* Source/GSXML.m: Likewise.
	* Tools/gsdoc.m: Likewise. (patches from Kim Shrier <kim@tinker.com>).

2000-12-22  Adam Fedor  <fedor@gnu.org>

	* Source/GSFFCallInvocation.m: Remove powerpc specific defs

2000-12-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDistantObject.m: Modified DO_FORWARD_INVOCATION() macro
	and its uses so that they actually do what was intended :-)
	Also, modified implementation of methodSignatureForSelector: for
	ffcall library to prevent recursion.

2000-12-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/GSIMap.h: On initialisation set number of nodes
	to exactly equal capacity, for improved memory efficiency.
	* Source/Makefile.postamble: correct dependencies for GSIMap.
	* Source/GSCountedSet.m: Use map enumerator rather than messing with
	the internals of a GSIMap directly.
	* Source/GSSet.m: ditto
	* Source/NSConnection.m: ditto
	* Source/NSGDictionary.m: ditto
	* Source/NSNotificationCenter.m: ditto
	* Source/NSString.m: property list memory leak fixed.

2000-12-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSGAttributedString.m: Fix logic errors setting attributes.

2000-12-18  Adam Fedor  <fedor@gnu.org>

	* Source/Makefile.postamble (libgnustep.def): Rebuild manually
	rather than automatically.

2000-12-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/Unicode.m: Tidied to conform to coding standards and changed
	to use ISOLatin1 as the default cString encoding.
	* Source/GSString.m: Fixed bug getting cString from unicode string -
	raise exception when it should.
	* Source/NSString.m: ditto.  Also use lossyCString in various
	places rather than cString.
 
2000-12-13  Nicola Pero  <n.pero@mi.flashnet.it>

	* Headers/gnustep/base/NSRange.h, Source/NSRange.m: Inlined 
	NSMakeRange.

2000-12-12  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSDebug.m (table_entry): Added peak field.
	(GSDebugAllocationAdd): Set peak counter if needed.
	(GSDebugAllocationClassList), (GSDebugAllocationTotal),
	(GSDebugAllocationPeak): New functions.
	* Headers/gnustep/base/NSDebug.h: Added corresponding
	declarations.

2000-12-08  Adam Fedor  <fedor@gnu.org>

	* Set up DO and NSInvocation to use foreign-function interface
	library.
	* configure.in: Add check for --enable-ffcall
	* Documentation/gnustep-base.texi: Update
	* Documentation/install.texi: Likewise.
	* Documentation/readme.texi: Likewise.
	* Documentation/gsdoc/NSTimeZone.gsdoc: Update.

	* Headers/gnustep/base/NSConnection.h: New forward method.
	* Headers/gnustep/base/NSInvocation.h: New frame ivar.
	* Source/GNUmakefile: Conditionally compile in FFI classes if
	enabled.
	* Source/NSConnection.m (-forwardInvocation:forProxy:): New method.
	(_service_forwardForProxy:): For FFCALL don't autorelease memory,
	call proper forwarding function.
	* Source/NSDistantObject.m (forwardInvocation:): Implement.
	(methodSignatureForSelector:): For FFCALL, forward through
	invocation.
	(conformsToProtocol:): Likewise.
	(respondsToSelector:): Likewise.
	* Source/NSInvocation.m: Convert to abstract class with subclasses
	based on FFI interface.
	(_get_arg, _set_arg, _arg_addr): New functions based on FFI interface.
	(+allocWithZone:): Alloc proper concrete class.
	(+initialize): Set proper concrete class.
	(-initWithCoder:): Replace self with proper concrete class.
	(initWithArgframe:selector:): Make subclassResponsibility.
	(initWithMethodSignature:): Likewise.
	(returnFrame:): Likewise.
	Implement GSFrameInvocation
	* Source/GSFFCallInvocation: New file.
	* Source/GSFFIInvocation: Likewise.
	* Source/cifframe.[hm]: Likewise.
	* Source/callframe.[hm]: Likewise.

2000-12-07  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSGSet.m: renamed to GSSet.m for consistency, tidied.
	* Source/NSGCountedSet.m: renamed to GSCountedSet.m for consistency.
	* Headers/Foundation/NSGSet.h: removed - obsolete.
	* Headers/Foundation/NSSet.h: si9mplified back to single class
	* Source/NSSet.m: Updated and tidied.  Fixed coding class for
	mutable sets. Removed non-core classes.

2000-12-05  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLHandle.m: minor mods to background loading.
	* Source/GNUmakefile:
	* Source/Makefile.postamble:
	* Source/Makefile.preamble:
	* Tools/Makefile.preamble:
	Updated for flattened directory structure.

2000-12-02  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSDate.m: GSTime() added millisecond info.
	* Source/NSCalendarDate.m: GSTime() added millisecond info.
	* Headers/Foundation/NSDate.h: GSTime() added millisecond info.
	* Source/NSObject.m: key-value-coding restructured and
	implemented for non-object values.

2000-11-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m: ([-initWithString:calendarFormat:locale:])
	Bugfixes to fill in missing information using current date/time and
	to implement missing format codes.

2000-11-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSClassDescription.m: New MacOS-X class added.
	* Headers/Foundation/NSClassDescription.m: New MacOS-X class added.
	* Headers/Foundation/NSKeyvalueCoding.m: New MacOS-X protocol added.
	* Source/NSObject.m: New MacOS-X key value coding methods added.
	Only objects currently supported - needs work to support scalar
	types too!

2000-11-23  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSBundle.m ([NSBundle +_addFrameworkFromClass:]): fixed an
	autorelease problem. (reported by Gerald Siebke <gerald@turbocat.de>)

2000-11-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpPort.m: ([-connectToPort:beforeDate:]) added locking to
	prevent possible problems with two threads trying to get root object
	of a new connection at the same time.
	* Documentation/gsdoc/NSURLHandle.gsdoc: Added subclass information.

2000-11-22  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSAutoreleasePool.h: Changed proivate method
	for cleanup at end of thread.
	* Headers/gnustep/base/NSThead.h: New ivar to mark when we are
	deallocating.
	* Source/NSAutoreleasePool.m: Added parameter to _endThread so we
	can safely end a thread without it being the current one.
	* Source/NSThread.m: Now clean up autorelease pools *after*
	everything elese, while deallocating the thread.  This is to cope
	with objects that try to access the thread dictionary while
	autoreleasing. -threadDictionary modified to return nil during
	deallocation rather than creating a new ductionary.

2000-11-21  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/externs.m: Removed obsolete http body key.
	* Source/GSHTTPURLHandle.m: Removed obsolete http body key.
	* Headers/Foundation/NSURLHandle.h: Removed obsolete http body key.

2000-11-20  Nicola Pero  <n.pero@mi.flashnet.it>

	* Source/NSConnection.m: ([NSConnection -invalidate]) Fixed typo in
	multi-thread support.

2000-11-18  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLHandle.m: Implemented setting and gettign of properties
	for file handles using NSFileManager.
	* Source/GSHTTPURLHandle.m: Implemented ([-writeData:]).  Rewrote
	posting mechanism using new implementation.  Modified so that old
	method of writing bodyn properties still works for the moment.
	* configure.in: Added tests for GMP library - needed in future.
	* Headers/Foundation/NSDecimal.h: include GSConfig.h for HAVE_GMP
	* Source/NSDecimal.m: test for truth value of HAVE_GMP
	* Headers/Foundation/GSConfig.h.in: add HAVE_GMP support, but
	override to '0' until GMP support is fully implemented.

2000-11-17  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/Foundation/GSMime.h: Added GSMimeEncodingContext etc
	* Headers/Foundation/NSURLHandle.h: Added some more property keys.
	* Source/GSMime.m: Update to add method for general decoding of
	different transfer encoding types including chunked (for http1.1).
	Recognise end of data in chunked encoding or by content length.
	* Source/GSHTTPURLHandle.m: Added new class for http and https support.
	* Source/NSURLHandle.m: Register class for http and https support.
	* Source/externs.m: Added property keys for URL handles.
	* Documentation/gsdoc/GSMime.gsdoc: updated
	* Documentation/gsdoc/GSMimeDocument.gsdoc: updated
	* Documentation/gsdoc/GSMimeParser.gsdoc: updated

2000-11-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: ([-userLanguages]) updated to ensure we
	don't get empty strings in the language list.
	* Headers/Foundation/GSMime.h: Revised API
	* Source/GSMime.m: Revised API to make more sense
	* Documentation/gsdoc/GSMime.gsdoc: ditto
	* Documentation/gsdoc/GSMimeDocument.gsdoc: ditto
	* Documentation/gsdoc/GSMimeParser.gsdoc: ditto

2000-11-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURL.m:  ([-explode]) bugfix for parsing username/password
	provided by mark@brainstorm.co.uk

2000-11-16  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpPort.m: Altered all GSTcpHandle debug output to include
	current thread.  Added locking for read/write operations on handle.
	Hopefully all thread-safe now :-)

2000-11-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSConnection.m: ([-_getReplyRmc:]) added semi-busy wait
	for when the connection is being used from multiple threads.

2000-11-15  Richard Frith-Macdonald <rfm@gnu.org>

	* configure.in: Added checks for OpenSSL
	* Headers/gnustep/base/NSFileHandle.h: Added info for SSL handles.
	* Source/UnixFileHandle.m: Added GSUnixSSLHandle class based on
	code by <mark@brainstorm.co.uk>

2000-11-15  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSBundle.m: Minor tidying to avoid compiler warnings.
	* Source/NSFileManager.m: ditto

Tue Nov 14 23:44:14 2000  Adam Fedor  <fedor@yogi.doc.com>

	* Source/GSString.m: Add limits.h (for Solaris)

2000-11-14  Adam Fedor  <fedor@gnu.org>

	* Source/GSLocale.m: Put LANGINFO_H ifdefs around include of
	langinfo.h.

2000-11-14  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpPort.m: ([GSTcpHandle -receivedEvent:type:extra:forMode:])
	added locks around write operations for multi-threaded operation.
	newDataWithEncodedPort() modified to encode local host as an empty
	string, and other hosts by name rather than address.
	decodePort() added new parameter so that an empty string can be
	decoded as the host to which the GSTcpHandle is talking.
	Modified in various places to keep a record of the IP address of the
	remote end of the connection, so we can pass this to decodePort()
	([-getFds:count:]) fixed error in determining set of file descriptors
	to listen to - resulted in two threads listening to the same descriptor
	at the same time!

2000-11-13  Richard Frith-Macdonald <rfm@gnu.org>

        * Source/NSGAttributedString.m: partial rewrite to cache/unique
	dictionaries and to coalesce adjacent regions of string with the
	same attributes when setting attributes.

2000-11-12  Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSArray.m: Corrected [NSMutableArray arrayWithObject:] to
	return obj instead of self.
	
Fri Nov 10 12:30:27 2000  Nicola Pero  <n.pero@mi.flashnet.it>

	Added some GNUstep extensions to NSThread to allow JIGS to
	transparently map java threads to gnustep threads (and vice
	versa):
	* Headers/gnustep/base/NSThread.h, Source/externs.m:
	(NSThreadDidStartNotification): New notification.
	* Source/NSThread.m ([NSThread -_sendThreadMethod]): Post 
	the NSThreadDidStartNotification.	
	* Source/NSThread.m, Headers/gnustep/base/NSThread.h
	([+registerCurrentThread]), ([+unregisterCurrentThread]): New
	methods.

2000-11-10  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSBundle.m ([NSBundle +_addFrameworkFromClass:]): avoid crash
	when called with Nil class.

2000-11-10 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSTcpPort.m: Added some locking tweaks for writing data.
	* Source/GSString.m: Fix for decoding obsolete string classes.

2000-11-09 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSPort.m: ([-setDelegate:]) corrected assertion to allow
	delegate to be set to nil.  Bug reported by cornils@mail.desy.de

2000-11-08 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: ([GSMutableString substringWithRange:]) fix to
	initialize inline string classes correctly.

2000-11-06  Adam Fedor  <fedor@gnu.org>

	* Documentation: Move tmpl.texi files to texi and update GNUmakefile

Mon Nov  6 16:55:26 2000  Nicola Pero  <n.pero@mi.flashnet.it>

	* Documentation/GNUmakefile: Install ANNOUNCE, NEWS, INSTALL,
	BUGS, README, STATUS into
	Documentation/Developer/Base/ReleaseNotes/$(VERSION); install
	CODING-STANDARDS and coding-standards into
	Documentation/Developer/CodingStandards; install gnustep-base into
	Documentation/Developer/Base/Manual.
	* Documentation/gsdoc/GNUmakefile
	(Base_DOCUMENTATION_INSTALL_DIR): Install gsdoc reference in
	Documentation/Developer/Base/Reference.

2000-11-06 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: handle_printf_atsign() - use lossyCString to
	get string to print.  This is a temporary *HACK* - we need a proper
	unicode supporting initWithFormat:
	* Source/GSString.m: ([GSMutableString substringWithRange:]) fix to
	allocate inline string classes for substrings.

2000-11-04 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSCalendarDate.m ([NSCalendarDate -initWithString:
	calendarFormat:locale:]): try getting timezone by name before
	attempting by abbreviation - thus preserving exact name isf possible.

2000-11-03  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Source/NSCalendarDate.m ([NSCalendarDate -initWithString:
	calendarFormat:locale:]): assign calendar format.

2000-11-03 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Update for placeholder class.
	* Source/GSString.m: Updates for optimisations using placeholder class.

2000-11-01 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSXML.m: External entity loader revisions completed.
	* Documentation/gsdoc/GSXML.gsdoc: changes to api
	* Documentation/gsdoc/GSXMLParser.gsdoc: ditto
	* Documentation/gsdoc/GSSAXHandler.gsdoc: ditto

2000-11-01  Manuel Guesdon <mguesdon@orange-concept.com>
	* Headers/Foundation/GSXML.h: added GSXMLNode 
		propertiesAsDictionaryWithKeyTransformationSel:
	* Source/GSXML.m: added GSXMLNode 
		propertiesAsDictionaryWithKeyTransformationSel:

2000-11-01 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSUserDefaults.m: Fixed uninitialised variable bug.
	* Source/NSString.m: Fixed error in xml property list parsing
	* Source/GSXML.m: Various SAX things to use default implementation.

2000-10-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSString.m: Implemented
	([-initWithCharactersNoCopy:length:freeWhenDone:]) and
	([-initWithCStringNoCopy:length:freeWhenDone:]) for NSMutableString.
	([-initWithCStringNoCopy:length:freeWhenDone:]) for NSString.

2000-10-31  Richard Frith-Macdonald <rfm@gnu.org>

	Loads of files modified, fast.x removed.
	Found it unexpectedly easy to tidy up so that all functions for
	accessing the runtime are now in NSObjCRuntime.h.
	Now all :-) we need are Apple runtime implementations, configuration
	auto-detect for the apple runtime, and loads of updating of any
	bits of code that call the runtime directly.

2000-10-31  Richard Frith-Macdonald <rfm@gnu.org>

	* Headers/gnustep/base/NSGString.h:
	* Headers/gnustep/base/NSGCString.h:
	* Source/NSGString.m:
	* Source/NSGCString.m: Removed classes - no longer used.
	* Headers/gnustep/base/NSObjCRuntime.h:
	* Headers/gnustep/base/fast.x:
	* Source/GSString.m:
	* Source/Makefile.postamble:
	* Source/NSArchiver.m:
	* Source/NSCTemplateValue.m:
	* Source/NSConcreteValue.m:
	* Source/NSCountedSet.m:
	* Source/NSDate.m:
	* Source/NSDictionary.m:
	* Source/NSDistantObject.m:
	* Source/NSGSet.m:
	* Source/NSNumber.m:
	* Source/NSObject.m:
	* Source/NSScanner.m:
	* Source/NSSerializer.m:
	* Source/NSSet.m:
	* Source/NSUnarchiver.m:
	Changed calls to 'fastClass()' to use 'GSObjCClassOfObject()' and
	added that to NSObjCRuntime.h.  Removed central class and
	implementation caching from NSObject.m and fast.x since it was not
	being effectively used.  New intention to do removal of fast.x and
	add similar functionality to NSObjCRuntime.h - intention being to
	combine functionality of fast access to the runtime, and hiding both
	GNU and Apple runtime behind a single interface.

2000-10-30  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLHandle.m: Wrap all locking with exception handlers to
	ensure that locks are released.
	* Headers/gnustep/base/NSInvocation.h: Removed non-standard macros
	* Headers/gnustep/base/behavior.h: Removed unused macro
	CALL_METHOD_IN_CLASS()
	* Source/GSString.m:
	* Source/GSXML.m:
	* Source/NSArchiver.m:
	* Source/NSArray.m:
	* Source/NSAttributedString.m:
	* Source/NSData.m:
	* Source/NSDictionary.m:
	* Source/NSGArray.m:
	* Source/NSGAttributedString.m:
	* Source/NSGCString.m:
	* Source/NSGDictionary.m:
	* Source/NSGeometry.m:
	* Source/NSObject.m:
	* Source/NSPortCoder.m:
	* Source/NSProcessInfo.m:
	* Source/NSRange.m:
	* Source/NSRunLoop.m:
	* Source/NSScanner.m:
	* Source/NSSerializer.m:
	* Source/NSString.m:
	* Source/NSUnarchiver.m:
	* Source/NSUserDefaults.m:
	Updated to move static SEL variable initialisation to +initialize
	methods so that it should (I think) work with the Apple runtime.

2000-10-29  Adam Fedor  <fedor@gnu.org>

	* configure.in: Check for langinfo.
	* Source/GSLocale.m (GSDomainFromDefaultLocale): Return nil
	dict if langinfo info not available.

	* acconfig.h: Add HAVE_DLADDR
	* Headers/gnustep/base/config.h.in: Regenerate.
	* Source/simple-load.h (__objc_dynamic_get_symbol_path): Return
	nil if not HAVE_DLADDR.

2000-10-29  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/GSString.m: New inline string classes added to avoid calls
	to malloc in some cases.  Changed all deallocation methods to call
	NSDeallocateObject() directy for efficiency.
	* Source/NSString.m: Use new inline string classes for creation of
	strings where we know the length of the data in advaance.

2000-10-28  Mirko Viviani  <mirko.viviani@rccr.cremona.it>

	* Headers/gnustep/base/NSBundle.h: added ivar.
	* Source/NSBundle.m ([NSBundle +_addFrameworkFromClass:]): new private
	method to parse NSFramework_* classes.
	(_bundle_load_callback): added framework support. Wrap classes in a
	NSValue to avoid implicit initialization.
	([NSBundle +allBundles]): added framework support.
	([NSBundle +allFrameworks]): implemented.
	([NSBundle +bundleForClass:]): get classes from NSValue object.
	([NSBundle -classNamed:]): likewise.

	* Headers/gnustep/base/objc-load.h (LINKER_GETSYMBOL): new define.
	* Source/objc-load.m (objc_get_symbol_path): get lib path of a Class
	or Category.
	* Source/simple-load.h (__objc_dynamic_get_symbol_path): indentifies
	lib path of a symbol.
	* Source/dld-load.h (__objc_dynamic_get_symbol_path): not supported.
	* Source/hpux-load.h (__objc_dynamic_get_symbol_path): not implemented.

	* Source/mframe/mframe.foot (mframe_get_arg): typ declaration fix.
	(mframe_set_arg): idem

	* Headers/gnustep/base/config.h.in: added HAVE_DLADDR
	* aclocal.m4 (OBJC_SYS_DYNAMIC_LINKER): test for dladdr()
	* configure.in: added --with-libxml-include and --with-libxml-library,
	added -I/usr/local/include and -L/usr/local/lib for FreeBSD.

2000-10-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSObject.m: Reverted last change -
        +new has to do alloc, init or break classes that expect to use their
	own allocation mechanisms.  Similarly, +alloc must call the
	([+allocWithZone:]) method.  We can't make optimisations that
	break with the OpenStep spec and MacOS documentation - they would
	break production code.  Of course, private classes can do this.

2000-10-27  Lyndon Tremblay  <humasect@home.com>

	* Source/NSObject.m ([NSObject +new]): No longer sends 2 messages,
	uses NSAllocateObject().
	([NSObject +alloc]): Likewise, no message sending within the method.

2000-10-27  Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSURLHandle.m: Make class registration thread safe.
	Tidy initialisation to use designated initialiser.

2000-10-27  Adam Fedor  <fedor@gnu.org>

	* Added localization support
	* configure.in: Look for locale.h
	* Resources: New directory, files for languages.
	* Headers/gnustep/base/NSUserDefaults.h: Add missing localization
	keys.
